shr.defineClass("shr.compensation.IncomeTaxDeclareListEx", shr.compensation.IncomeTaxDeclareList, {
    initalizeDOM: function () {
        shr.compensation.IncomeTaxDeclareListEx.superClass.initalizeDOM.call(this);
        var _self = this;
    },
    /**
        * 个税申报按钮事件
        */
    taxDeclareAction: function () {
        var _self = this;
        // if (!_self.hasTaxImp) {
        //     shr.showError({
        //         message: '操作失败，需开通云服务后才能使用，请系统管理员前往【系统设置-云服务设置-云服务注册及连接】进行注册。'
        //         , hideAfter: 5
        //     });
        // } else {
        var selectedId = _self.getSelectedIds();
        if (!selectedId) {
            return;
        }
        var param = {};
        param.selectedId = selectedId;
        _self.remoteCall({
            type: "post",
            method: "taxDeclare",
            param: param,
            showBlock: true,
            success: function (res) {
                if (res.success) {
                    shr.showInfo({ message: res.info, hideAfter: 10 });
                } else {
                    if (res.hasErrData) {
                        if (res.hasCheckDataErr) {
                            shr.showWarning({ message: '以下员工数据异常，无法进行个税申报，请点击异常人员名单查看失败原因及操作指引。', hideAfter: 10 });
                            document.location.href = shr.getContextPath() + res.excel;
                        } else {
                            shr.showError({ message: res.errorMsg, hideAfter: 10 })
                        }
                    }
                    if (res.dataError) {
                        shr.showWarning({ message: res.errMsg, hideAfter: 10 });
                    }
                    if (res.issueError) {
                        _self.showConfirm(res.errMsg, function () {
                            _self.reloadPage({
                                uipk: "com.kingdee.shr.compensation.app.tax.IncomeTaxIssue.person.list"
                            });
                        }, function () {
                            _self.reloadPage({
                                uipk: "com.kingdee.shr.compensation.app.incomeTax.TaxPersonRecordEntry.list"
                            });
                        });
                    }
                    if (res.reductionError) {
                        shr.showWarning({ message: res.errMsg, hideAfter: 10 });
                    }
                }
                _self.queryGrid();
            }
        });
        // }
    },
    /**
    * 生成申报数据
    */
    generateTaxDataAction: function () {
        var _self = this;
        var html = [], buttons = [], $dialog = $("#generateDataDialog"), $body = $(document.body);
        if ($dialog.size() == 0) {
            $dialog = $("<div id='generateDataDialog' class='tiny-dialog'></div>").appendTo($body);
        }
        html = ['<div id="generateDataHtml">',
            '<div class="sync-row row-fluid">',
            '<div data-ctrlrole="labelContainer">',
            '<div class="col-lg-6 textLeft"><div class="field_label" title="' + '纳税单位名称' + '">' +
            '纳税单位名称' + '</div></div>',
            '<div class="col-lg-6 field-ctrl"><input id="taxUnitF7" class="taxUnitF7 input-height" validate="{required:true}"></input></div>',
            '</div>',
            '</div>',
            '<div class="sync-row row-fluid" style="margin-top:20px">',
            '<div data-ctrlrole="labelContainer">',
            '<div class="col-lg-6 textLeft"><div class="field_label"  title="' + '税款所属期（所得月份）' + '">' +
            '税款所属期（所得月份）' + '</div></div>',
            '<div class="col-lg-6 field-ctrl">',
            '<div><div class="ui-datepicker-layout"><div class="ui-datepicker-inputframe"><input id="yearMonthData" name="yearMonthData" class="block-father input-height" value="" validate="" placeholder="" type="text" dataextenal="" autocomplete="off" istotemplate="true" ctrlrole="datetimepicker"></div></div></div>',
            '</div>',
            '</div>',
            '</div>',
            '</div>'];
        var saveSettingButton = _self.getSaveSettingButton();
        buttons.push(saveSettingButton);
        showDialog("#generateDataDialog",
            '生成申报数据',
            html.join(""), buttons, 700, 320, '取消');
        var dateTimePicker_json = {};

        dateTimePicker_json.readonly = '';
        dateTimePicker_json.validate = '{required:true}';
        dateTimePicker_json.format = 'yyyy-mm';
        dateTimePicker_json.id = "yearMonthData";

        dateTimePicker_json.isRemoveDay = true;
        dateTimePicker_json.ctrlType = 'Date';

        $('#yearMonthData').shrDateTimePicker(dateTimePicker_json);
        var date = new Date();
        var dateStr = date.format('yyyy-MM');
        var dateArr = dateStr.split('-');
        if (parseInt(dateArr[1]) == 1) {
            dateStr = (parseInt(dateArr[0]) - 1) + "-12";
        } else {
            dateStr = dateArr[0] + "-" + (parseInt(dateArr[1]) - 1);
        }
        $('#yearMonthData').shrDateTimePicker('setValue', dateStr, 'yyyy-MM');
        var grid_f7_json = {
            id: "taxUnitF7",
            name: "taxUnitF7",
            subWidgetName: "shrPromptGrid",
            validate: "{required:true}",
            subWidgetOptions: {
                title: '选择纳税单位:',
                uipk: "com.kingdee.shr.compensation.app.tax.TaxDeclareTaxUnitF7",
                filter: '',
                multiselect: true,
                isInput: true,
            },
        };
        /**
         * 默认当前员工所有的纳税单位数据权限
         */
        $("#taxUnitF7").shrPromptBox(grid_f7_json);
        //		$("#taxUnitF7").shrPromptBox("option",{
        //			onchange:function(e,value) {
        //				var info = value.current;
        //				$.each(info, function(index, item){
        //					
        //				})
        //			}
        //		});
        shr.callHandler({
            handler: "com.kingdee.shr.compensation.web.handler.tax.TaxDeclareTaxUnitF7Handler",
            action: "getPersonAllPermTaxUnit",
            async: false,
            param: {},
            error: function (ret) {
                var message = ret.responseText;
                shr.showWarning({
                    message: message,
                    hideAfter: 5
                });
                return;
            },
            success: function (res) {
                // console.log(res);
                // $("#taxUnitF7").shrPromptBox("setValue", res);
            }
        });
    },









    // 更正申报
    updateDeclareAction: function () {
        var _self = this;
        //if (!_self.hasTaxImp) {
        //    shr.showError({
        //        message: '操作失败，需开通云服务后才能使用，请系统管理员前往【系统设置-云服务设置-云服务注册及连接】进行注册。'
        //        , hideAfter: 5
        //    });
        //    return;
        //}
        var selectedId = _self.getSelectedIds();
        if (!selectedId) {
            return;
        }
        if (selectedId.indexOf(",") > -1) {
            shr.showError({
                message: '请选择单条记录做更正申报。'
                , hideAfter: 5
            });
            return;
        }
        var canUpdate = true;// 是否能更正申报
        var param = {};
        param.selectedId = selectedId;
        // _self.remoteCall({
        //     type: "post",
        //     method: "beforeUpdateDeclare",
        //     param: param,
        //     async: false,
        //     showBlock: true,
        //     success: function (res) {
        //         if (res) {
        //             canUpdate = true;
        //         } else {
        //             //不成功
        //             canUpdate = false;
        //             shr.showError({message: res, hideAfter: 10})
        //         }
        //     }
        // });
        if (canUpdate) {
            var isEnableExcelPwd = $('#updateDeclare').attr('data-isenableexcelpwd');
            var callback = function (psw) {
                $.extend(param, {
                    //handler: "com.kingdee.shr.compensation.web.handler.tax.IncomeTaxDeclareListHandler",
                    handler: "com.kingdee.eas.custom.compensation.handler.IncomeTaxDeclareListHandlerEx",
                    method: "updateDeclare",
                    psw: psw,
                    isEnableExcelPwd: JSON.parse(isEnableExcelPwd)
                });
                shr.urlLocate(shr.getContextPath() + "/dynamic.do", param);
                shr.showWarning({
                    message: "已提交金税系统更正申报"
					_self.reloadGrid();
                });
            };

            if (_self.isNeedExportFilePassword('#updateDeclare')) {
                fieldSensitiveService.setExportPsw(callback);
            } else {
                callback();
            }
        }
    },

    // 撤销更正
    cancelUpdateAction: function () {
        var _self = this;
        //if (!_self.hasTaxImp) {
        //    shr.showError({
        //        message: '操作失败，需开通云服务后才能使用，请系统管理员前往【系统设置-云服务设置-云服务注册及连接】进行注册。'
        //        , hideAfter: 5
        //    });
        //    return;
        //}
        var selectedId = _self.getSelectedIds();
        if (!selectedId) {
            return;
        }
        if (selectedId.indexOf(",") > -1) {
            shr.showError({
                message: '请选择单条记录进行撤销更正。'
                , hideAfter: 5
            });
            return;
        }
        var canCancel = true;
        var param = {};
        param.selectedId = selectedId;
        // _self.remoteCall({
        //     type: "post",
        //     method: "beforeCancelUpdate",
        //     param: param,
        //     async: false,
        //     showBlock: true,
        //     success: function (res) {
        //         if (res) {
        //             canCancel = true;
        //         } else {
        //             //不成功
        //             canCancel = false;
        //             shr.showError({message: res, hideAfter: 10})
        //         }
        //     }
        // });
        if (canCancel) {
            _self.remoteCall({
                type: "post",
                method: "cancelUpdate",
                param: param,
                showBlock: true,
                success: function (res) {
                    shr.showWarning({
                        message: "已提交金税系统撤销更正"
						_self.reloadGrid();
                    });
                }
            });
        }
    },
    // 作废申报
    cancelDeclareAction: function () {
        var _self = this;
        //if (!_self.hasTaxImp) {
        //    shr.showError({
        //        message: '操作失败，需开通云服务后才能使用，请系统管理员前往【系统设置-云服务设置-云服务注册及连接】进行注册。'
        //        , hideAfter: 5
        //    });
        //    return;
        //}
        var selectedId = _self.getSelectedIds();
        if (!selectedId) {
            return;
        }
        if (selectedId.indexOf(",") > -1) {
            shr.showError({
                message: '请选择单条记录进行作废。'
                , hideAfter: 5
            });
            return;
        }
        var canCancel = true;
        var param = {};
        param.selectedId = selectedId;
        // _self.remoteCall({
        //     type: "post",
        //     method: "beforeCancelDeclare",
        //     param: param,
        //     async: false,
        //     showBlock: true,
        //     success: function (res) {
        //         if (res) {
        //             canCancel = true;
        //         } else {
        //             //不成功
        //             canCancel = false;
        //             shr.showError({message: res, hideAfter: 10})
        //         }
        //     }
        // });
        if (canCancel) {
            var isEnableExcelPwd = $('#cancelDeclare').attr('data-isenableexcelpwd');
            var callback = function (psw) {
                $.extend(param, {
                    //handler: "com.kingdee.shr.compensation.web.handler.tax.IncomeTaxDeclareListHandler",
                    handler: "com.kingdee.eas.custom.compensation.handler.IncomeTaxDeclareListHandlerEx",
                    method: "cancelDeclare",
                    psw: psw,
                    isEnableExcelPwd: JSON.parse(isEnableExcelPwd)
                });
                shr.urlLocate(shr.getContextPath() + "/dynamic.do", param);
                shr.showWarning({
                    message: "已提交金税系统作废申报，需要等待几分钟，可在任务执行监控中查看运行进度"
                });
            };

            if (_self.isNeedExportFilePassword('#cancelDeclare')) {
                fieldSensitiveService.setExportPsw(callback);
            } else {
                callback();
            }
        }
    },





    //任务监控
    taskMonitorAction: function () {
        var self = this;
        var urlParam = {
            uipk: "com.kingdee.eas.custom.shuiyou.task.app.Task.list",
            //uipk: "com.kingdee.shr.compensation.app.taxCal.TaxCalTask.list",
            catalog: "TAX"
        };
        self.reloadPage(urlParam);
    },





});