package com.kingdee.eas.custom.shuiyou.incomeTax;

import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.rabbitmq.guava.Lists;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.shuiyou.vo.SixTConfirmInfo;
import com.kingdee.eas.custom.shuiyou.vo.SixTPersonInfo;
import com.kingdee.eas.custom.shuiyou.task.TaskCatalogEnum;
import com.kingdee.eas.custom.shuiyou.uitls.ISYUtilsFacade;
import com.kingdee.eas.custom.shuiyou.uitls.SYUtilsFacadeFactory;
import com.kingdee.eas.custom.shuiyou.uitls.URLConfigEnum;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.shr.base.syssetting.app.filter.HRFilterUtils;
import com.kingdee.shr.compensation.app.tax.TaxUnitCollection;
import com.kingdee.shr.compensation.app.tax.TaxUnitFactory;
import com.kingdee.shr.compensation.app.tax.TaxUnitInfo;
import com.kingdee.shr.compensation.app.taxCal.*;
import com.kingdee.shr.compensation.util.Base64Utils;
import com.kingdee.shr.compensation.util.CmpDateUtil;
import com.kingdee.shr.compensation.util.CmpStrUtil;
import com.kingdee.shr.compensation.util.TaxReportUtil;
import com.kingdee.shr.compensation.util.lock.CmpDistributedLockUtils;
import org.apache.log4j.Logger;
import com.kingdee.bos.*;
import java.sql.Timestamp;
import java.util.*;
import java.lang.String;

public class TaxDirectDeductionExFacadeControllerBean extends AbstractTaxDirectDeductionExFacadeControllerBean
{
    private static Logger logger =
        Logger.getLogger("com.kingdee.eas.custom.shuiyou.incomeTax.TaxDirectDeductionExFacadeControllerBean");


    /**
     * ȡ˰λ鼯¼
     * @param collection
     * @return
     */
    protected Map<String, List<TaxDirectDeductionInfo>> groupByTaxUnit(TaxDirectDeductionCollection collection) {
        Map<String, List<TaxDirectDeductionInfo>> map = new HashMap();

        for(int i = 0; i < collection.size(); ++i) {
            TaxDirectDeductionInfo info = collection.get(i);
            String taxUnitDeductionId = info.getTaxUnitDeduction().getId().toString();
            List<TaxDirectDeductionInfo> list = (List)map.get(taxUnitDeductionId);
            if (null == list) {
                list = new ArrayList();
            }

            ((List)list).add(info);
            map.put(taxUnitDeductionId, list);
        }

        return map;
    }
    protected Map<String, String> getAcceptIdMap(Context ctx, Map<String, List<TaxDirectDeductionInfo>> groups) throws BOSException {
        try {
            String sql = "select t3.fAccept_id acceptId, t1.fid fid from t_hr_sTaxUnitDeduction t1, T_HR_STaskIncomeTaxRelation t2, t_hr_sTaxCalTask t3 where t1.fid = t2.fBizId and t2.fTaskId = t3.fid and t1.fid in (" + CmpStrUtil.convertSetToSqlString(groups.keySet()) + ")";
            Map<String, String> acceptIdMap = new HashMap();
            IRowSet rs = DbUtil.executeQuery(ctx, sql);

            while(rs.next()) {
                String key = rs.getString("fid");
                String acceptId = rs.getString("acceptId");
                acceptIdMap.put(key, acceptId);
            }

            return acceptIdMap;
        } catch (Exception var8) {
            logger.error("getAcceptIdMap error: ", var8);
            throw new BOSException(var8.getMessage());
        }
    }

    @Override
    protected List _confirm(Context ctx, Map paramMap) throws BOSException {
        super._confirm(ctx, paramMap);
        List<String> ids = (List)paramMap.get("ids");
        String oql = "select id, taxUnitDeduction.id, taxUnitDeduction.taxUnit.taxNumber,taxUnitDeduction.taxUnit.name, taxUnitDeduction.taxUnit.id, " +
                "taxUnitDeduction.taxUnit.areaCode, taxUnitDeduction.taxUnit.regNumber,taxUnitDeduction.year, taxUnitDeduction.taxUnit.declPassword, " +
                "taxUnitDeduction.taxUnit.realPassword, taxUnitDeduction.taxUnit.isAutoDeduct, isDecdut, " +
                "taxPersonRecordEntry.bill.cardType, taxPersonRecordEntry.bill.cardNumber," +
                "taxPersonRecordEntry.bill.reportName,taxPersonRecordEntry.bill.nationality.name where id in " + CmpStrUtil.concatList(ids);

        TaxDirectDeductionCollection collection = TaxDirectDeductionFactory.getLocalInstance(ctx).getTaxDirectDeductionCollection(oql);
        logger.error(collection.toString());
        if (null != collection && collection.size() != 0) {
            List<IObjectPK> arrayList = new ArrayList();
            Map<String, List<TaxDirectDeductionInfo>> groups = this.groupByTaxUnit(collection);
            Map<String, String> acceptIdMap = this.getAcceptIdMap(ctx, groups);
            List<Object[]> params = new ArrayList();
            Iterator i$groups = groups.entrySet().iterator();

            while(i$groups.hasNext()) {
                Map.Entry<String, List<TaxDirectDeductionInfo>> entry = (Map.Entry)i$groups.next();
                TaxDirectDeductionInfo deductionInfo = ((TaxDirectDeductionInfo)((List)entry.getValue()).get(0));
                TaxUnitDeductionInfo taxUnitDeductionInfo = deductionInfo.getTaxUnitDeduction();
                TaxUnitInfo taxUnitInfo = taxUnitDeductionInfo.getTaxUnit();
                StringBuilder confirmIds = new StringBuilder();
                SixTConfirmInfo sixTConfirmInfo = new SixTConfirmInfo();
                sixTConfirmInfo.setBizNo(deductionInfo.getId().toString());
                sixTConfirmInfo.setQymc(taxUnitInfo.getName());
                sixTConfirmInfo.setMmlx(null);
                sixTConfirmInfo.setSmzh(null);
                sixTConfirmInfo.setSmmm(null);
                sixTConfirmInfo.setJmsmmm(null);
                sixTConfirmInfo.setDjxhid(taxUnitInfo.getRegNumber());
                sixTConfirmInfo.setNsrsbh(taxUnitInfo.getTaxNumber());
                sixTConfirmInfo.setAreaid(taxUnitInfo.getAreaCode());
                sixTConfirmInfo.setBmbh(null);
                sixTConfirmInfo.setBmmc(null);
                sixTConfirmInfo.setSbmm(Base64Utils.decode(taxUnitInfo.getDeclPassword()));
                sixTConfirmInfo.setJmsbmm(null);
                sixTConfirmInfo.setSkssnd(String.valueOf(taxUnitDeductionInfo.getYear()));
                sixTConfirmInfo.setAcceptId(acceptIdMap.get(taxUnitDeductionInfo.getId().toString()));
                sixTConfirmInfo.setTAXUNITID(taxUnitInfo.getId().toString());
                int lastYear = CmpDateUtil.getYear(new Date());
                String period = lastYear + "01";
                sixTConfirmInfo.setSdyf(period);

                Map<String, Object> map = new HashMap();

                List<SixTPersonInfo> kczglb = Lists.newArrayList();
                sixTConfirmInfo.setKczglb(kczglb);

                TaxDirectDeductionInfo taxDirectDeductionInfo;
                for(Iterator i$ = ((List)entry.getValue()).iterator(); i$.hasNext(); confirmIds.append(taxDirectDeductionInfo.getId().toString())) {
                    taxDirectDeductionInfo = (TaxDirectDeductionInfo)i$.next();
                    SixTPersonInfo sixTPersonInfo = new SixTPersonInfo();
                    kczglb.add(sixTPersonInfo);
                    sixTPersonInfo.setXm(taxDirectDeductionInfo.getTaxPersonRecordEntry().getBill().getReportName());
                    sixTPersonInfo.setZzlx(taxDirectDeductionInfo.getTaxPersonRecordEntry().getBill().getCardType().getAlias());
                    sixTPersonInfo.setZzhm(taxDirectDeductionInfo.getTaxPersonRecordEntry().getBill().getCardNumber());
                    sixTPersonInfo.setGj(taxDirectDeductionInfo.getTaxPersonRecordEntry().getBill().getNationality().getName());
                    sixTPersonInfo.setKcbs( taxDirectDeductionInfo.isIsDecdut() ? "" : "");
                    Object[] param = new Object[2];
                    param[0] = 40;
                    param[1] = taxDirectDeductionInfo.getId().toString();
                    params.add(param);
                    if (confirmIds.length() > 0) {
                        confirmIds.append(",");
                    }
                }

                map.put("ids", confirmIds.toString());
                map.put("qrgjrylb", kczglb);

                ISYUtilsFacade facade = SYUtilsFacadeFactory.getLocalInstance(ctx);
                String sixTConfirmJSON =JSONUtil.toJsonStr(sixTConfirmInfo);
                logger.error(sixTConfirmJSON);
                String taskId = facade.addTask("getPreDeductConfirm",sixTConfirmJSON, TaskCatalogEnum.COLLECTION_CONFIRM,null);
                String updateSQL = "update T_HR_STaxDirectDeduction set FSate = ?,FTASKID='"+taskId+"' where fid = ?";
                DbUtil.executeBatch(ctx, updateSQL, params);
                arrayList.add(new ObjectUuidPK(taskId));
            }

            return arrayList;
        } else {
            throw new BOSException("6ֱӿ۳ԱȷϣδȡӦԱݣϵԱǷɾ");
        }
    }

    @Override
    protected void _saveConfirm(Context ctx, String taskId, String result) throws BOSException {
        super._saveConfirm(ctx, taskId, result);
    }

    /**
     * ۳ѯ
     * @param ctx
     * @param paramMap
     * @return
     * @throws BOSException
     */
    @Override
    protected List _staffCollection(Context ctx, Map paramMap) throws BOSException {
        super._staffCollection(ctx, paramMap);
        if (null != paramMap && null != paramMap.get("taxUnitIds") && null != paramMap.get("period")) {
            String taxUnitIds = (String)paramMap.get("taxUnitIds");
            List<IObjectPK> arrayList = new ArrayList();
            String oql = "select id,name,number,taxNumber,areaCode,regNumber,declPassword,realPassword,isAutoDeduct where id in " + CmpStrUtil.buildInSql(taxUnitIds);
            TaxUnitCollection taxUnitCollection = TaxUnitFactory.getLocalInstance(ctx).getTaxUnitCollection(oql);
            List<Object[]> params = new ArrayList();
            ISYUtilsFacade facade = SYUtilsFacadeFactory.getLocalInstance(ctx);
            Map<String,String> config =facade.getConfig();
            for(int i = 0; i < taxUnitCollection.size(); ++i) {
                TaxUnitInfo taxUnitInfo = taxUnitCollection.get(i);
                String yearMonth = TaxReportUtil.getCurrentYearMonth((String)paramMap.get("period"));
                int year = Integer.parseInt(yearMonth.substring(0, 4));
                SixTConfirmInfo sixTConfirmInfo = new SixTConfirmInfo();
                sixTConfirmInfo.setBizNo(System.currentTimeMillis()+"");
                sixTConfirmInfo.setQymc(taxUnitInfo.getName());
                sixTConfirmInfo.setMmlx(null);
                sixTConfirmInfo.setSmzh(null);
                sixTConfirmInfo.setSmmm(null);
                sixTConfirmInfo.setJmsmmm(null);
                sixTConfirmInfo.setDjxhid(taxUnitInfo.getRegNumber());
                sixTConfirmInfo.setNsrsbh(taxUnitInfo.getTaxNumber());
                sixTConfirmInfo.setAreaid(taxUnitInfo.getAreaCode());
                sixTConfirmInfo.setBmbh(null);
                sixTConfirmInfo.setBmmc(null);
                sixTConfirmInfo.setSbmm(Base64Utils.decode(taxUnitInfo.getDeclPassword()));
                sixTConfirmInfo.setJmsbmm(null);
                sixTConfirmInfo.setSkssnd(String.valueOf(year));
                taxUnitInfo.put("year",year);
                //sixTConfirmInfo.setAcceptId(acceptIdMap.get(taxUnitDeductionInfo.getId().toString()));
                sixTConfirmInfo.setTAXUNITID(taxUnitInfo.getId().toString());
                String result = facade.addTask("queryPreDeductService",JSONUtil.toJsonStr(sixTConfirmInfo),TaskCatalogEnum.QUERYPREDEDUCTSERVICE,null);
                arrayList.add(new ObjectUuidPK(result));
            }
            return arrayList;
        } else {
            throw new BOSException("6ֱӿ۳Ա鼯ӿڷȱʧ");
        }
    }

    protected String saveTaxUnitDeduction(Context ctx, TaxUnitInfo taxUnit, int year) throws BOSException {
        IObjectPK pk;
        try {
            String taxUnitId = taxUnit.getId().toString();
            String deleteSQL = "delete from t_hr_sTaxDirectDeduction where fTaxUnitDeductionId in (select fid from T_HR_STaxUnitDeduction where fTaxUnitId = '" + taxUnitId + "' and fYear = " + year + ")";
            DbUtil.execute(ctx, deleteSQL);
            deleteSQL = "delete from T_HR_STaxUnitDeduction where fTaxUnitId = '" + taxUnitId + "' and fYear = " + year;
            DbUtil.execute(ctx, deleteSQL);
            TaxUnitDeductionInfo info = new TaxUnitDeductionInfo();
            info.setTaxUnit(taxUnit);
            info.setYear(year);
            info.setIsCollection(true);
            pk = TaxUnitDeductionFactory.getLocalInstance(ctx).save(info);
        } catch (EASBizException var8) {
            logger.error("_saveStaffCollection error: ", var8);
            throw new BOSException(var8.getMessage());
        }

        return pk.toString();
    }

    protected String getTaxUnitDeduction(Context ctx, TaxUnitInfo taxUnit, int year) throws BOSException {
        String oql = "select id where taxUnit.id = '" + taxUnit.getId().toString() + "' and year = " + year;
        TaxUnitDeductionCollection collection = TaxUnitDeductionFactory.getLocalInstance(ctx).getTaxUnitDeductionCollection(oql);
        if (null != collection && !collection.isEmpty()) {
            return collection.get(0).getId().toString();
        } else {
            throw new BOSException("ûҵ˰λ鼯Ϣ");
        }
    }

    @Override
    protected synchronized void _saveStaffCollection(Context ctx, TaxUnitInfo taxUnit, String result) throws BOSException {
        super._saveStaffCollection(ctx, taxUnit, result);
        JSONObject object = JSONUtil.parseObj(result);
        JSONObject head = object.getJSONObject("head");
        Map<String, Object> headMap = (Map)object.get("head");
        Map<String, Object> bodyMap = (Map)object.get("body");
        if ("00000000".equals(head.getStr("code"))) {
            System.out.println("_saveStaffCollection:start");
            List<Map<String, Object>> kczglbList = (bodyMap.containsKey("kczglb") ? (List<Map<String, Object>>) bodyMap.get("kczglb") : null);
            if (null != kczglbList && !kczglbList.isEmpty()) {
                String prefix = "person_collect_";
                String resource = taxUnit.getId().toString();
                boolean flag = CmpDistributedLockUtils.tryLock(ctx, prefix, resource);
                if (flag) {
                    try {
                        int year = taxUnit.getInt("year");
                        String taxUnitDeductionId = this.getTaxUnitDeduction(ctx, taxUnit, year);
                        Map<String, Integer> personMap = new HashMap();
                        String userId = HRFilterUtils.getCurrentUserId(ctx);
                        Iterator itgjrylb = kczglbList.iterator();

                        while(itgjrylb.hasNext()) {
                            Map<String, Object> stringObjectMap = (Map)itgjrylb.next();
                            personMap.put(stringObjectMap.get("zzhm").toString(), "".equals(stringObjectMap.get("kcbs")) ? 1 : 0);
                        }
                        String cardNumbers = CmpStrUtil.converMapToString(personMap);
                        String sql = "SELECT e.fid, r.fCardNumber FROM t_hr_sTaxPersonRecordEntry e, t_hr_sTaxPersonRecord r WHERE e.fTaxUnitID = '" + resource + "' " + " and e.fBillId = r.fid " + " and r.fCardNumber IN (" + cardNumbers + ")";
                        IRowSet rowSet = DbUtil.executeQuery(ctx, sql);
                        Timestamp createTime = new Timestamp(System.currentTimeMillis());
                        List<Object[]> paramList = new ArrayList();
                        HashMap personSet = new HashMap();

                        while(rowSet.next()) {
                            Object[] param = new Object[10];
                            String taxPersonRecordEntryId = rowSet.getString(1);
                            param[0] = taxPersonRecordEntryId;
                            Integer isDirect = (Integer)personMap.get(rowSet.getString(2));
                            param[1] = isDirect;
                            param[2] = taxUnitDeductionId;
                            param[3] = userId;
                            param[4] = createTime;
                            param[5] = userId;
                            param[6] = createTime;
                            param[7] = BOSUuid.create("F831C6DA").toString();
                            param[8] = "";
                            param[9] = 10;
                            personSet.put(taxPersonRecordEntryId, isDirect);
                            paramList.add(param);
                        }
                        System.out.println("_saveStaffCollection:"+paramList);
                        String batchSql = "INSERT INTO T_HR_STAXDIRECTDEDUCTION( FTaxPersonRecordEntryId, FISDECDUT, FTAXUNITDEDUCTIONID, FCREATORID, FCREATETIME,  FLASTUPDATEUSERID, FLASTUPDATETIME, FID, FTaskId, fSate)  VALUES(?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
                        DbUtil.executeBatch(ctx, batchSql, paramList);
                        sql = "UPDATE t_hr_sTaxPersonRecordEntry SET fIsDirect = ? WHERE fid = ?";
                        paramList = new ArrayList();
                        Iterator itPersonSet = personSet.entrySet().iterator();

                        while(itPersonSet.hasNext()) {
                            Map.Entry<String, Integer> entry = (Map.Entry)itPersonSet.next();
                            Object[] param = new Object[]{entry.getValue(), entry.getKey()};
                            paramList.add(param);
                        }
                        DbUtil.executeBatch(ctx, sql, paramList);
                        System.out.println("_saveStaffCollection:"+paramList);
                    } catch (Exception var33) {
                        logger.error("_saveStaffCollection error: ", var33);
                    } finally {
                        CmpDistributedLockUtils.unlock(ctx, prefix, resource);
                    }
                }
            }else {
                throw new BOSException(result);
            }
        }else{
            throw new BOSException(result);
        }
    }
}