package com.kingdee.eas.custom.shuiyou.task;


/**
 * osfҵض
 * description: MessageResult <br>
 * date: 2024/9/10 16:59 <br>
 * author: lhbj <br>
 * version: 1.0 <br>
 */
public class MessageResult<T> {
    private String msg;
    private ExecutionStatusEnum status;
    private T data;

    public MessageResult(String msg, ExecutionStatusEnum status, T data) {
        this.msg = msg;
        this.status = status;
        this.data = data;
    }
    public MessageResult(String msg, ExecutionStatusEnum status) {
        this(msg,status,null);
    }
    public MessageResult(ExecutionStatusEnum status) {
        this(status.getAlias(),status);
    }

    /**
     * ɹ
     * @return
     */
    public static MessageResult SUCCESS(){
        ExecutionStatusEnum success = ExecutionStatusEnum.success;
        return new MessageResult(success.getAlias(),success);
    }
    public static MessageResult SUCCESS(String msg){
        return new MessageResult(msg,ExecutionStatusEnum.success);
    }
    /**
     * 
     * @return
     */
    public static MessageResult AGAIN(){
        ExecutionStatusEnum again = ExecutionStatusEnum.again;
        return new MessageResult(again.getAlias(),again);
    }
    public static MessageResult AGAIN(String msg){
        return new MessageResult(msg,ExecutionStatusEnum.again);
    }
    /**
     * ȴ
     * @return
     */
    public static MessageResult AWAIT_W(){
        ExecutionStatusEnum await_w = ExecutionStatusEnum.await_w;
        return new MessageResult(await_w.getAlias(),await_w);
    }
    public static MessageResult AWAIT_W(String msg){
        return new MessageResult(msg,ExecutionStatusEnum.await_w);
    }

    /**
     * ʧ
     * @param msg
     * @return
     */
    public static MessageResult FAILED(String msg){
        return new MessageResult(msg,ExecutionStatusEnum.failed);
    }
    public static MessageResult FAILED(){
        ExecutionStatusEnum failed = ExecutionStatusEnum.failed;
        return new MessageResult(failed.getAlias(),failed);
    }
    public static MessageResult ERROR(String msg){
        ExecutionStatusEnum error = ExecutionStatusEnum.error;
        return new MessageResult(msg,error);
    }

    public String getMsg() {
        return msg;
    }

    public MessageResult setMsg(String msg) {
        this.msg = msg;
        return this;
    }

    public ExecutionStatusEnum getStatus() {
        return status;
    }

    public void setStatus(ExecutionStatusEnum status) {
        this.status = status;
    }

    public T getData() {
        return data;
    }

    public MessageResult setData(T data) {
        this.data = data;
        return this;
    }
}
