package com.kingdee.eas.custom.shuiyou.task;

import cn.hutool.core.util.StrUtil;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.google.common.collect.Maps;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.eas.custom.shuiyou.RequestStateEnum;
import com.kingdee.eas.custom.shuiyou.uitls.*;
import org.apache.log4j.Logger;
import javax.ejb.*;
import java.rmi.RemoteException;
import com.kingdee.bos.*;
import com.kingdee.bos.util.BOSObjectType;
import com.kingdee.bos.metadata.IMetaDataPK;
import com.kingdee.bos.metadata.rule.RuleExecutor;
import com.kingdee.bos.metadata.MetaDataPK;
//import com.kingdee.bos.metadata.entity.EntityViewInfo;
import com.kingdee.bos.framework.ejb.AbstractEntityControllerBean;
import com.kingdee.bos.framework.ejb.AbstractBizControllerBean;
//import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.dao.IObjectValue;
import com.kingdee.bos.dao.IObjectCollection;
import com.kingdee.bos.service.ServiceContext;
import com.kingdee.bos.service.IServiceContext;

import java.lang.String;
import java.util.Map;
import java.util.Optional;
import java.util.concurrent.CountDownLatch;

public class TaskExecuteFacadeControllerBean extends AbstractTaskExecuteFacadeControllerBean
{
    private static Logger logger =
        Logger.getLogger("com.kingdee.eas.custom.shuiyou.task.TaskExecuteFacadeControllerBean");

    @Override
    protected String _executeTask(Context ctx, String taskId) throws BOSException {
        int size =0;
        try {
            ITask iTask = TaskFactory.getLocalInstance(ctx);
            if (!StrUtil.isBlank(taskId)) {
                SelectorItemCollection sc = new SelectorItemCollection();
                sc.add(new SelectorItemInfo("id"));
                sc.add(new SelectorItemInfo("url"));
                sc.add(new SelectorItemInfo("requestId"));
                sc.add(new SelectorItemInfo("requestType"));
                sc.add(new SelectorItemInfo("requestParam.id"));
                sc.add(new SelectorItemInfo("requestParam.paramContent"));
                sc.add(new SelectorItemInfo("requestResult.id"));
                sc.add(new SelectorItemInfo("requestResult.resultContent"));
                sc.add(new SelectorItemInfo("requestState"));
                sc.add(new SelectorItemInfo("state"));
                sc.add(new SelectorItemInfo("name"));
                sc.add(new SelectorItemInfo("osfServiceName"));
                sc.add(new SelectorItemInfo("number"));
                sc.add(new SelectorItemInfo("taskPre.id"));
                sc.add(new SelectorItemInfo("taskPre.state"));
                sc.add(new SelectorItemInfo("taskPre.requestState"));
                //ָidִ
                TaskInfo taskInfo = iTask.getTaskInfo(new ObjectUuidPK(taskId),sc);
                taskInfo.setContext(ctx).execute();
                size =1;
            }else {
                //ִ״̬Ϊδʼ
                EntityViewInfo viewInfo = new EntityViewInfo();
                SelectorItemCollection sc = new SelectorItemCollection();
                sc.add(new SelectorItemInfo("id"));
                sc.add(new SelectorItemInfo("url"));
                sc.add(new SelectorItemInfo("requestId"));
                sc.add(new SelectorItemInfo("requestType"));
                sc.add(new SelectorItemInfo("requestParam.id"));
                sc.add(new SelectorItemInfo("requestParam.paramContent"));
                sc.add(new SelectorItemInfo("requestResult.id"));
                sc.add(new SelectorItemInfo("requestResult.resultContent"));
                sc.add(new SelectorItemInfo("requestState"));
                sc.add(new SelectorItemInfo("state"));
                sc.add(new SelectorItemInfo("name"));
                sc.add(new SelectorItemInfo("osfServiceName"));
                sc.add(new SelectorItemInfo("number"));
                sc.add(new SelectorItemInfo("taskPre.id"));
                sc.add(new SelectorItemInfo("taskPre.state"));
                sc.add(new SelectorItemInfo("taskPre.requestState"));
                viewInfo.setSelector(sc);
                FilterInfo filterInfo = new FilterInfo();
                filterInfo.getFilterItems().add(
                        new FilterItemInfo("state",
                                TaskStateEnum.STANDBY_VALUE, CompareType.EQUALS));
                filterInfo.getFilterItems().add(
                        new FilterItemInfo("state",
                                TaskStateEnum.DELETE_VALUE, CompareType.NOTEQUALS));
//                FilterInfo filterPre1Info = new FilterInfo();
//                filterPre1Info.getFilterItems().add(
//                        new FilterItemInfo("taskPre.requestState",
//                                RequestStateEnum.SUCCESSFUL_VALUE, CompareType.EQUALS));
//                filterPre1Info.getFilterItems().add(
//                        new FilterItemInfo("taskPre.state",
//                                TaskStateEnum.FINISHED_VALUE, CompareType.EQUALS));
//                FilterInfo filterPre2Info = new FilterInfo();
//                filterPre2Info.getFilterItems().add(
//                        new FilterItemInfo("taskPre.id is null"));
//                filterPre1Info.mergeFilter(filterPre2Info,"or");
//                filterInfo.mergeFilter(filterPre1Info,"and");
                viewInfo.setFilter(filterInfo);
                TaskCollection taskCollection = iTask.getTaskCollection(viewInfo);
                //״̬Ϊ
                size = taskCollection.size();
                SelectorItemCollection scUp = new SelectorItemCollection();
                scUp.add(new SelectorItemInfo("requestState"));
                scUp.add(new SelectorItemInfo("state"));
                for(int i=0;i<size;i++) {
                    TaskInfo taskInfo = taskCollection.get(i);

                    taskInfo.setRequestState(RequestStateEnum.Ongoing);
                    taskInfo.setState(TaskStateEnum.WAITTING);
                    iTask.updatePartial(taskInfo,scUp);
                }
                //
                CountDownLatch latch = new CountDownLatch(size);
                SYUCronTaskUtil cronTaskUtil = SYUCronTaskUtil.getInstance();
                //ӵѯ
                for(int i=0;i<size;i++) {
                    TaskInfo taskInfo = taskCollection.get(i);
                    taskInfo.setContext(ctx);
                    taskInfo.setCountDownLatch(latch);
                    cronTaskUtil.addSchedule(taskInfo);
                }
                latch.await();
            }
        }catch (Exception e){
            e.printStackTrace();
            logger.error(e);
            size=0;
           throw new BOSException(e);
        }
        return String.valueOf(size);
    }
}