package com.kingdee.eas.custom.shuiyou.task;



import cn.hutool.core.util.StrUtil;
import cn.hutool.cron.task.Task;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.google.common.collect.Maps;
import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;

import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.shuiyou.RequestStateEnum;
import com.kingdee.eas.custom.shuiyou.RequestTypeEnum;
import com.kingdee.eas.custom.shuiyou.uitls.ISYUtilsFacade;

import com.kingdee.eas.custom.shuiyou.uitls.SYUCronTaskUtil;
import com.kingdee.eas.custom.shuiyou.uitls.SYUtilsFacadeFactory;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.shr.base.syssetting.MSFServiceFacadeFactory;
import org.apache.log4j.Logger;

import java.io.Serializable;
import java.util.Date;
import java.util.Map;
import java.util.Optional;
import java.util.concurrent.CountDownLatch;
import java.util.function.Supplier;

public class TaskInfo extends AbstractTaskInfo implements Serializable, Task
{
    private static Logger logger =Logger.getLogger(TaskInfo.class);
    private StringBuilder msg=new StringBuilder();
    private boolean state=true;
    public static final String calculatingCode="100004";
    private int i=0;
    private Context ctx;
    private CountDownLatch cdl;
    public TaskInfo()
    {
        super();

    }
    protected TaskInfo(String pkField)
    {
        super(pkField);

    }

    /**
     * 
     * @param context
     * @return
     */
    public TaskInfo setContext(Context context)
    {
        this.ctx=context;
        return this;
    }

    /**
     * 
     * @param cdl
     * @return
     */
    public TaskInfo setCountDownLatch(CountDownLatch cdl)
    {
        this.cdl=cdl;
        return this;
    }
    /**
     * ǰ״̬
     * true ִ
     * false ִ
     * @return
     */
    public boolean isState() {
        return state;
    }

    /**
     * Ϣ
     * @return
     */
    public String getMsg() {
        return msg.toString();
    }

    @Override
    public void execute() {
        this.i=this.i+1;
        try {
            ITask iTask = TaskFactory.getLocalInstance(ctx);
            //Ϊִ
            if (TaskStateEnum.WAITTING.equals(this.getState())){
                this.setState(TaskStateEnum.RUNNING);
                SelectorItemCollection sc = new SelectorItemCollection();

                sc.add(new SelectorItemInfo("state"));
                iTask.updatePartial(this,sc);
            }
            //УǷִִ
            TaskInfo taskPre = this.getTaskPre();
            //ǰ
            if(null!=taskPre&&null!=taskPre.getId()) {

                SelectorItemCollection sc = new SelectorItemCollection();
                sc.add(new SelectorItemInfo("id"));
                sc.add(new SelectorItemInfo("state"));
                taskPre = iTask.getTaskInfo(new ObjectUuidPK(this.getId()), sc);
                TaskStateEnum taskStateEnum = taskPre.getState();
                if (TaskStateEnum.FAIDED.equals(taskStateEnum)) {
                    //ǰִʧܺʧ
                    this.setState(TaskStateEnum.FAIDED);
                    this.setExecutionStatus(ExecutionStatusEnum.failed);
                    //Ƴ
                    this.stop();
                }
                if (TaskStateEnum.DELETE.equals(taskStateEnum)) {
                    //ǰִɾɾ
                    this.setState(TaskStateEnum.DELETE);
                    this.setExecutionStatus(ExecutionStatusEnum.failed);
                    //Ƴ
                    this.stop();
                }
                if (!TaskStateEnum.FINISHED.equals(taskStateEnum)) {
                    //ǰδִɵȴ´ִ
                    return;
                }
            }
            Map<String,Object> paramOsf = Maps.newHashMap();
            Optional<TaskRequestParamInfo> requestParamInfo = Optional.ofNullable(this.getRequestParam());
            String param = requestParamInfo.orElse((new TaskRequestParamInfo())).getParamContent();
//            //ƴӲ
//            if(StrUtil.isNotBlank(param)){
//                JSONObject jsonObject = JSONUtil.parseObj(param);
//                for(Map.Entry<String,Object> st : jsonObject.entrySet()){
//                    Optional<Object> op = Optional.ofNullable(st.getValue());
//                    paramOsf.put(st.getKey(),op.orElse("").toString());
//                }
//            }
            this.setCalTime(new Date());
            paramOsf.put("this_taskId",this.getId().toString());
            paramOsf.put("paramData",param);
            logger.error(""+this.getId().toString()+",ַ"+this.getUrl()+","+param+"");
            //ҵʵ
            MessageResult messageResult = this.callBackOSF(paramOsf);
            if(ExecutionStatusEnum.success.equals(messageResult.getStatus())){
                Optional<TaskRequestResultInfo> resultInfo = Optional.ofNullable(this.getRequestResult());
                TaskRequestResultInfo requestResult = resultInfo.orElse(new TaskRequestResultInfo());
                requestResult.setResultContent(messageResult.getMsg());
                requestResult.setTask(this);
                this.setRequestResult(requestResult);
                //óɹ
                this.setRequestState(RequestStateEnum.Successful);
                this.setState(TaskStateEnum.FINISHED);
                this.stop();
            }else if (ExecutionStatusEnum.again.equals(messageResult.getStatus())){
                //ü
                Optional<TaskRequestResultInfo> resultInfo = Optional.ofNullable(this.getRequestResult());
                TaskRequestResultInfo requestResult = resultInfo.orElse(new TaskRequestResultInfo());
                requestResult.setResultContent(messageResult.getMsg());
                requestResult.setTask(this);
                this.setRequestResult(requestResult);
            }else if (ExecutionStatusEnum.await_w.equals(messageResult.getStatus())){
                //õȴ,ֹͣTaskStateEnum״̬Ҫ¡
                //µҪȴִɣܼ
                Optional<TaskRequestResultInfo> resultInfo = Optional.ofNullable(this.getRequestResult());
                TaskRequestResultInfo requestResult = resultInfo.orElse(new TaskRequestResultInfo());
                requestResult.setResultContent(messageResult.getMsg());
                requestResult.setTask(this);
                this.setRequestResult(requestResult);
                this.setRequestState(RequestStateEnum.Successful);
                this.setState(TaskStateEnum.RUNNING);
                this.stop();
            }else {
                //ʧ
                Optional<TaskRequestResultInfo> resultInfo = Optional.ofNullable(this.getRequestResult());
                TaskRequestResultInfo requestResult = resultInfo.orElse(new TaskRequestResultInfo());
                requestResult.setResultContent(messageResult.getMsg());
                requestResult.setTask(this);

                this.setRequestResult(requestResult);
                this.setRequestState(RequestStateEnum.Failed);
                this.setState(TaskStateEnum.FAIDED);
                this.stop();
            }
            this.setExecutionStatus(messageResult.getStatus());
        }catch (Exception e){
            e.printStackTrace();
            logger.error(e);
            //ʧ
            Optional<TaskRequestResultInfo> resultInfo = Optional.ofNullable(this.getRequestResult());
            TaskRequestResultInfo requestResult = resultInfo.orElse(new TaskRequestResultInfo());
            requestResult.setResultContent(requestResult.getResultContent()+"----------"+e.getMessage());
            requestResult.setTask(this);
            //ʧ
            this.setRequestResult(requestResult);
            this.setRequestState(RequestStateEnum.Failed);
            this.setState(TaskStateEnum.FAIDED);
            this.setExecutionStatus(ExecutionStatusEnum.error);
            this.stop();
        }finally {
            //״̬
            try {
                TaskRequestResultFactory.getLocalInstance(ctx).save(this.getRequestResult());
                TaskFactory.getLocalInstance(ctx).save(this);
            } catch (BOSException e) {
                e.printStackTrace();
            } catch (EASBizException e) {
                e.printStackTrace();
            }
        }
    }

    /**
     * ʵ
     */
    @Deprecated
    public void execute_old() {

        this.i=this.i+1;

        try {

            //ִ
            ISYUtilsFacade syu = SYUtilsFacadeFactory.getLocalInstance(this.ctx);
            Map<String,String> map = Maps.newHashMap();
            map.put("requestId",this.getRequestId());

            Optional<TaskRequestParamInfo> requestParamInfo = Optional.ofNullable(this.getRequestParam());
            String param = requestParamInfo.orElse((new TaskRequestParamInfo())).getParamContent();
            //ƴӲ
            if(StrUtil.isNotBlank(param)){
                JSONObject jsonObject = JSONUtil.parseObj(param);
                for(Map.Entry<String,Object> st : jsonObject.entrySet()){
                    Optional<Object> op = Optional.ofNullable(st.getValue());
                    map.put(st.getKey(),op.orElse("").toString());
                }
            }

            String getParam = JSONUtil.toJsonStr(map);
            logger.info(""+this.getId().toString()+",ַ"+this.getUrl()+","+getParam+"");
            //Զ̽ӿ
            String string = null;
            this.setCalTime(new Date());
            if(RequestTypeEnum.GET_VALUE.equals(this.getRequestType().getValue())){
                string = syu.get(this.getUrl(),getParam);
            }else{
                string = syu.post(this.getUrl(),getParam);
            }

            JSONObject jsonObject = JSONUtil.parseObj(string);
            JSONObject head =  jsonObject.getJSONObject("head");
            if(null!=head){
                String status = (String) head.get("status");
                String code = (String) head.get("code");
                if("Y".equalsIgnoreCase(status)){
                    logger.info("ɹ"+(this.i)+","+string);
                    //ɹֹͣ
                    this.stop();
                    Optional<TaskRequestResultInfo> resultInfo = Optional.ofNullable(this.getRequestResult());
                    TaskRequestResultInfo requestResult = resultInfo.orElse(new TaskRequestResultInfo());
                    requestResult.setResultContent(string);
                    requestResult.setTask(this);
                    this.setRequestResult(requestResult);
                    //óɹ
                    this.setRequestState(RequestStateEnum.Successful);
                    this.setState(TaskStateEnum.FINISHED);
                    Map<String,Object> paramOsf = Maps.newHashMap();
                    paramOsf.put("paramData",getParam);
                    paramOsf.put("taskId",this.getId().toString());
                    paramOsf.put("result",string);
                    this.callBackOSF(paramOsf);
                } else if(calculatingCode.equals(code)&&StrUtil.isNotBlank(this.getRequestId())){
                    logger.info(""+(this.i)+","+string);
                    //
                } else {
                    logger.info(""+(this.i)+"ʧ,"+string);
                    //ʧֹͣ
                    this.stop();
                    //÷ֵ
                    Optional<TaskRequestResultInfo> resultInfo = Optional.ofNullable(this.getRequestResult());
                    TaskRequestResultInfo requestResult = resultInfo.orElse(new TaskRequestResultInfo());
                    requestResult.setResultContent(string);
                    requestResult.setTask(this);
                    //ʧ
                    this.setRequestResult(requestResult);
                    this.setRequestState(RequestStateEnum.Successful);
                    this.setState(TaskStateEnum.FAIDED);

                    Map<String,Object> paramOsf = Maps.newHashMap();
                    paramOsf.put("paramData",getParam);
                    paramOsf.put("taskId",this.getId().toString());
                    paramOsf.put("result",string);
                    this.callBackOSF(paramOsf);
                }
            }
        }catch (Exception e){
            e.printStackTrace();
            logger.error(e);
            //ʧ
            Optional<TaskRequestResultInfo> resultInfo = Optional.ofNullable(this.getRequestResult());
            TaskRequestResultInfo requestResult = resultInfo.orElse(new TaskRequestResultInfo());

            requestResult.setResultContent(requestResult.getResultContent()+"----------"+e.getMessage());
            requestResult.setTask(this);
            //ʧ
            this.setRequestResult(requestResult);
            this.setRequestState(RequestStateEnum.Failed);
            this.setState(TaskStateEnum.FAIDED);
            this.stop();
        }finally {
            //״̬
            try {
                TaskRequestResultFactory.getLocalInstance(ctx).save(this.getRequestResult());
                TaskFactory.getLocalInstance(ctx).save(this);
            } catch (BOSException e) {
                e.printStackTrace();
            } catch (EASBizException e) {
                e.printStackTrace();
            }
        }
    }

    /**
     * osf
     * ĬϻὫŴϣҪԼosföӦĲ
     * @param param
     */
    public MessageResult callBackOSF(Map<String,Object> param){
        MessageResult result=null;
        try {
            //صosf
            if(StrUtil.isNotBlank(this.getOsfServiceName())) {
                Object obj = MSFServiceFacadeFactory.getLocalInstance(this.ctx).processService(this.getOsfServiceName(), param);
                result = (MessageResult)obj;
            }else {
                result =MessageResult.SUCCESS();
            }
        } catch (BOSException e){
            //e.printStackTrace();
            logger.error(e);
            result = MessageResult.ERROR(e.getMessage());
        } catch (EASBizException e){
            //e.printStackTrace();
            logger.error(e);
            result = MessageResult.ERROR(e.getMessage());
        }finally {
        }
        return result;
    }

    public boolean stop(){
        this.state=false;
        if(null!=cdl) {
            cdl.countDown();
        }
        return SYUCronTaskUtil.getInstance().delSchedule(this);
    }
}