package com.kingdee.eas.custom.shuiyou.taxCal;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.bos.util.EASResource;
import com.kingdee.eas.custom.shuiyou.incomeTax.TaxPersonReportExFacadeFactory;
import com.kingdee.eas.custom.shuiyou.incomeTax.TaxSpeAddDedReportExFacadeFactory;
import com.kingdee.eas.custom.shuiyou.task.TaskCatalogEnum;
import com.kingdee.eas.custom.shuiyou.uitls.SYUtilsFacadeFactory;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.shr.base.syssetting.app.filter.HRFilterUtils;
import com.kingdee.shr.compensation.app.tax.base.TaxItemCollection;
import com.kingdee.shr.compensation.app.tax.base.TaxItemInfo;
import com.kingdee.shr.compensation.app.taxCal.*;
import com.kingdee.shr.compensation.app.taxCal.vo.TaxCalBasicVO;
import com.kingdee.shr.compensation.taxCal.util.TaxItemUtil;
import com.kingdee.shr.compensation.util.CmpDateUtil;
import com.kingdee.util.StringUtils;
import org.apache.log4j.Logger;
import com.kingdee.bos.*;

import java.math.BigDecimal;
import java.lang.String;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.util.*;

/**
 * ˰Facade
 */
public class TaxCalFacadeControllerBean extends AbstractTaxCalFacadeControllerBean {
    private static Logger logger = Logger.getLogger(TaxCalFacadeControllerBean.class);
    private static final long serialVersionUID = 1L;
    private Map<String, String> taskMap;
    private Map<String, Map<String, Object>> dataMap = new HashMap();
    private List<String> sumTaxList;//˰ۼĿֶ
    private List<String> allTaxItemList;//ȫ˰Ŀֶ
    private static final int FIXED_PARA_COUNT = 15;
    private String userId;
    private boolean isDelete = false;
    //Ƿ񸽱ύ
    private boolean isFbSubmit;

    /**
     * ƴװ˰
     *
     * @param ctx
     * @param initIds     ϸid
     * @param relayTaskID ǰid
     * @param taskCatalog 
     * @return
     * @throws BOSException
     */
    @Override
    protected String _submitInitData(Context ctx,
                                     String initIds,
                                     String relayTaskID,
                                     TaxCalTaskCatalogEnum taskCatalog) throws BOSException {
        if (!StringUtils.isEmpty(initIds) && !"''".equals(initIds)) {
            //ύ
            this.isFbSubmit = taskCatalog == TaxCalTaskCatalogEnum.FB_UPLOAD;
            //ǰûΪԱuserʱѯid
            this.initUserID(ctx, relayTaskID);
            //id
            //this.updateAcceptId(ctx, initIds);
            //
            String taskId = this.createTask(ctx, initIds, taskCatalog);
            //ȡ˰Ŀ
            this.initTaxItem(ctx);
            //״̬Ϊѷ
            //this.updateLastTaskDetail(ctx, initIds);
            //ȡд ˰ύ˰ݼ¼ sql
//            String insertSql = this.getInsertTaskDetailSql();
//            List<Object[]> paramsList = this.getParamListData(ctx, initIds);
//            DbUtil.executeBatch(ctx, insertSql, paramsList);
            if (!this.isFbSubmit) {//Ǹύ
                //¸˰Ӧ+˰ϸ 
                this.updateTaxCalInitData(ctx, initIds);
            }
            return taskId;
        } else {
            return null;
        }
    }

    /**
     * ʼûid
     * ǰûΪԱuserʱѯid
     *
     * @param ctx
     * @param relayTaskId ǰid
     */
    private void initUserID(Context ctx, String relayTaskId) {
        this.userId = HRFilterUtils.getCurrentUserId(ctx);
        //ڹԱuser  ǰidڿ
        if (
                ("00000000-0000-0000-0000-00000000000013B7DE7F".equals(this.userId)
                        || "256c221a-0106-1000-e000-10d7c0a813f413B7DE7F".equals(this.userId)
                ) && !StringUtils.isEmpty(relayTaskId)) {
            String getCreatorSQL = " select top 1 FCreatorID from T_HR_STAXCALTASK where fid = '" + relayTaskId + "'";
            try {
                IRowSet rowSet = DbUtil.executeQuery(ctx, getCreatorSQL);
                if (rowSet.next()) {
                    this.userId = rowSet.getString("FCreatorID");
                }
            } catch (Exception var5) {
                var5.printStackTrace();
            }
        }
    }

    /**
     * id
     *
     * @param ctx
     * @param initIds ϸid
     * @throws BOSException
     */
    private void updateAcceptId(Context ctx, String initIds) throws BOSException {
        String str = " update T_HR_STAXCALINITDETAIL detail set FAcceptId = ( select FAcceptId from T_HR_STaxPersonRecordEntry entry  where detail.FTaxUnitId = entry.FTaxUnitId and detail.FPersonId = entry.FPersonId)  where fid in (" + initIds + ") ";
        DbUtil.execute(ctx, str);
    }

    /**
     * 
     *
     * @param ctx
     * @param initIds ϸid
     * @param catalog 
     * @return
     * @throws BOSException
     */
    private String createTask(Context ctx,
                              String initIds,
                              TaxCalTaskCatalogEnum catalog) throws BOSException {
        this.taskMap = new HashMap();
        //˰Ӧ+˰ϸ
        //ְܹʹҵϢ¼
        String str = " SELECT t.fTaxUnitId," +
                " t.fPeriodBegin, " +
                " t.fIncomeItemId, " +
                " e.FAcceptId, " +
                " e.fid entryId," +
                " e.FSubmitStatus, " +
                " t.fid initId " +
                " from T_HR_STaxCalInitDetail t " +
                " left join T_HR_STaxPersonRecordEntry e  on t.fPersonId = e.fPersonId and t.fTaxUnitId = e.fTaxUnitId " +
                " where t.fid IN (" + initIds + ")";
        IRowSet rowSet = DbUtil.executeQuery(ctx, str);
        if (rowSet.size() < 1) {
            //δȡҪ˰ԱϢ
            throw new BOSException(EASResource.getString("com.kingdee.shr.compensation.resource.TaxCalBaseResource", "label31", ctx.getLocale()));
        } else {
            //˰λ
            HashMap<String, List<TaxCalBasicVO>> taxUnitGroups = new HashMap<String, List<TaxCalBasicVO>>();
            try {
                while (rowSet.next()) {
                    //˰λ
                    String taxUnitId = rowSet.getString("fTaxUnitId");
                    List<TaxCalBasicVO> calcList = taxUnitGroups.get(taxUnitId);
                    if (null == calcList) {
                        calcList = new ArrayList();
                        taxUnitGroups.put(taxUnitId, calcList);
                    }
                    //˰
                    TaxCalBasicVO vo = new TaxCalBasicVO();
                    vo.setPeriodBegin(rowSet.getDate("fPeriodBegin"));//ڿʼʱ
                    vo.setTaxUnitId(rowSet.getString("fTaxUnitId"));//˰λ
                    vo.setIncomeItemId(rowSet.getString("fIncomeItemId"));//Ŀ
                    vo.setAcceptId(rowSet.getString("initId"));//ʼid
                    vo.setSubmitStatus(rowSet.getString("FSubmitStatus"));//ύ״̬
                    vo.setEntryId(rowSet.getString("entryId"));//¼id
                    calcList.add(vo);
                }
            } catch (SQLException e) {
                logger.error(e.getMessage(), e);
                throw new BOSException(e.getMessage());
            }
            Iterator<Map.Entry<String, List<TaxCalBasicVO>>> iterator = taxUnitGroups.entrySet().iterator();
            ObjectMapper objectMapper = new ObjectMapper();
            for (Iterator i$ = iterator; i$.hasNext(); ) {
                Map.Entry<String, List<TaxCalBasicVO>> group = (Map.Entry) i$.next();
                Map<String, Object> paramMap = new HashMap();
                //˰λid
                String taxUnitId = group.getKey();
                List<TaxCalBasicVO> list = group.getValue();
                String yearMonth = CmpDateUtil.getDateStr((list.get(0)).getPeriodBegin(), "yyyy-MM");
                paramMap.put("TAXUNITID", taxUnitId);//˰λid
                paramMap.put("PERIOD", yearMonth);//yyyy-MM
                paramMap.put("initIds", initIds);//
                paramMap.put("creator", this.userId);//id
                //1.Ա
                //δͳɹԱid
                String notReportedPersonIds = getNotReportedPersonIds(list);
                if (StringUtils.isEmpty(notReportedPersonIds)) {
                    paramMap.put("accept_id", (list.get(0)).getAcceptId());
                } else if (!this.isFbSubmit) {//Ǹύ
                    try {
                        //Ա˰Ϣ_ԱϢ
                        List relayTaskIDList = TaxPersonReportExFacadeFactory.getLocalInstance(ctx)
                                .report(paramMap);
                        if (null != relayTaskIDList && relayTaskIDList.size() > 0) {
                            String relayTaskID = (String) relayTaskIDList.get(0);
                            paramMap.put("RELAYTASK", relayTaskID);//ǰid
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        throw new BOSException("Ա˰Ϣ_ԱϢͱ: " + e.getMessage());
                    }
                }
                //ȡĿнʵķ¼id
                String taxSpeAddDedEntryIds = this.getTaxSpeAddDedEntryIds(list);
                String reportTaskId = null;
                //2.רӿ۳걨_걨
                if (TaxCalTaskCatalogEnum.CAL == catalog && taxSpeAddDedEntryIds.length() > 0) {
                    paramMap.put("TaxPersonRecordEntryIDS", taxSpeAddDedEntryIds);
                    try {
                        //רӿ۳걨_걨
                        String jsonString = objectMapper.writeValueAsString(paramMap);
                        logger.info("רӿ۳걨_걨 : " + jsonString);
                        List relayTaskIDList = TaxSpeAddDedReportExFacadeFactory.getLocalInstance(ctx).report(paramMap);
                        if (null != relayTaskIDList && relayTaskIDList.size() > 0) {
                            reportTaskId = (String) relayTaskIDList.get(0);
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        throw new BOSException("רӿ۳걨_걨ύ񱨴: " + e.getMessage());
                    }
                }
                //3.˰
                String calTaxTaskId = null;
                try {
                    String jsonString = objectMapper.writeValueAsString(paramMap);
                    logger.info("˰ : " + jsonString);
                    calTaxTaskId = SYUtilsFacadeFactory.getLocalInstance(ctx).addTask(
                            "submitAsynTaxCalRequestService",
                            jsonString,
                            TaskCatalogEnum.CAL,
                            reportTaskId);
                } catch (JsonProcessingException e) {
                    e.printStackTrace();
                    throw new BOSException("˰ύ񱨴: " + e.getMessage());
                }
            }
            return null;
        }
    }

    /**
     * ȡĿнʵķ¼id
     *
     * @param list
     * @return
     */
    private String getTaxSpeAddDedEntryIds(List<TaxCalBasicVO> list) {
        StringBuilder entryIds = new StringBuilder();
        for (TaxCalBasicVO vo : list) {
            //Ŀн
            if ("8r0AAABCg2PDiOoP".equals(vo.getIncomeItemId())) {
                if (entryIds.length() > 0) {
                    entryIds.append(",");
                }
                entryIds.append("'").append(vo.getEntryId()).append("'");
            }
        }
        return entryIds.toString();
    }

    /**
     * ȡ˰Ŀ
     *
     * @param ctx
     */
    private void initTaxItem(Context ctx) {
        this.allTaxItemList = new ArrayList();
        this.sumTaxList = new ArrayList();
        //ȡи˰Ŀ
        TaxItemCollection itemColl = TaxItemUtil.getAllTaxItem(ctx, false);
        for (int i = 0; i < itemColl.size(); ++i) {
            TaxItemInfo info = itemColl.get(i);
            this.allTaxItemList.add("T" + info.getFieldSn());
            boolean isSum = info.isIsSum();
            if (isSum) {
                this.sumTaxList.add("T" + info.getFieldSn());
            }
        }
    }

    /**
     * ״̬Ϊѷ
     *
     * @param ctx
     * @param initIds
     * @throws BOSException
     */
    private void updateLastTaskDetail(Context ctx, String initIds) throws BOSException {
        //˰ύ˰ݼ¼ ״̬Ϊѷ
        String str = " UPDATE T_HR_STAXCALTASKDETAIL A01 SET FDATASTATE = 30 " +
                "WHERE EXISTS (" +
                "SELECT 1 FROM T_HR_STAXCALINITDETAIL A02  WHERE FID IN (" + initIds + ") " +
                "AND A01.FCMPCALTABLEID = A02.FCMPCALTABLEID AND A01.fIncomeItemId = A02.fIncomeItemId) " + "   AND A01.FDATASTATE = " + 10;
        DbUtil.execute(ctx, str);
    }

    private String getInsertTaskDetailSql() {
        StringBuilder str = new StringBuilder();
        StringBuilder itemStr = new StringBuilder();
        Iterator i$ = this.allTaxItemList.iterator();

        while (i$.hasNext()) {
            String s = (String) i$.next();
            str.append(s).append(",");
            itemStr.append(",?");
        }

        String taxItems = str.substring(0, str.length() - 1);
        str = new StringBuilder();
        str.append(" INSERT INTO T_HR_STAXCALTASKDETAIL(FID, FCALTASKID, FRELAYID, FCMPCALTABLEID, FPERSONID, ");
        str.append(" FTAXUNITID, FPERIODBEGIN, FPERIODEND, FINCOMEITEMID, FACCEPTID, ");
        str.append(" FCREATORID, FCREATETIME, FLASTUPDATEUSERID, FLASTUPDATETIME,FDataState, ").append(taxItems);
        str.append(" )");
        str.append(" values(?, ?, ?, ?, ?, ");
        str.append(" ?, ?, ?, ?, ?, ");
        str.append(" ?, ?, ?, ?, ? ");
        str.append(itemStr);
        str.append(")");
        return str.toString();
    }

    private List<Object[]> getParamListData(Context ctx, String initIds) throws BOSException {
        List<Object[]> paramsList = new ArrayList();
        StringBuilder str = new StringBuilder();
        Iterator i$ = this.allTaxItemList.iterator();

        while (i$.hasNext()) {
            String s = (String) i$.next();
            str.append(",").append(s);
        }

        String taxItem = str.toString();
        if (!this.isDelete) {
            this.getSubmittedData(ctx, initIds);
        }

        Set<String> personSet = new HashSet();
        str = new StringBuilder();
        str.append(" SELECT FCMPCALTABLEID, FPERSONID, FTAXUNITID, FPERIODBEGIN, FPERIODEND, ");
        str.append(" FINCOMEITEMID,FID,fAcceptId ").append(taxItem);
        str.append(" FROM T_HR_STAXCALINITDETAIL ");
        str.append(" WHERE FID IN (").append(initIds).append(")");
        str.append(" ORDER BY FTAXUNITID, FINCOMEITEMID, FPERSONID, FCREATETIME ");
        IRowSet rowSet = DbUtil.executeQuery(ctx, str.toString());

        try {
            while (rowSet.next()) {
                String taxUnitId = rowSet.getString("FTAXUNITID");
                String incomeItemId = rowSet.getString("FINCOMEITEMID");
                String personId = rowSet.getString("FPERSONID");
                String personKey = this.getPersonKey(taxUnitId, incomeItemId, personId);
                if (!personSet.contains(personKey)) {
                    personSet.add(personKey);
                    String taskId = (String) this.taskMap.get(taxUnitId);
                    Object[] param = this.sumLastData(rowSet, personKey, taskId);
                    paramsList.add(param);
                }
            }
        } catch (SQLException var14) {
            logger.error(var14);
        }

        return paramsList;
    }

    /**
     * @param ctx
     * @param initIds
     * @throws BOSException
     */
    private void updateTaxCalInitData(Context ctx, String initIds) throws BOSException {
        //˰Ӧ+˰ϸ 
        String sql = "UPDATE T_HR_STAXCALINITDETAIL SET FSTATE = 30 WHERE FID IN (" + initIds + ")  ";
        DbUtil.execute(ctx, sql);
    }

    private Object[] sumLastData(IRowSet rowSet, String personKey, String taskId) throws SQLException {
        Timestamp createTime = new Timestamp(System.currentTimeMillis());
        Map<String, Object> rowMap = new HashMap();
        if (this.dataMap.containsKey(personKey)) {
            rowMap = (Map) this.dataMap.get(personKey);
            Iterator i$ = this.sumTaxList.iterator();

            while (i$.hasNext()) {
                String taxItem = (String) i$.next();
                BigDecimal detail = null == rowSet.getBigDecimal(taxItem) ? BigDecimal.ZERO : rowSet.getBigDecimal(taxItem);
                BigDecimal sum = null == ((Map) rowMap).get(taxItem) ? BigDecimal.ZERO : (BigDecimal) ((Map) rowMap).get(taxItem);
                ((Map) rowMap).put(taxItem, detail.add(sum));
            }
        }

        Object[] param = new Object[15 + this.allTaxItemList.size()];
        param[0] = BOSUuid.create("01CB8082").toString();
        param[1] = taskId;
        param[2] = ((Map) rowMap).get("FCMPCALTABLEID");
        param[3] = rowSet.getString("FCMPCALTABLEID");
        param[4] = rowSet.getString("FPERSONID");
        param[5] = rowSet.getString("FTAXUNITID");
        param[6] = rowSet.getDate("FPERIODBEGIN");
        param[7] = rowSet.getDate("FPERIODEND");
        param[8] = rowSet.getString("FINCOMEITEMID");
        param[9] = rowSet.getString("fAcceptId");
        param[10] = this.userId;
        param[11] = createTime;
        param[12] = this.userId;
        param[13] = createTime;
        param[14] = this.isDelete ? 20 : 10;

        String item;
        int index;
        for (Iterator i$ = this.allTaxItemList.iterator(); i$.hasNext(); param[15 + index] = ((Map) rowMap).containsKey(item) ? ((Map) rowMap).get(item) : rowSet.getObject(item)) {
            item = (String) i$.next();
            index = this.allTaxItemList.indexOf(item);
        }
        return param;
    }

    /**
     * @param ctx
     * @param initIds ϸid
     * @throws BOSException
     */
    private void getSubmittedData(Context ctx, String initIds) throws BOSException {
        if (null != this.sumTaxList && !this.sumTaxList.isEmpty()) {
            StringBuilder str = new StringBuilder();

            String taxItem;
            for (Iterator i$ = this.sumTaxList.iterator(); i$.hasNext(); str.append("SUMDATA.").append(taxItem)) {
                taxItem = (String) i$.next();
                if (str.length() > 0) {
                    str.append(",");
                }
            }

            String sumItems = str.toString();
            str = new StringBuilder();
            str.append(" SELECT SUMDATA.FPERSONID, SUMDATA.FTAXUNITID, SUMDATA.FINCOMEITEMID,SUMDATA.FCMPCALTABLEID, ").append(sumItems);
            //˰ύ˰ݼ¼
            str.append(" FROM T_HR_STAXCALTASKDETAIL SUMDATA ");
            //˰Ӧ+˰ϸ
            str.append(" INNER JOIN T_HR_STAXCALINITDETAIL INIT ON SUMDATA.FCMPCALTABLEID = INIT.FCMPCALTABLEID and SUMDATA.fIncomeItemId = INIT.fIncomeItemId AND INIT.FSTATE = ");
            str.append(40);
            //˰Ŀ
            str.append(" INNER JOIN T_HR_STAXINCOMEITEM INCOMEITEM ON SUMDATA.FINCOMEITEMID =  INCOMEITEM.FID ");
            str.append(" WHERE EXISTS( ");
            //˰Ӧ+˰ϸ
            str.append(" SELECT 1 FROM T_HR_STAXCALINITDETAIL DETAIL ");
            str.append(" WHERE DETAIL.FID IN (").append(initIds).append(") ");
            str.append(" AND INIT.FPERSONID = DETAIL.FPERSONID AND INIT.FTAXUNITID = DETAIL.FTAXUNITID ");
            str.append(" AND INIT.FINCOMEITEMID = DETAIL.FINCOMEITEMID AND INIT.FPERIODBEGIN = DETAIL.FPERIODBEGIN) ");
            str.append(" AND SUMDATA.FDATASTATE = ").append(10);
            str.append(" AND INCOMEITEM.FTAXCALMETHOD = ").append(10);
            str.append(" ORDER BY SUMDATA.FPERSONID, SUMDATA.FTAXUNITID, SUMDATA.FINCOMEITEMID, SUMDATA.FCREATETIME DESC ");
            IRowSet rowSet = DbUtil.executeQuery(ctx, str.toString());

            try {
                while (rowSet.next()) {
                    this.combineRowData(rowSet);
                }
            } catch (SQLException var7) {
                var7.printStackTrace();
            }

        }
    }

    /**
     * ȡδͻʧԱķ¼idַ
     *
     * @param list
     */
    private String getNotReportedPersonIds(List<TaxCalBasicVO> list) {
        StringBuilder notReported = new StringBuilder();
        for (TaxCalBasicVO vo : list) {
            //Ա״̬
            String submitStatus = vo.getSubmitStatus();
            //δͻʧ
            if ("0".equals(submitStatus) || "3".equals(submitStatus)) {
                if (notReported.length() > 0) {
                    notReported.append(",");
                }
                notReported.append("'").append(vo.getEntryId()).append("'");
            }
        }
        return notReported.toString();
    }

    private String getPersonKey(String taxUnitId, String incomeItemId, String personId) {
        return taxUnitId + "_" + incomeItemId + "_" + personId;
    }


    /**
     * װ
     *
     * @param rowSet
     */
    private void combineRowData(IRowSet rowSet) {
        Map<String, Object> rowMap = new HashMap();
        String key = null;

        try {
            //˰λid-˰Ŀid-Աid
            key = this.getPersonKey(rowSet.getString("FTAXUNITID"), rowSet.getString("FINCOMEITEMID"), rowSet.getString("FPERSONID"));
            if (this.dataMap.containsKey(key)) {
                return;
            }

            Iterator i$ = this.sumTaxList.iterator();

            while (i$.hasNext()) {
                String taxItem = (String) i$.next();
                rowMap.put(taxItem, rowSet.getBigDecimal(taxItem));
            }

            rowMap.put("FCMPCALTABLEID", rowSet.getString("FCMPCALTABLEID"));
        } catch (SQLException var6) {
            var6.printStackTrace();
        }

        this.dataMap.put(key, rowMap);
    }
}