package com.kingdee.eas.custom.shuiyou.uitls;

import cn.hutool.core.lang.Snowflake;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.cron.CronUtil;
import com.google.common.collect.Maps;

import com.kingdee.bos.util.BOSUuid;
import com.kingdee.eas.custom.shuiyou.task.TaskInfo;
import org.apache.log4j.Logger;

import java.io.FileInputStream;
import java.io.IOException;
import java.util.Map;
import java.util.Properties;
import java.util.Set;

/**
 * ļ
 * description: SYUConfigUtil <br>
 * date: 2024/8/23 15:11 <br>
 * author: lhbj <br>
 * version: 1.0 <br>
 */
public class SYUConfigUtil {
    private static Logger logger =Logger.getLogger(SYUConfigUtil.class);
    private Properties propt = new Properties();//ò
    private static SYUConfigUtil instance = new SYUConfigUtil();

    public static SYUConfigUtil getInstance() {
        return instance;
    }

    private SYUConfigUtil() {
        this.initConfig(System.getProperty("EAS_HOME") + "/server/properties/sy/syConfig.properties");
    }

    public void initConfig(String filePath) {
        try {
            this.propt.load(new FileInputStream(filePath));
        }catch (IOException e){
            e.printStackTrace();
            logger.error(e);
        }
    }

    public Map<String,String> getConfig() {
        Map<String,String> map = Maps.newHashMap();
        Set<Map.Entry<Object, Object>> set = this.propt.entrySet();
        for(Map.Entry<Object, Object> entry : set){
            map.put((String)entry.getKey(),(String)entry.getValue());
        }
        return map;
    }

    public static void main(String[] args) {
        System.setProperty("EAS_HOME","D:/jingdie/yss/8.6v2jar/Project_86v2/jiuzhoutong/config");
        System.out.println(System.getProperty("EAS_HOME"));
        SYUConfigUtil sys = SYUConfigUtil.getInstance();
        sys.initConfig(System.getProperty("EAS_HOME")+"/server/properties/sy/syConfig.properties");

        System.out.println(sys.getConfig().get("cronText"));
        System.out.println( SYUCronTaskUtil.getInstance().getSnowflake().nextIdStr());
    }
}
