package com.kingdee.eas.custom.shuiyou.uitls;

import cn.hutool.core.lang.Snowflake;
import cn.hutool.core.util.StrUtil;

import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;


import com.google.common.collect.Maps;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.eas.base.permission.UserInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.shuiyou.RequestStateEnum;
import com.kingdee.eas.custom.shuiyou.RequestTypeEnum;
import com.kingdee.eas.custom.shuiyou.interfacelog.LogInfoFactory;

import com.kingdee.eas.custom.shuiyou.task.*;

import com.kingdee.shr.dydeploy.web.executeSql.ExceptionUtils;
import okhttp3.*;
import org.apache.log4j.Logger;

import javax.crypto.Mac;
import javax.crypto.spec.SecretKeySpec;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;

import com.kingdee.bos.*;


import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.sql.Timestamp;
import java.util.*;

import com.kingdee.eas.custom.shuiyou.interfacelog.LogInfoInfo;
import java.lang.String;

public class SYUtilsFacadeControllerBean extends AbstractSYUtilsFacadeControllerBean
{

    private static Logger logger =
            Logger.getLogger("com.kingdee.eas.custom.shuiyou.uitls.SYUtilsFacadeControllerBean");

    /**
     * ȡѩ
     * @param ctx
     * @return
     * @throws BOSException
     */
    @Override
    protected Snowflake _getSnowflake(Context ctx) throws BOSException {
        super._getSnowflake(ctx);
        return SYUCronTaskUtil.getInstance().getSnowflake();
    }


    /**
     * ȡҵ
     * @param ctx
     * @return
     * @throws BOSException
     */
    @Override
    protected String _getBizNo(Context ctx) throws BOSException {
        super._getBizNo(ctx);
        return this._getSnowflake(ctx).nextIdStr();
    }

    /**
     * 
     * @param ctx
     * @param url ַ
     * @param requestId id
     * @param osfServiceName صosf
     * @param backParam ص JSONObject
     * @param catalog 
     * @return
     * @throws BOSException
     */
    @Deprecated
    @Override
    protected String _backTask(Context ctx, String url, String requestId, String osfServiceName, String backParam,TaskCatalogEnum catalog) throws BOSException {
        super._backTask(ctx, url, requestId, osfServiceName, backParam,catalog);
        TaskInfo taskInfo = new TaskInfo();
        try{
            taskInfo.setId(BOSUuid.create(taskInfo.getBOSType()));
            taskInfo.setUrl(url);
            taskInfo.setRequestId(requestId);
            TaskRequestParamInfo requestParam = new TaskRequestParamInfo();
            requestParam.setTask(taskInfo);
            requestParam.setParamContent(backParam);
            IObjectPK pkp = TaskRequestParamFactory.getLocalInstance(ctx).addnew(requestParam);
            requestParam.setId(BOSUuid.read(pkp.toString()));
            taskInfo.setRequestParam(requestParam);
            taskInfo.setOsfServiceName(osfServiceName);
            taskInfo.setRequestType(RequestTypeEnum.GET);
            taskInfo.setRequestState(RequestStateEnum.NotStarted);
            taskInfo.setState(TaskStateEnum.STANDBY);
            taskInfo.setCatalog(catalog);
            TaskRequestResultInfo resultInfo = new TaskRequestResultInfo();
            resultInfo.setTask(taskInfo);
            IObjectPK pkr = TaskRequestResultFactory.getLocalInstance(ctx).addnew(resultInfo);
            resultInfo.setId(BOSUuid.read(pkr.toString()));
            taskInfo.setRequestResult(resultInfo);
            taskInfo.setName(catalog.getAlias());
            String number = SYUCronTaskUtil.getInstance().getSnowflake().nextIdStr();
            taskInfo.setNumber(number);

            IObjectPK pk = TaskFactory.getLocalInstance(ctx).addnew(taskInfo);

        } catch (Exception e){
            e.printStackTrace();
        }
        return taskInfo.getId().toString();
    }
    /**
     * post
     * @param ctx
     * @param url
     * @param param
     * @return
     * @throws BOSException
     */
    @Override
    protected String _post(Context ctx, String url, String param) throws BOSException {
        super._post(ctx, url, param);
        String result = "";
        LogInfoInfo logInfo = new LogInfoInfo();
        try {
            //־
            logInfo.setEntrance(this.getClass().getName());//
            Long timestampLong = System.currentTimeMillis();
            UserInfo userInfo = (UserInfo)ctx.get("UserInfo");
            logInfo.setCreator(userInfo);
            Timestamp timestamp = new Timestamp(timestampLong);
            logInfo.setCreateTime(timestamp);
            logInfo.setLastUpdateTime(timestamp);
            logInfo.setLastUpdateUser(userInfo);
            logInfo.setBizDate(timestamp);

            JSONObject paramMap = JSONUtil.parseObj(param);

            //ȡļ
            Map<String,String> propt = this._getConfig(ctx);
            Map signaMap = Maps.newHashMap();
            if(StrUtil.isBlank(paramMap.getStr("timestamp"))){

                signaMap.put("timestamp",String.valueOf(timestampLong));
            }else {
                signaMap.put("timestamp",paramMap.getStr("timestamp"));
            }
            if(StrUtil.isBlank(paramMap.getStr("xReqNonce"))){
                String xReqNonce = UUID.randomUUID().toString().replace("-", "");//ɵ UUID(32λ)ʱtimestamp ط
                signaMap.put("xReqNonce",xReqNonce);
            }else {
                signaMap.put("xReqNonce",paramMap.getStr("xReqNonce"));
            }
            param=JSONUtil.toJsonStr(paramMap);
            String signature = this._getSignature(ctx,propt,signaMap);
            Map<String,String> headers = new HashMap<String,String>();
            headers.put("appKey",propt.get("appKey"));
            headers.put("timestamp", (String) signaMap.get("timestamp"));
            headers.put("version",propt.get("version"));
            headers.put("xReqNonce", (String) signaMap.get("xReqNonce"));
            headers.put("signature",signature);
            OkHttpClient client = new OkHttpClient();
            RequestBody body = RequestBody.create(MediaType.parse("application/json"), param);
            Request sYRequest = new Request.Builder()
                    .url(url)
                    .post(body).headers(Headers.of(headers))
                    .build();
            Response sYResponse = client.newCall(sYRequest).execute();
            if (sYResponse.isSuccessful()) {
                result = sYResponse.body().string();
            }else {
                logInfo.setErrorInfo(sYResponse.message());//Ϣ
            }
            logInfo.setOutParameter(result);//ز
        }catch (Exception e){
            e.printStackTrace();
            logger.error(e);
            logInfo.setOutParameter( ExceptionUtils.getStackTrace(e));//ز
        }finally {
            logInfo.setInterfaceAddress(url);//ӿڵַ
            logInfo.setInterfaceName("POST");//ӿ
            logInfo.setInParameter(param);//
            this._log(ctx, logInfo);
        }
        return result;
    }

    /**
     * get
     * @param ctx
     * @param url
     * @param param JSONObject
     * @return
     * @throws BOSException
     */
    @Override
    protected String _get(Context ctx, String url, String param) throws BOSException {
        super._get(ctx, url, param);
        String result = "";
        LogInfoInfo logInfo = new LogInfoInfo();
        try {
            //־
            logInfo.setEntrance(this.getClass().getName());//
            Long timestampLong = System.currentTimeMillis();
            UserInfo userInfo = (UserInfo)ctx.get("UserInfo");
            logInfo.setCreator(userInfo);
            Timestamp timestamp = new Timestamp(timestampLong);
            logInfo.setCreateTime(timestamp);
            logInfo.setLastUpdateTime(timestamp);
            logInfo.setLastUpdateUser(userInfo);
            logInfo.setBizDate(timestamp);

            JSONObject paramMap = JSONUtil.parseObj(param);
            //ȡļ
            Map<String,String> propt = this._getConfig(ctx);
            if(StrUtil.isBlank(paramMap.getStr("timestamp"))){

                paramMap.set("timestamp",String.valueOf(timestampLong));
            }
            if(StrUtil.isBlank(paramMap.getStr("xReqNonce"))){
                String xReqNonce = UUID.randomUUID().toString().replace("-", "");//ɵ UUID(32λ)ʱtimestamp ط
                paramMap.set("xReqNonce",xReqNonce);
            }
            param=JSONUtil.toJsonStr(paramMap);
            String signature = this._getSignature(ctx,propt,paramMap);
            Map<String,String> headers = new HashMap<String,String>();
            headers.put("appKey",propt.get("appKey"));
            headers.put("timestamp",paramMap.getStr("timestamp"));
            headers.put("version",propt.get("version"));
            headers.put("xReqNonce",paramMap.getStr("xReqNonce"));
            headers.put("signature",signature);
            OkHttpClient client = new OkHttpClient();
            HttpUrl.Builder urlBuilder = HttpUrl.parse(url).newBuilder();
            for(Map.Entry<String,Object> entry : paramMap.entrySet() ){
                Optional<Object> op = Optional.ofNullable(entry.getValue());
                urlBuilder.addQueryParameter(entry.getKey(), op.orElse("").toString());
            }
            url = urlBuilder.build().toString();
            Request sYRequest = new Request.Builder()
                    .url(url).headers(Headers.of(headers))
                    .get()
                    .build();
            Response sYResponse = client.newCall(sYRequest).execute();
            if (sYResponse.isSuccessful()) {
                result = sYResponse.body().string();
            }else {
                logInfo.setErrorInfo(sYResponse.message());//Ϣ
            }
        }catch (IOException e){
            //e.printStackTrace();
            logger.error(e);
            logInfo.setErrorInfo(e.getMessage());//ӿڵַ
        }finally {
            logInfo.setInterfaceAddress(url);//ӿڵַ
            logInfo.setInterfaceName("GET");//ӿ
            logInfo.setInParameter(param);//
            logInfo.setOutParameter(result);//ز
            this._log(ctx,logInfo);
        }
        return result;
    }




    @Override
    protected String _getSignature(Context ctx, Map propt,Map paramMap) throws BOSException {
        logger.error("====ȡǩ===뵽com.kingdee.eas.custom.jiuzhoutong.utils.SYUtils.getSignature=======");
        TreeMap<String, String> treeMap = new TreeMap<>();

        String version = (String) propt.get("version");//汾
        String appKey = (String) propt.get("appKey");//ݱʶ
        String appSecret = (String) propt.get("appSecret");//Կ
        logger.error("=============================");
        logger.error("version"+version);
        logger.error("param"+paramMap.toString());
        logger.error("appSecret"+appSecret);
        logger.error("==================================");
        treeMap.put("appKey", appKey);
        treeMap.put("appSecret", appSecret);
        treeMap.put("version", version);
        for(Object obj : paramMap.entrySet()){
           Map.Entry<String, Object> entry = (Map.Entry<String, Object>) obj;
           treeMap.put(entry.getKey(), StrUtil.toString(entry.getValue()));
        }
        StringBuilder mergeStr = new StringBuilder();
        for (Map.Entry<String, String> stringStringEntry : treeMap.entrySet()) {
            mergeStr.append(stringStringEntry.getValue());
        }
        logger.error("key=valueԵvalueкϲ,һַmergeStr"+mergeStr.toString());
        String encodedStr = null;
        try {
            encodedStr = URLEncoder.encode(mergeStr.toString(), "UTF-8");
        } catch (UnsupportedEncodingException e) {
            // URL ʧ
            e.printStackTrace();
            throw new RuntimeException("urlʧ");
        }
        logger.error("ɵmergeStrUrl룺"+encodedStr);

        // 4.HmacSHA256㷨signStrйϣϢժҪ,ժҪBase64ʽأsignStrΪеsignatureֶ
        String signatureResult = "";
        try {
            Mac mac = Mac.getInstance("HmacSHA256");
            SecretKeySpec signingKey = new SecretKeySpec(appSecret.getBytes(), "HmacSHA256");
            mac.init(signingKey);
            byte[] signData = mac.doFinal(encodedStr.getBytes());
            byte[] resultBytes = Base64.getEncoder().encode(signData);
            signatureResult = new String(resultBytes, "UTF-8");
        } catch (NoSuchAlgorithmException e) {
            throw new RuntimeException("ƽ̨֧ HmacSHA ժҪʽ");
        } catch (InvalidKeyException e) {
            throw new RuntimeException("Speicified access secret is not valid.");
        } catch (UnsupportedEncodingException e) {
            throw new RuntimeException("תʧ");
        }
        logger.error("HmacSHA256㷨signStrйϣϢժҪ,ժҪBase64ʽأsignStrΪеsignatureֶ"+signatureResult);
        logger.error("==========================˳================================");
        return signatureResult;
    }
    /**
     * ǩ
     * @param ctx
     * @param param
     * @return
     * @throws BOSException
     */
    @Override
    protected String _getSignature(Context ctx, String param) throws BOSException {
        super._getSignature(ctx, param);
        JSONObject paramMap = JSONUtil.parseObj(param);
        return this._getSignature(ctx,this._getConfig(ctx),paramMap);
    }

    /**
     * /ļ
     * /server/properties/sy/syConfig.properties
     * @param ctx
     * @param filePath
     * @throws BOSException
     */
    @Override
    protected void _initConfig(Context ctx, String filePath) throws BOSException {
        super._initConfig(ctx, filePath);
        //ļ
        SYUConfigUtil.getInstance().initConfig(filePath);
        //º̨ʱʱ
        SYUCronTaskUtil.getInstance().refreshPropt();
    }

    /**
     * ־
     * @param ctx
     * @param logInfo
     * @return
     * @throws BOSException
     */
    @Override
    protected LogInfoInfo _log(Context ctx, LogInfoInfo logInfo) throws BOSException {
        try {
            super._log(ctx, logInfo);
            IObjectPK pk = LogInfoFactory.getLocalInstance(ctx).save(logInfo);
            logInfo.setId(BOSUuid.read(pk.toString()));
        }catch (EASBizException e) {
            //e.printStackTrace();
            logger.error(e);
        }
        return logInfo;
    }

    /**
     * ȡļ
     * @param ctx
     * @return
     * @throws BOSException
     */
    @Override
    protected Map _getConfig(Context ctx) throws BOSException {
        super._getConfig(ctx);
        Map map = SYUConfigUtil.getInstance().getConfig();
        return map;
    }
    /**
     * 
     * @param ctx
     * @param param JSONObject
     * @param osfServiceName osf
     * @param catalog 
     * @param taskPreId  ǰid
     * @param sourceBillId  Դid
     * @return
     * @throws BOSException
     */
    @Override
    protected String _addTask(Context ctx, String osfServiceName,String param, TaskCatalogEnum catalog, String taskPreId,String sourceBillId) throws BOSException {
       super._addTask(ctx,osfServiceName, param, catalog, taskPreId, sourceBillId);
        TaskInfo taskInfo = new TaskInfo();
        try{
            if(StrUtil.isNotBlank(taskPreId)) {
                TaskInfo taskPreInfo = new TaskInfo();
                taskPreInfo.setId(BOSUuid.read(taskPreId));
                taskInfo.setTaskPre(taskPreInfo);
            }
            taskInfo.setSourceBillId(sourceBillId);
            taskInfo.setId(BOSUuid.create(taskInfo.getBOSType()));
            TaskRequestParamInfo requestParam = new TaskRequestParamInfo();
            requestParam.setTask(taskInfo);
            requestParam.setParamContent(param);
            IObjectPK pkp = TaskRequestParamFactory.getLocalInstance(ctx).addnew(requestParam);
            requestParam.setId(BOSUuid.read(pkp.toString()));
            taskInfo.setRequestParam(requestParam);
            taskInfo.setOsfServiceName(osfServiceName);
            taskInfo.setRequestState(RequestStateEnum.NotStarted);
            taskInfo.setState(TaskStateEnum.STANDBY);
            taskInfo.setCatalog(catalog);
            TaskRequestResultInfo resultInfo = new TaskRequestResultInfo();
            resultInfo.setTask(taskInfo);
            IObjectPK pkr = TaskRequestResultFactory.getLocalInstance(ctx).addnew(resultInfo);
            resultInfo.setId(BOSUuid.read(pkr.toString()));
            taskInfo.setRequestResult(resultInfo);
            taskInfo.setName(catalog.getAlias());
            String number = SYUCronTaskUtil.getInstance().getSnowflake().nextIdStr();
            taskInfo.setNumber(number);
            IObjectPK pk = TaskFactory.getLocalInstance(ctx).addnew(taskInfo);
        } catch (Exception e){
            logger.error(e);
        }
        return taskInfo.getId().toString();
    }
    /**
     * 
     * @param ctx
     * @param param JSONObject
     * @param osfServiceName osf
     * @param catalog 
     * @param taskPreId  ǰid
     * @return
     * @throws BOSException
     */
    @Override
    protected String _addTask(Context ctx, String osfServiceName,String param, TaskCatalogEnum catalog, String taskPreId) throws BOSException {
        super._addTask(ctx,osfServiceName, param, catalog, taskPreId);
        return this._addTask(ctx,osfServiceName,param,catalog,taskPreId,"");
    }

    /**
     * ɾ
     * @param ctx
     * @param taskId
     * @return
     * @throws BOSException
     */
    @Deprecated
    @Override
    protected boolean _delTask(Context ctx, String taskId) throws BOSException {
        super._delTask(ctx, taskId);
        boolean isSe = true;
        try {
            ObjectUuidPK pk = new ObjectUuidPK(taskId);
            ITask iTask = TaskFactory.getLocalInstance(ctx);
            //ɾǰ
            EntityViewInfo viewInfo = new EntityViewInfo();
            SelectorItemCollection sc = new SelectorItemCollection();
            sc.add(new SelectorItemInfo("id"));
            sc.add(new SelectorItemInfo("taskPre.id"));
            viewInfo.setSelector(sc);
            FilterInfo filterInfo = new FilterInfo();
            filterInfo.getFilterItems().add(new FilterItemInfo("id", taskId, CompareType.EQUALS));
            viewInfo.setFilter(filterInfo);
            TaskCollection collection = iTask.getTaskCollection(viewInfo);
            for(int i=0;i<collection.size();i++){
                TaskInfo taskInfo = collection.get(i);
                Optional<TaskInfo> op = Optional.ofNullable(taskInfo.getTaskPre());
                BOSUuid uuid = op.orElse(new TaskInfo()).getId();
                if(null!=uuid) {
                    FilterInfo delFilterInfo = new FilterInfo();
                    delFilterInfo.getFilterItems().add(new FilterItemInfo("id", uuid.toString(), CompareType.EQUALS));
                    iTask.delete(delFilterInfo);
                }
            }
            //ɾ
            FilterInfo filterNextInfo = new FilterInfo();
            filterNextInfo.getFilterItems().add(new FilterItemInfo("taskPre.id", taskId, CompareType.EQUALS));
            iTask.delete(filterNextInfo);
            //ɾǰ
            iTask.delete(filterInfo);
        }catch (Exception e){
            //e.printStackTrace();
            logger.error(e);
            isSe=false;
        }finally {

        }
        return isSe;
    }
}