package com.kingdee.eas.custom.compensation.handler;

import cn.com.servyou.dto.ApiResponse;
import cn.com.servyou.dto.AsyncResult;
import cn.com.servyou.dto.tax.*;
import cn.com.servyou.rmi.client.ClientProxyFactory;
import cn.com.servyou.service.TaxRequest;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.metadata.entity.EntityViewInfo;
import com.kingdee.bos.metadata.entity.FilterInfo;
import com.kingdee.bos.metadata.entity.FilterItemInfo;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.eas.basedata.hraux.NationalityInfo;
import com.kingdee.eas.basedata.person.IPerson;
import com.kingdee.eas.basedata.person.PersonFactory;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.compensation.vo.TaxUnitAndPerson;
import com.kingdee.eas.custom.individualback.ITaxPaymentBackCalculate;
import com.kingdee.eas.custom.individualback.TaxPaymentBackCalculateCollection;
import com.kingdee.eas.custom.individualback.TaxPaymentBackCalculateFactory;
import com.kingdee.eas.custom.individualback.TaxPaymentBackCalculateInfo;
import com.kingdee.eas.custom.shuiyou.interfacelog.LogInfoFactory;
import com.kingdee.eas.custom.shuiyou.interfacelog.LogInfoInfo;
import com.kingdee.eas.custom.shuiyou.six.osf.vo.SixTConfirmInfo;
import com.kingdee.eas.custom.shuiyou.task.TaskCatalogEnum;
import com.kingdee.eas.custom.shuiyou.uitls.ISYUtilsFacade;
import com.kingdee.eas.custom.shuiyou.uitls.SYUtilsFacadeFactory;
import com.kingdee.eas.custom.shuiyou.utils.ClientProxyFactoryUtils;
import com.kingdee.eas.hr.emp.IPersonPosition;
import com.kingdee.eas.hr.emp.PersonPositionCollection;
import com.kingdee.eas.hr.emp.PersonPositionFactory;
import com.kingdee.eas.hr.emp.PersonPositionInfo;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.exception.ShrWebBizException;
import com.kingdee.shr.base.syssetting.web.json.JSONUtils;
import com.kingdee.shr.compensation.*;
import com.kingdee.shr.compensation.app.incomeTax.*;
import com.kingdee.shr.compensation.app.tax.ITaxUnit;
import com.kingdee.shr.compensation.app.tax.TaxItemPlanInfo;
import com.kingdee.shr.compensation.app.tax.TaxUnitFactory;
import com.kingdee.shr.compensation.app.tax.TaxUnitInfo;
import com.kingdee.shr.custom.compensation.accrue.handler.CmpCalDynamicListHandlerExEx;
import com.kingdee.util.StringUtils;
import org.apache.log4j.Logger;
import org.springframework.ui.ModelMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.math.BigDecimal;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.*;

/**
 * @author qingwu
 * @date 2024/8/30
 * @apiNote BackCalculateService   TaxPaymentBackCalculate
 */
public class CmpCalDynamicListHandlerExExEx extends CmpCalDynamicListHandlerExEx {
    private Context ctx = SHRContext.getInstance().getContext();
    Logger logger = Logger.getLogger("com.kingdee.eas.custom.compensation.handler.CmpCalDynamicListHandlerExExEx");

    /**
     * ͬ
     *
     * @param request
     * @param response
     * @param modelMap
     * @throws SHRWebException
     * @throws BOSException
     * @throws EASBizException
     */
    public void taxPaymentBackSynAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws SHRWebException, BOSException {
        logger.error("taxPaymentBackSynAction---------starst-------------");
        //ID
        String cmpschemeid = request.getParameter("cmpschemeid");
        if (StringUtils.isEmpty(cmpschemeid)) {
            throw new ShrWebBizException("IDΪգ");
        }
        Map msgMap = new HashMap();
        try {
            //нĿ
            Map cmpItemMap = new HashMap();
            ICmpItem iCmpItem = CmpItemFactory.getLocalInstance(ctx);
            //GS014:¸˰  JZT02:˰Ӧ
            CmpItemCollection cmpItemCollection = iCmpItem.getCmpItemCollection("where number in ('GS014','JZT02')");
            for (int i = 0; i < cmpItemCollection.size(); i++) {
                CmpItemInfo cmpItemInfo = cmpItemCollection.get(i);
                cmpItemMap.put(cmpItemInfo.getNumber(), cmpItemInfo.getFieldSn());
            }
            logger.error("cmpItemMap----------------------" + cmpItemMap);
            //˰
            ITaxPaymentBackCalculate iTaxPaymentBackCalculate = TaxPaymentBackCalculateFactory.getLocalInstance(ctx);
            TaxPaymentBackCalculateCollection taxPaymentBackCalculateCollection = iTaxPaymentBackCalculate.getTaxPaymentBackCalculateCollection("where cmpscheme = '" + cmpschemeid + "'");
            if (taxPaymentBackCalculateCollection.size() <= 0) {
                throw new ShrWebBizException("˰δҵüݣ˰ύͬ");
            }
            for (int i = 0; i < taxPaymentBackCalculateCollection.size(); i++) {
                TaxPaymentBackCalculateInfo taxPaymentBackCalculateInfo = taxPaymentBackCalculateCollection.get(i);
                //˰Ӧ
                BigDecimal salarySum = taxPaymentBackCalculateInfo.getSalarySum();
                //¸˰
                BigDecimal individual = taxPaymentBackCalculateInfo.getIndividual();
                //ԱϢ
                PersonInfo person = taxPaymentBackCalculateInfo.getPerson();
                //
                CalSchemeInfo cmpscheme = taxPaymentBackCalculateInfo.getCmpscheme();
                // ˰Ӧ   ˰Ӧ  ¸˰  ¸˰ ID ԱID
                String updateSql = String.format("update T_HR_SCmpCalTable set s%s = '%s'  , s%s = '%s' where  FCALSCHEMEID = '%s' and FPERSONID = '%s'",
                        cmpItemMap.get("JZT02"), salarySum.toString(), cmpItemMap.get("GS014"), individual, cmpscheme.getId(), person.getId());
                logger.error("updateSql---------" + updateSql);
                DbUtil.execute(ctx, updateSql);
                //String updateSql = "select * from T_HR_SCmpCalTable where FCALSCHEMEID = 'FqEAAAe2vAv/zfKx' and FPERSONID = '383Uzn7KSea0Y+B08YP6qIDvfe0='";
                //update T_HR_SCmpCalTable set s1 , s2 where  FCALSCHEMEID = '' and FPERSONID = ''
            }
            msgMap.put("msg", "ͬɹ");
            JSONUtils.SUCCESS(msgMap);
        } catch (Exception e) {
            e.printStackTrace();
            throw new ShrWebBizException(e);

        }
    }

    /**
     * ˰
     *
     * @param request
     * @param response
     * @param modelMap
     * @throws ShrWebBizException
     * @throws BOSException
     */
    public void taxPaymentBackCalculateAction(HttpServletRequest request, HttpServletResponse response, ModelMap
            modelMap) throws SHRWebException, BOSException, EASBizException {
        //ID
        String cmpschemeid = request.getParameter("cmpschemeid");
        if (StringUtils.isEmpty(cmpschemeid)) {
            throw new ShrWebBizException("IDΪգ");
        }
        Map rseMap = new HashMap();
        List resList = new ArrayList();
        //ӿ־ʵ
        LogInfoInfo logInfo = new LogInfoInfo();
        //
        logInfo.setEntrance(this.getClass().getName());
        logInfo.setBizDate(new Date());
        try {
            //
            ICalScheme iCalScheme = CalSchemeFactory.getLocalInstance(ctx);
            ITaxUnit iTaxUnit = TaxUnitFactory.getLocalInstance(ctx);
            IPerson iPerson = PersonFactory.getLocalInstance(ctx);
            SelectorItemCollection sic = new SelectorItemCollection();
            sic.add("taxItemPlanList.taxItemPlan.name");
            sic.add("taxItemPlanList.taxItemPlan.number");
            sic.add("*");
            FilterInfo filterInfo = new FilterInfo();
            filterInfo.getFilterItems().add(new FilterItemInfo("id", cmpschemeid, CompareType.EQUALS));
            EntityViewInfo entityViewInfo = EntityViewInfo.getInstance(filterInfo, sic, null);
            CalSchemeInfo calSchemeInfo = iCalScheme.getCalSchemeCollection(entityViewInfo).get(0);
            //ȡǰн
            CmpCalTableCollection cmpCalTableCollection = getCalSchemeColl(calSchemeInfo.getId().toString(), calSchemeInfo.getPeriodYear(), calSchemeInfo.getPeriodMonth());
            logger.error("cmpCalTableCollection--------" + cmpCalTableCollection.size());
            //ȡ˺˰λ
            List<TaxUnitAndPerson> taxUnitAndPeople = new ArrayList();
            if (cmpCalTableCollection.size() > 0) {
                for (int i = 0; i < cmpCalTableCollection.size(); i++) {
                    String personId = cmpCalTableCollection.get(i).getPerson().getId().toString();
                    //ѯǷ˰ʵ
                    Integer abroadIncome = getAbroadIncome(personId, cmpschemeid);
                    logger.error("abroadIncome-----------" + personId + "--------------" + cmpschemeid);
                    logger.error("abroadIncome-----------" + abroadIncome);
                    if (abroadIncome != null && abroadIncome != 0) {
                        //ȡ˰λ
                        String sql = getSalaryOrgMappingByPersonId(personId);
                        logger.error("getSalaryOrgMappingByPersonId--------" + sql);
                        IRowSet iRowSet = DbUtil.executeQuery(ctx, sql);
                        String taxUnitId = null;
                        while (iRowSet.next()) {
                            taxUnitId = iRowSet.getString("taxunit");
                        }
                        if (!StringUtils.isEmpty(taxUnitId)) {
                            //throw new ShrWebBizException("ԱID:" + personId + "δȡ˰λ");
                            TaxUnitAndPerson taxUnitAndPerson = new TaxUnitAndPerson(taxUnitId, personId);
                            taxUnitAndPeople.add(taxUnitAndPerson);
                        }
                    }
                }
            }
            logger.error("taxUnitAndPeople-----------" + taxUnitAndPeople);
            //    ͨ˰λ
            Map<String, List<TaxUnitAndPerson>> groupedPeople = new HashMap<>();
            for (TaxUnitAndPerson taxUnitAndPerson : taxUnitAndPeople) {
                String taxunitId = taxUnitAndPerson.getTaxunitId();
                if (!groupedPeople.containsKey(taxunitId)) {
                    groupedPeople.put(taxunitId, new ArrayList<>());
                }
                groupedPeople.get(taxunitId).add(taxUnitAndPerson);
            }
            logger.error("groupedPeople-----------" + groupedPeople);
            // 
            for (Map.Entry<String, List<TaxUnitAndPerson>> entry : groupedPeople.entrySet()) {
                logger.error("------------start");
                logger.error("taxunitId: " + entry.getKey());
                //Զ 
                SixTConfirmInfo sixTConfirmInfo = new SixTConfirmInfo();
                //ⲿҵ
                sixTConfirmInfo.setBizNo(UUID.randomUUID().toString().replace("-", ""));
                //˰λ
                String taxunitId = entry.getKey();
                TaxUnitInfo taxUnitInfo = iTaxUnit.getTaxUnitInfo("where id = '" + taxunitId + "'");
                //˰
                TaxItemPlanInfo taxItemPlan = calSchemeInfo.getTaxItemPlanList().get(0).getTaxItemPlan();
                String taxItemPlanNumber = taxItemPlan.getNumber();
                String taxItemPlanName = taxItemPlan.getName();
                JSONObject jsonObject = new JSONObject();
                jsonObject.put("periodYear", calSchemeInfo.getPeriodYear());
                jsonObject.put("periodMonth", calSchemeInfo.getPeriodMonth());
                jsonObject.put("cmpschemeid", cmpschemeid);
                jsonObject.put("taxItemPlanName", taxItemPlanName);
                jsonObject.put("taxItemPlanNumber", taxItemPlanNumber);
                logger.error("jsonObject-------------" + jsonObject);
                //
                ClientProxyFactory clientProxyFactory = ClientProxyFactoryUtils.getClientProxyFactory();
                //˰ӿ
                TaxRequest taxRequest = clientProxyFactory.getTaxRequest();
                //ȡ
                CalculateIndividualIncomeTaxRequest calculateIndividualIncomeTaxRequest = getCalculateIndividualIncomeTaxRequest(entry, taxUnitInfo, taxItemPlanNumber, taxItemPlanName, cmpschemeid, logInfo);
                //÷ӿ
                ApiResponse<AsyncResult> asyncResultApiResponse = clientProxyFactory.getTaxRequest().reverseCalculateASynIndividualIncomeTax(calculateIndividualIncomeTaxRequest);
                logger.error("asyncResultApiResponse-----getCode-------" + asyncResultApiResponse.getHead().getCode());
                logger.error("asyncResultApiResponse-----getMsg--------" + asyncResultApiResponse.getHead().getMsg());
                if (asyncResultApiResponse.getHead().getCode().equals("00000000")) {
                    AsyncResult body = asyncResultApiResponse.getBody();
                    String requestId = body.getRequestId();
                    logger.error("requestId-----" + requestId);
                    //ѯ㷴
                    ISYUtilsFacade isyUtilsFacade = SYUtilsFacadeFactory.getLocalInstance(ctx);
                    //backTask(url,requestId,صosf,Զ,)
                    //isyUtilsFacade.backTask(isyUtilsFacade.getConfig().get("ip") + "/gateway/iit/reverseCalculateTax/getASynIndividualIncomeTaxFeedback", requestId, "synIndividualIncomeTaxService", jsonObject.toString(), TaskCatalogEnum.CAL_GET);
                    JSONObject json = new JSONObject();
                    json.put("requestId", requestId);
                    json.put("param", jsonObject.toString());
                    isyUtilsFacade.addTask("synIndividualIncomeTaxService", json.toJSONString(), TaskCatalogEnum.UN_CAL_GET, "");
                    //isyUtilsFacade.backTask("https://test-openapi.17win.com/gateway/iit/reverseCalculateTax/getASynIndividualIncomeTaxFeedback", requestId, "synIndividualIncomeTaxService", jsonObject.toString(), TaskCatalogEnum.CAL_GET);
                    //ѯ㷴
                    //ISYUtilsFacade isyUtilsFacade = SYUtilsFacadeFactory.getLocalInstance(ctx);
                    //backTask(url,requestId,صosf,Զ,)
                    //isyUtilsFacade.backTask(isyUtilsFacade.getConfig().get("ip") + "/gateway/iit/reverseCalculateTax/getASynIndividualIncomeTaxFeedback", requestId, "synIndividualIncomeTaxService", "", TaskCatalogEnum.CAL_GET);
                    //isyUtilsFacade.backTask("https://test-openapi.17win.com/gateway/iit/reverseCalculateTax/getASynIndividualIncomeTaxFeedback", requestId, "synIndividualIncomeTaxService", jsonObject.toString(), TaskCatalogEnum.CAL_GET);
                    //ApiResponse<CalculateTaxResultRequest> aSynIndividualIncomeTaxFeedback = null;
                    //boolean istrue = true;
                    //while (istrue) {
                    //    //ApiResponse<CalculateTaxResultRequest> aSynIndividualIncomeTaxFeedback = taxRequest.getReverseASynIndividualIncomeTaxFeedback(requestId);
                    //    aSynIndividualIncomeTaxFeedback = taxRequest.getReverseASynIndividualIncomeTaxFeedback(requestId);
                    //    //ApiResponse<CalculateTaxResultRequest> aSynIndividualIncomeTaxFeedback =taxRequest.getReverseASynIndividualIncomeTaxFeedback("9a538f46af784ec6b78fa6e2e10e7037");
                    //    String code = aSynIndividualIncomeTaxFeedback.getHead().getCode();
                    //    if (!"100004".equals(code)) {
                    //        istrue = false;
                    //    }
                    //    logger.error("getCode---" + aSynIndividualIncomeTaxFeedback.getHead().getCode());
                    //    logger.error("getMsg---" + aSynIndividualIncomeTaxFeedback.getHead().getMsg());
                    //    // ȴһʱٽһѯΪ 5 루5000 룩
                    //    Thread.sleep(3000);
                    //}
                    //CalculateTaxResultRequest resBody = aSynIndividualIncomeTaxFeedback.getBody();
                    ////˰㱣淽
                    //String saveId = addTaxPaymentBackCalculate(resBody, jsonObject);
                    //resList.add(saveId);
                }
            }
            rseMap.put("msg", "ִ̨У");
        } catch (Exception e) {
            e.printStackTrace();
            logInfo.setErrorInfo(e.getMessage());//Ϣ
            LogInfoFactory.getLocalInstance(ctx).save(logInfo);
            rseMap.put("msg", e.getMessage());
            throw new SHRWebException(e);
        }
        JSONUtils.SUCCESS(rseMap);
    }

    /**
     * ȡ
     *
     * @param entry
     * @param taxUnitInfo
     * @param taxItemPlanNumber
     * @param taxItemPlanName
     * @param cmpschemeid
     * @param logInfo
     * @throws BOSException
     * @throws EASBizException
     * @throws SQLException
     * @throws JsonProcessingException
     */
    private CalculateIndividualIncomeTaxRequest getCalculateIndividualIncomeTaxRequest
    (Map.Entry<String, List<TaxUnitAndPerson>> entry, TaxUnitInfo taxUnitInfo, String taxItemPlanNumber, String
            taxItemPlanName, String cmpschemeid, LogInfoInfo logInfo) throws
            BOSException, EASBizException, SQLException, JsonProcessingException {
        CalculateIndividualIncomeTaxRequest calculateIndividualIncomeTaxRequest = new CalculateIndividualIncomeTaxRequest();
        //ⲿҵ
        String replace = UUID.randomUUID().toString().replace("-", "");
        logger.error("BizNo" + replace);
        calculateIndividualIncomeTaxRequest.setBizNo(replace);
        //ҵƣ˰λ
        calculateIndividualIncomeTaxRequest.setName(taxUnitInfo.getName());
        //calculateIndividualIncomeTaxRequest.setName("ݾͨҽҩ޹˾00");
        //걨
        logger.error("taxUnitInfo----" + taxUnitInfo);
        logger.error("declPassword----" + taxUnitInfo.getDeclPassword());
        String sbmm = new String(Base64.getDecoder().decode(taxUnitInfo.getDeclPassword()));
        //String sbmm = new String(Base64.getDecoder().decode("QWExMjM0NTY="));
        logger.error("sbmm----" + sbmm);
        calculateIndividualIncomeTaxRequest.setDeclarePassword(sbmm);
        //
        calculateIndividualIncomeTaxRequest.setPasswordType(null);
        //ʵ˺
        calculateIndividualIncomeTaxRequest.setRealNameAccount(null);
        //ʵ
        calculateIndividualIncomeTaxRequest.setRealNamePassword(null);
        //ʵ
        calculateIndividualIncomeTaxRequest.setEncryptedRealNamePassword(null);
        //Ǽ
        calculateIndividualIncomeTaxRequest.setRegistrationNumber(taxUnitInfo.getRegNumber());
        //calculateIndividualIncomeTaxRequest.setRegistrationNumber("10117310124834931897");
        //˰
        calculateIndividualIncomeTaxRequest.setTaxNo(taxUnitInfo.getTaxNumber());
        //calculateIndividualIncomeTaxRequest.setTaxNo("91310124834931897I");
        //
        calculateIndividualIncomeTaxRequest.setArea(taxUnitInfo.getAreaCode());
        //calculateIndividualIncomeTaxRequest.setArea("310101");
        //ű
        calculateIndividualIncomeTaxRequest.setDeptNo(null);
        //
        calculateIndividualIncomeTaxRequest.setDeptName(null);
        //˰
        //ȡǰ
        LocalDateTime now = LocalDateTime.now();
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyyMM");
        String formattedDate = now.format(formatter);
        calculateIndividualIncomeTaxRequest.setMonth(formattedDate);
        //ȡԱ
        IPersonPosition iPersonPosition = PersonPositionFactory.getLocalInstance(ctx);
        Set personIds = new HashSet();
        for (TaxUnitAndPerson taxUnitAndPerson : entry.getValue()) {
            logger.error("personId" + taxUnitAndPerson.getPersonId());
            String personId = taxUnitAndPerson.getPersonId();
            personIds.add(personId);
        }
        FilterInfo personFilterInfo = new FilterInfo();
        personFilterInfo.getFilterItems().add(new FilterItemInfo("person.id", personIds, CompareType.INCLUDE));
        SelectorItemCollection personSic = new SelectorItemCollection();
        personSic.add("*");
        personSic.add("person.*");
        personSic.add("person.employeeType.*");
        personSic.add("person.nationality.*");
        EntityViewInfo personEntityViewInfo = EntityViewInfo.getInstance(personFilterInfo, personSic, null);
        PersonPositionCollection personPositionCollection = iPersonPosition.getPersonPositionCollection(personEntityViewInfo);
        logger.error("personPositionCollection------------size" + personPositionCollection.size());
        //ۺö
        ComplexIncomeRequest complexIncomeRequest = getComplexIncomeRequest(taxItemPlanNumber, taxItemPlanName, personPositionCollection, cmpschemeid, taxUnitInfo);
        logger.error("complexIncomeRequest------------" + complexIncomeRequest);
        //ۺ
        calculateIndividualIncomeTaxRequest.setComplexIncomeRequest(complexIncomeRequest);
        //Ǿ
        //NonResidentsIncomeRequest nonResidentsIncomeRequest = getNonResidentsIncomeRequest(taxItemPlanName, personInfo, cmpschemeid);
        logger.error("------------end");
        logInfo.setInterfaceAddress("gateway/iit/reverseCalculateTax/calculateASynIndividualIncomeTax");//ӿڵַ
        logInfo.setInterfaceName("calculateASynIndividualIncomeTax");//ӿ
        ObjectMapper mapper = new ObjectMapper();
        logger.error("calculateIndividualIncomeTaxRequest------------" + mapper.writeValueAsString(calculateIndividualIncomeTaxRequest));
        logInfo.setInParameter(mapper.writeValueAsString(calculateIndividualIncomeTaxRequest));//
        return calculateIndividualIncomeTaxRequest;
    }
    ///**
    // * ˰
    // *
    // * @param request
    // * @param response
    // * @param modelMap
    // * @throws ShrWebBizException
    // * @throws BOSException
    // */
    //public void taxPaymentBackCalculateAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws SHRWebException, BOSException, SQLException, EASBizException, InterruptedException {
    //    //ID
    //    String cmpschemeid = request.getParameter("cmpschemeid");
    //    if (StringUtils.isEmpty(cmpschemeid)) {
    //        throw new ShrWebBizException("IDΪգ");
    //    }
    //    //
    //    ICalScheme iCalScheme = CalSchemeFactory.getLocalInstance(ctx);
    //    ITaxUnit iTaxUnit = TaxUnitFactory.getLocalInstance(ctx);
    //    IPerson iPerson = PersonFactory.getLocalInstance(ctx);
    //    SelectorItemCollection sic = new SelectorItemCollection();
    //    sic.add("taxItemPlanList.taxItemPlan.name");
    //    sic.add("taxItemPlanList.taxItemPlan.number");
    //    sic.add("*");
    //    FilterInfo filterInfo = new FilterInfo();
    //    filterInfo.getFilterItems().add(new FilterItemInfo("id", cmpschemeid, CompareType.EQUALS));
    //    EntityViewInfo entityViewInfo = EntityViewInfo.getInstance(filterInfo, sic, null);
    //    CalSchemeInfo calSchemeInfo = iCalScheme.getCalSchemeCollection(entityViewInfo).get(0);
    //    //ȡǰн
    //    CmpCalTableCollection cmpCalTableCollection = getCalSchemeColl(calSchemeInfo.getId().toString(), calSchemeInfo.getPeriodYear(), calSchemeInfo.getPeriodMonth());
    //    logger.error("cmpCalTableCollection--------" + cmpCalTableCollection.size());
    //    Map rseMap = new HashMap();
    //    List resList = new ArrayList();
    //    if (cmpCalTableCollection.size() > 0) {
    //        for (int i = 0; i < cmpCalTableCollection.size(); i++) {
    //            String personId = cmpCalTableCollection.get(i).getPerson().getId().toString();
    //            //Զ 
    //            SixTConfirmInfo sixTConfirmInfo = new SixTConfirmInfo();
    //            //ⲿҵ
    //            sixTConfirmInfo.setBizNo(UUID.randomUUID().toString().replace("-", ""));
    //            //ȡ˰λ
    //            String sql = getSalaryOrgMappingByPersonId(personId);
    //            logger.error("getSalaryOrgMappingByPersonId--------" + sql);
    //            IRowSet iRowSet = DbUtil.executeQuery(ctx, sql);
    //            if (iRowSet.size() <= 0) {
    //                throw new ShrWebBizException("ԱID:" + personId + "δȡ˰λ");
    //            }
    //            TaxUnitInfo taxUnitInfo = null;
    //            while (iRowSet.next()) {
    //                taxUnitInfo = iTaxUnit.getTaxUnitInfo("where id = '" + iRowSet.getString("taxunit") + "'");
    //            }
    //            //˰
    //            TaxItemPlanInfo taxItemPlan = calSchemeInfo.getTaxItemPlanList().get(0).getTaxItemPlan();
    //            String taxItemPlanNumber = taxItemPlan.getNumber();
    //            String taxItemPlanName = taxItemPlan.getName();
    //            //String taxItemPlanNumber = "2024083001";
    //            JSONObject jsonObject = new JSONObject();
    //            jsonObject.put("personId", personId);
    //            jsonObject.put("periodYear", calSchemeInfo.getPeriodYear());
    //            jsonObject.put("periodMonth", calSchemeInfo.getPeriodMonth());
    //            jsonObject.put("cmpschemeid", cmpschemeid);
    //            jsonObject.put("taxItemPlanName", taxItemPlanName);
    //            jsonObject.put("taxItemPlanNumber", taxItemPlanNumber);
    //            logger.error("jsonObject-------------" + jsonObject);
    //            ClientProxyFactory clientProxyFactory = new ClientProxyFactory(
    //                    "46639607259987202405271637080",
    //                    "oTmd/QGL2xOfIKItqFGKnw==",
    //                    "https://test-openapi.17win.com");
    //            //
    //            //˰ӿ
    //            TaxRequest taxRequest = clientProxyFactory.getTaxRequest();
    //            CalculateIndividualIncomeTaxRequest calculateIndividualIncomeTaxRequest = new CalculateIndividualIncomeTaxRequest();
    //            //ⲿҵ
    //            String replace = UUID.randomUUID().toString().replace("-", "");
    //            logger.error("BizNo" + replace);
    //            calculateIndividualIncomeTaxRequest.setBizNo(replace);
    //            //ҵƣ˰λ
    //            calculateIndividualIncomeTaxRequest.setName(taxUnitInfo.getName());
    //            //calculateIndividualIncomeTaxRequest.setName("ݾͨҽҩ޹˾00");
    //            //걨
    //            String sbmm = new String(Base64.getDecoder().decode(taxUnitInfo.getDeclPassword()));
    //            //String sbmm = new String(Base64.getDecoder().decode("QWExMjM0NTY="));
    //            logger.error("sbmm----" + sbmm);
    //            calculateIndividualIncomeTaxRequest.setDeclarePassword(sbmm);
    //            //
    //            calculateIndividualIncomeTaxRequest.setPasswordType(null);
    //            //ʵ˺
    //            calculateIndividualIncomeTaxRequest.setRealNameAccount(null);
    //            //ʵ
    //            calculateIndividualIncomeTaxRequest.setRealNamePassword(null);
    //            //ʵ
    //            calculateIndividualIncomeTaxRequest.setEncryptedRealNamePassword(null);
    //            //Ǽ
    //            calculateIndividualIncomeTaxRequest.setRegistrationNumber(taxUnitInfo.getRegNumber());
    //            //calculateIndividualIncomeTaxRequest.setRegistrationNumber("10117310124834931897");
    //            //˰
    //            calculateIndividualIncomeTaxRequest.setTaxNo(taxUnitInfo.getTaxNumber());
    //            //calculateIndividualIncomeTaxRequest.setTaxNo("91310124834931897I");
    //            //
    //            calculateIndividualIncomeTaxRequest.setArea(taxUnitInfo.getAreaCode());
    //            //calculateIndividualIncomeTaxRequest.setArea("310101");
    //            //ű
    //            calculateIndividualIncomeTaxRequest.setDeptNo(null);
    //            //
    //            calculateIndividualIncomeTaxRequest.setDeptName(null);
    //            //˰
    //            //ȡǰ
    //            LocalDateTime now = LocalDateTime.now();
    //            DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyyMM");
    //            String formattedDate = now.format(formatter);
    //            calculateIndividualIncomeTaxRequest.setMonth(formattedDate);
    //            //ȡԱ
    //            IPersonPosition iPersonPosition = PersonPositionFactory.getLocalInstance(ctx);
    //            PersonPositionInfo personPositionInfo = iPersonPosition.getPersonPositionInfo("select *,person.*,person.employeeType.* ,person.nationality.* where person.id = '" + personId + "'");
    //            //PersonInfo personInfo = iPerson.getPersonInfo(new ObjectUuidPK(personId));
    //            PersonInfo personInfo = personPositionInfo.getPerson();
    //            //ۺö
    //            ComplexIncomeRequest complexIncomeRequest = getComplexIncomeRequest(taxItemPlanNumber, taxItemPlanName, personInfo, cmpschemeid);
    //            //ۺ
    //            calculateIndividualIncomeTaxRequest.setComplexIncomeRequest(complexIncomeRequest);
    //            //Ǿ
    //            NonResidentsIncomeRequest nonResidentsIncomeRequest = getNonResidentsIncomeRequest(taxItemPlanName, personInfo, cmpschemeid);
    //            calculateIndividualIncomeTaxRequest.setNonResidentsIncomeRequest(nonResidentsIncomeRequest);
    //
    //            ApiResponse<AsyncResult> asyncResultApiResponse = clientProxyFactory.getTaxRequest().reverseCalculateASynIndividualIncomeTax(calculateIndividualIncomeTaxRequest);
    //            logger.error("asyncResultApiResponse-----getCode-------" + asyncResultApiResponse.getHead().getCode());
    //            logger.error("asyncResultApiResponse-----getMsg--------" + asyncResultApiResponse.getHead().getMsg());
    //            if (asyncResultApiResponse.getHead().getCode().equals("00000000")) {
    //                AsyncResult body = asyncResultApiResponse.getBody();
    //                String requestId = body.getRequestId();
    //                logger.error("requestId-----" + requestId);
    //                //ѯ㷴
    //                //ISYUtilsFacade isyUtilsFacade = SYUtilsFacadeFactory.getLocalInstance(ctx);
    //                //backTask(url,requestId,صosf,Զ,)
    //                //isyUtilsFacade.backTask(isyUtilsFacade.getConfig().get("ip") + "/gateway/iit/reverseCalculateTax/getASynIndividualIncomeTaxFeedback", requestId, "synIndividualIncomeTaxService", "", TaskCatalogEnum.CAL_GET);
    //                //isyUtilsFacade.backTask("https://test-openapi.17win.com/gateway/iit/reverseCalculateTax/getASynIndividualIncomeTaxFeedback", requestId, "synIndividualIncomeTaxService", jsonObject.toString(), TaskCatalogEnum.CAL_GET);
    //                ApiResponse<CalculateTaxResultRequest> aSynIndividualIncomeTaxFeedback = null;
    //                boolean istrue = true;
    //                while (istrue) {
    //                    //ApiResponse<CalculateTaxResultRequest> aSynIndividualIncomeTaxFeedback = taxRequest.getReverseASynIndividualIncomeTaxFeedback(requestId);
    //                    aSynIndividualIncomeTaxFeedback = taxRequest.getReverseASynIndividualIncomeTaxFeedback(requestId);
    //                    //ApiResponse<CalculateTaxResultRequest> aSynIndividualIncomeTaxFeedback =taxRequest.getReverseASynIndividualIncomeTaxFeedback("9a538f46af784ec6b78fa6e2e10e7037");
    //                    String code = aSynIndividualIncomeTaxFeedback.getHead().getCode();
    //                    if (!"100004".equals(code)) {
    //                        istrue = false;
    //                    }
    //                    logger.error("getCode---" + aSynIndividualIncomeTaxFeedback.getHead().getCode());
    //                    logger.error("getMsg---" + aSynIndividualIncomeTaxFeedback.getHead().getMsg());
    //                    // ȴһʱٽһѯΪ 5 루5000 룩
    //                    Thread.sleep(3000);
    //                }
    //                CalculateTaxResultRequest resBody = aSynIndividualIncomeTaxFeedback.getBody();
    //                //˰㱣淽
    //                String saveId = addTaxPaymentBackCalculate(resBody, jsonObject);
    //                resList.add(saveId);
    //            }
    //        }
    //        rseMap.put("resListSize", resList.size());
    //        rseMap.put("resList", resList);
    //        JSONUtils.writeJson(response, rseMap);
    //    }
    //}

    /**
     * Ӹ˰
     *
     * @param resBody ѯ㷴ӿڷؽ
     * @param param   ԱID
     * @return
     */
    public String addTaxPaymentBackCalculate(CalculateTaxResultRequest resBody, com.alibaba.fastjson.JSONObject
            param) throws BOSException, EASBizException {
        logger.error("addTaxPaymentBackCalculate============Start===============");
        String personId = param.getString("personId");//ԱID
        String periodYear = param.getString("periodYear");//ͳ
        String periodMonth = param.getString("periodMonth");//ͳ
        String cmpschemeid = param.getString("cmpschemeid");//ID
        String taxItemPlanName = param.getString("taxItemPlanName");//˰Ŀ
        String taxItemPlanNumber = param.getString("taxItemPlanNumber");//˰Ŀ
        //ѯ˰Ƿڸ
        ITaxPaymentBackCalculate iTaxPaymentBackCalculate = TaxPaymentBackCalculateFactory.getLocalInstance(ctx);
        FilterInfo filterInfo = new FilterInfo();
        filterInfo.getFilterItems().add(new FilterItemInfo("person", personId, CompareType.EQUALS));
        filterInfo.getFilterItems().add(new FilterItemInfo("periodMonth", periodMonth, CompareType.EQUALS));
        filterInfo.getFilterItems().add(new FilterItemInfo("periodYear", periodYear, CompareType.EQUALS));
        filterInfo.getFilterItems().add(new FilterItemInfo("cmpscheme", cmpschemeid, CompareType.EQUALS));
        EntityViewInfo entityViewInfo = EntityViewInfo.getInstance(filterInfo, null, null);
        TaxPaymentBackCalculateCollection taxPaymentBackCalculateCollection = iTaxPaymentBackCalculate.getTaxPaymentBackCalculateCollection(entityViewInfo);
        TaxPaymentBackCalculateInfo taxPaymentBackCalculateInfo = new TaxPaymentBackCalculateInfo();
        if (taxPaymentBackCalculateCollection.size() > 0) {
            taxPaymentBackCalculateInfo = taxPaymentBackCalculateCollection.get(0);
            taxPaymentBackCalculateInfo.setId(taxPaymentBackCalculateCollection.get(0).getId());
        }
        //Ա
        taxPaymentBackCalculateInfo.setPerson(PersonFactory.getLocalInstance(ctx).getPersonInfo(new ObjectUuidPK(personId)));
        //ͳ
        taxPaymentBackCalculateInfo.setPeriodYear(periodYear);
        //ͳ
        taxPaymentBackCalculateInfo.setPeriodMonth(periodMonth);
        //
        taxPaymentBackCalculateInfo.setCmpscheme(CalSchemeFactory.getLocalInstance(ctx).getCalSchemeInfo(new ObjectUuidPK(cmpschemeid)));
        //˰Ŀ
        taxPaymentBackCalculateInfo.setTaxItemPlan(taxItemPlanName);
        ComplexTaxCalculateResult complexTaxCalculateResult = null;
        //zhsd   ۺ
        ComplexIncomeResultRequest complexIncomeResultRequest = resBody.getComplexIncomeResultRequest();
        //ȫһԽ
        if ("GS003".equals(taxItemPlanNumber)) {
            //qnycxjjsslb  ȫһԽ
            complexTaxCalculateResult = complexIncomeResultRequest.getAnnualOneTimeBonusIncome();
        }
        //һ񱨳б
        if ("GS002".equals(taxItemPlanNumber)) {
            //lwbclb  һ񱨳б
            complexTaxCalculateResult = complexIncomeResultRequest.getLaborRemunerationIncome();
        }
        //н
        if ("GS001".equals(taxItemPlanNumber)) {
            //zcgzxj  н
            complexTaxCalculateResult = complexIncomeResultRequest.getNormalSalarySpecIncome();
        }
        List<ComplexIncome> successComplexIncomes = complexTaxCalculateResult.getSuccessComplexIncomes();
        ComplexIncome complexIncome = successComplexIncomes.get(0);
        //sre  
        BigDecimal income = complexIncome.getIncome();
        taxPaymentBackCalculateInfo.setSalarySum(income);
        //ybtse refundTax  Ӧ˰
        BigDecimal refundTax = complexIncome.getRefundTax();
        taxPaymentBackCalculateInfo.setIndividual(refundTax);
        IObjectPK save = iTaxPaymentBackCalculate.save(taxPaymentBackCalculateInfo);
        logger.error("addTaxPaymentBackCalculate============end===============");
        return save.toString();
    }


    /**
     * ȡǾ	
     *
     * @return
     */
    public NonResidentsIncomeRequest getNonResidentsIncomeRequest(String taxItemPlanName, PersonInfo
            personInfo, String cmpschemeid) throws SQLException, BOSException {
        NonResidentsIncomeRequest nonResidentsIncomeRequest = new NonResidentsIncomeRequest();
        List<NonResidentsIncome> foreignerWagesSalaryIncomes = new ArrayList();
        NonResidentsIncome nonResidentsIncome = getNonResidentsIncome(taxItemPlanName, personInfo, cmpschemeid);
        foreignerWagesSalaryIncomes.add(nonResidentsIncome);
        nonResidentsIncomeRequest.setForeignerWagesSalaryIncomes(foreignerWagesSalaryIncomes);
        return nonResidentsIncomeRequest;
    }

    /**
     * Ǿ-סн
     * * taxItemPlanName   ˰Ŀ
     * * personInfo ԱϢ
     * * cmpschemeid ID
     */
    public NonResidentsIncome getNonResidentsIncome(String taxItemPlanName, PersonInfo personInfo, String
            cmpschemeid) throws SQLException, BOSException {
        NonResidentsIncome nonResidentsIncome = new NonResidentsIncome();
        //nonResidentsIncome.setName("");
        //nonResidentsIncome.setLicenseType("֤");
        //nonResidentsIncome.setLicenseNumber("429004198601085125");
        //nonResidentsIncome.setAbroadIncome(new BigDecimal("8000"));
        //nonResidentsIncome.setIncomeItemName("סн");
        //
        nonResidentsIncome.setName(personInfo.getName());
        //complexIncome.setName("");
        //֤
        if (personInfo.getIdCardNO() != null) {
            //֤պ
            nonResidentsIncome.setLicenseNumber(personInfo.getIdCardNO());
            //֤
            nonResidentsIncome.setLicenseType("֤");
        }
        //йղ
        if (personInfo.getPassportNO() != null) {
            //֤
            nonResidentsIncome.setLicenseType("й");
            //֤պ
            nonResidentsIncome.setLicenseNumber(personInfo.getPassportNO());
        }
        Integer abroadIncome = getAbroadIncome(personInfo.getId().toString(), cmpschemeid);
        //complexIncome.setLicenseNumber("429004198601085125");
        //˰
        //nonResidentsIncome.setAbroadIncome(new BigDecimal(abroadIncome));
        nonResidentsIncome.setIncomeItemName(taxItemPlanName);
        return nonResidentsIncome;
    }

    /**
     * ȡۺ
     * taxItemPlanNumber   ˰Ŀ
     * taxItemPlanName   ˰Ŀ
     * personInfo ԱϢ
     * cmpschemeid ID
     *
     * @return
     */
    public ComplexIncomeRequest getComplexIncomeRequest(String taxItemPlanNumber, String
            taxItemPlanName, PersonPositionCollection personPositionCollection, String cmpschemeid, TaxUnitInfo taxUnitInfo) throws
            BOSException, EASBizException, SQLException {
        logger.error("getComplexIncomeRequest-----" + taxItemPlanNumber + "---" + taxItemPlanName + "---" + personPositionCollection + "---" + cmpschemeid);
        ComplexIncomeRequest complexIncomeRequest = new ComplexIncomeRequest();
        //ȫһԽ
        if (taxItemPlanNumber.equals("GS003")) {
            //if (taxItemPlanNumber.equals("2024083001")) {
            List<ComplexIncome> aOneBonusIncomeList = new ArrayList();
            for (int i = 0; i < personPositionCollection.size(); i++) {
                PersonPositionInfo personPositionInfo = personPositionCollection.get(i);
                PersonInfo personInfo = personPositionInfo.getPerson();
                logger.error("getAbroadIncome-----" + personInfo.getName() + "-----------" + getAbroadIncome(personInfo.getId().toString(), cmpschemeid));
                if (getAbroadIncome(personInfo.getId().toString(), cmpschemeid) != null || getAbroadIncome(personInfo.getId().toString(), cmpschemeid) != 0) {
                    ComplexIncome annualOneTimeBonusIncome = getAnnualOneTimeBonusIncome(personInfo, taxItemPlanName, cmpschemeid);
                    aOneBonusIncomeList.add(annualOneTimeBonusIncome);
                    complexIncomeRequest.setAnnualOneTimeBonusIncome(aOneBonusIncomeList);
                }
            }
        }
        //һ񱨳б
        //if (taxItemPlanNumber.equals("2024083003")) {
        if (taxItemPlanNumber.equals("GS002")) {
            List<ComplexIncome> complexIncomeList = new ArrayList();
            for (int i = 0; i < personPositionCollection.size(); i++) {
                PersonPositionInfo personPositionInfo = personPositionCollection.get(i);
                PersonInfo personInfo = personPositionInfo.getPerson();
                logger.error("getAbroadIncome-----" + personInfo.getName() + "-----------" + +getAbroadIncome(personInfo.getId().toString(), cmpschemeid));
                if (getAbroadIncome(personInfo.getId().toString(), cmpschemeid) != null || getAbroadIncome(personInfo.getId().toString(), cmpschemeid) != 0) {
                    ComplexIncome laborRemunerationIncome = getLaborRemunerationIncome(personInfo, taxItemPlanName, cmpschemeid);
                    complexIncomeList.add(laborRemunerationIncome);
                    complexIncomeRequest.setLaborRemunerationIncome(complexIncomeList);
                }
            }
        }
        //н
        //if (taxItemPlanNumber.equals("2024083004")) {
        if (taxItemPlanNumber.equals("GS001")) {
            logger.error("GS001-----" + personPositionCollection);
            NormalSalarySpecIncome normalSalarySpecIncome = getNormalSalarySpecIncome(personPositionCollection, taxItemPlanName, cmpschemeid, taxUnitInfo);
            complexIncomeRequest.setNormalSalarySpecIncome(normalSalarySpecIncome);
        }
        return complexIncomeRequest;
    }


    /**
     * ȡȫһԽ
     * taxItemPlanName  ˰Ŀ
     * cmpschemeid ID
     *
     * @return
     */
    public ComplexIncome getAnnualOneTimeBonusIncome(PersonInfo personInfo, String taxItemPlanName, String
            cmpschemeid) throws SQLException, BOSException {
        ComplexIncome complexIncome = new ComplexIncome();
        //
        complexIncome.setName(personInfo.getName());
        //complexIncome.setName("");
        //֤
        if (personInfo.getIdCardNO() != null) {
            //֤պ
            complexIncome.setLicenseNumber(personInfo.getIdCardNO());
            //֤
            complexIncome.setLicenseType("֤");
        }
        //йղ
        if (personInfo.getPassportNO() != null) {
            //֤
            complexIncome.setLicenseType("й");
            //֤պ
            complexIncome.setLicenseNumber(personInfo.getPassportNO());
        }
        Integer abroadIncome = getAbroadIncome(personInfo.getId().toString(), cmpschemeid);
        //complexIncome.setLicenseNumber("429004198601085125");
        //˰
        complexIncome.setAfterTaxIncome(new BigDecimal(abroadIncome));
        complexIncome.setIncomeItemName(taxItemPlanName);
        return complexIncome;
    }

    /**
     * ȡһ񱨳
     * taxItemPlanName  ˰Ŀ
     * cmpschemeid ID
     *
     * @return
     */
    public ComplexIncome getLaborRemunerationIncome(PersonInfo personInfo, String taxItemPlanName, String
            cmpschemeid) throws SQLException, BOSException {
        ComplexIncome complexIncome = new ComplexIncome();
        //
        complexIncome.setName(personInfo.getName());
        //complexIncome.setName("");
        //֤
        if (personInfo.getIdCardNO() != null) {
            //֤պ
            complexIncome.setLicenseNumber(personInfo.getIdCardNO());
            //֤
            complexIncome.setLicenseType("֤");
        }
        //йղ
        if (personInfo.getPassportNO() != null) {
            //֤
            complexIncome.setLicenseType("й");
            //֤պ
            complexIncome.setLicenseNumber(personInfo.getPassportNO());
        }
        Integer abroadIncome = getAbroadIncome(personInfo.getId().toString(), cmpschemeid);
        //complexIncome.setLicenseNumber("429004198601085125");
        //˰
        complexIncome.setAfterTaxIncome(new BigDecimal(abroadIncome));
        complexIncome.setIncomeItemName(taxItemPlanName);
        return complexIncome;
    }

    /**
     * ȡн
     *
     * @return
     */
    public NormalSalarySpecIncome getNormalSalarySpecIncome(PersonPositionCollection
                                                                    personPositionCollection, String taxItemPlanName, String cmpschemeid, TaxUnitInfo taxUnitInfo) throws
            BOSException, EASBizException, SQLException {
        logger.error("getNormalSalarySpecIncome-------------start");
        //н
        NormalSalarySpecIncome normalSalarySpecIncome = new NormalSalarySpecIncome();
        //Աб
        List<DetailCompanyEmployee> companyEmployeeList = new ArrayList();
        for (int i = 0; i < personPositionCollection.size(); i++) {
            PersonPositionInfo personPositionInfo = personPositionCollection.get(i);
            PersonInfo personInfo = personPositionInfo.getPerson();
            //ȡԱ
            DetailCompanyEmployee detailCompanyEmployee = getDetailCompanyEmployee(personInfo, taxUnitInfo);
            companyEmployeeList.add(detailCompanyEmployee);
            normalSalarySpecIncome.setCompanyEmployeeList(companyEmployeeList);
            //нб
            List<ComplexIncome> normalSalarySpec = new ArrayList();
            ComplexIncome complexIncome = new ComplexIncome();
            //
            complexIncome.setName(personInfo.getName());
            //complexIncome.setName("");
            //֤
            if (personInfo.getIdCardNO() != null) {
                //֤պ
                complexIncome.setLicenseNumber(personInfo.getIdCardNO());
                //֤
                complexIncome.setLicenseType("֤");
            }
            //йղ
            if (personInfo.getPassportNO() != null) {
                //֤
                complexIncome.setLicenseType("й");
                //֤պ
                complexIncome.setLicenseNumber(personInfo.getPassportNO());
            }
            Integer abroadIncome = getAbroadIncome(personInfo.getId().toString(), cmpschemeid);
            //complexIncome.setLicenseNumber("429004198601085125");
            //˰
            complexIncome.setAfterTaxIncome(new BigDecimal(abroadIncome));
            complexIncome.setIncomeItemName(taxItemPlanName);
            normalSalarySpec.add(complexIncome);
            normalSalarySpecIncome.setNormalSalarySpec(normalSalarySpec);
        }
        return normalSalarySpecIncome;
    }

    /**
     * Ա
     *
     * @return
     */
    public DetailCompanyEmployee getDetailCompanyEmployee(PersonInfo personInfo, TaxUnitInfo taxUnitInfo) throws
            BOSException, EASBizException {
        logger.error("getDetailCompanyEmployee-------------start");
        //Ա
        DetailCompanyEmployee detailCompanyEmployee = new DetailCompanyEmployee();
        ////
        //detailCompanyEmployee.setName("");
        ////֤
        //detailCompanyEmployee.setLicenseType("֤");
        ////֤պ
        //detailCompanyEmployee.setLicenseNumber("429004198601085125");
        //
        detailCompanyEmployee.setName(personInfo.getName());
        logger.error("personInfoName-------------" + personInfo.getName());
        logger.error("personInfo.getIdCardNO()-------------" + personInfo.getIdCardNO());
        //complexIncome.setName("");
        //֤
        if (personInfo.getIdCardNO() != null) {
            //֤պ
            detailCompanyEmployee.setLicenseNumber(personInfo.getIdCardNO());
            //֤
            detailCompanyEmployee.setLicenseType("֤");
            //Ա
            detailCompanyEmployee.setArea("");
        }
        //й
        if (personInfo.getPassportNO() != null) {
            //֤
            detailCompanyEmployee.setLicenseType("й");
            //֤պ
            detailCompanyEmployee.setLicenseNumber(personInfo.getPassportNO());
            //Ա
            detailCompanyEmployee.setArea("");
        }
        //绰
        detailCompanyEmployee.setPhone(personInfo.getCell());

        //Ա״̬
        detailCompanyEmployee.setState(personInfo.getEmployeeType().getName());
        //Ա˰Ϣ->ְܹʹҵϢ
        ITaxPersonRecordEntry iTaxPersonRecordEntry = TaxPersonRecordEntryFactory.getLocalInstance(ctx);
        TaxPersonRecordEntryCollection taxPersonRecordEntryCollection = iTaxPersonRecordEntry.getTaxPersonRecordEntryCollection("where person.id = '" + personInfo.getId() + "'");
        TaxPersonRecordEntryInfo taxPersonRecordEntryInfo = taxPersonRecordEntryCollection.get(0);
        logger.error("taxPersonRecordEntryInfo-------------" + taxPersonRecordEntryInfo);
        //ְܹ  ѡԱӪԱ֤ȯˡʵϰѧȫѧ
        //detailCompanyEmployee.setIsEmployee("");
        if (taxPersonRecordEntryInfo.getEmployedType() == null) {
            detailCompanyEmployee.setIsEmployee("");
        } else {
            detailCompanyEmployee.setIsEmployee(taxPersonRecordEntryInfo.getEmployedType().getAlias());
        }
        //ܹ  YYYY-MM-DD,ܴڵǰʱ䣬ְܹѡԱӪԱ֤ȯʱ¼
        SimpleDateFormat inputFormat = new SimpleDateFormat("yyyy-MM-dd");
        detailCompanyEmployee.setEmployedDate(inputFormat.format(taxPersonRecordEntryInfo.getEmployedDate()));
        //Ա
        detailCompanyEmployee.setGender(personInfo.getGender().getAlias());
        //
        detailCompanyEmployee.setBirthday(inputFormat.format(personInfo.getBirthday()));
        // nationality
        NationalityInfo nationality = personInfo.getNationality();
        detailCompanyEmployee.setNationality(nationality.getName());
        //˰״̬
        detailCompanyEmployee.setState(taxPersonRecordEntryInfo.getPersonStatus().getAlias());
        logger.error("detailCompanyEmployee-------------" + detailCompanyEmployee);
        logger.error("getDetailCompanyEmployee-------------end");
        return detailCompanyEmployee;
    }

    /**
     * ȡ˰  ϵͳֶ=˰ʵ
     *
     * @param perosnId
     * @param cmpschemeid
     * @return
     */
    public Integer getAbroadIncome(String perosnId, String cmpschemeid) throws BOSException, SQLException {
        String sql = String.format("select S328  from  T_HR_SCmpCalTable where FPERSONID = '%s' and  FCALSCHEMEID = '%s'", perosnId, cmpschemeid);
        logger.error("getAbroadIncomeSql---------------" + sql);
        IRowSet iRowSet = DbUtil.executeQuery(ctx, sql);
        Integer abroadIncome = null;
        while (iRowSet.next()) {
            abroadIncome = iRowSet.getInt("S328");
        }
        return abroadIncome;
    }


    /**
     * ȡ˰Ԫ
     *
     * @param personId
     * @return
     */
    public String getSalaryOrgMappingByPersonId(String personId) {
        StringBuilder sb = new StringBuilder();
        sb.append("select top 1 ").append("\n");
        sb.append("cmpOrgUnitCus.FTAXUNITID as taxunit").append("\n");
        sb.append("from CT_COM_CmpOrgUnitCus cmpOrgUnitCus").append("\n");
        sb.append("left join T_HR_SPersonCmp personCmp on personCmp.Fid = cmpOrgUnitCus.FPERSONCMPID").append("\n");
        sb.append("left join T_bd_person person on person.Fid = personCmp.FPERSONID").append("\n");
        sb.append("where").append("\n");
        sb.append("person.Fid = '").append(personId).append("'").append("\n");
        sb.append("order by cmpOrgUnitCus.FLEFFECTTIME desc ").append("\n");
        return sb.toString();

    }


    ///**
    // * ͬԱ˰Ϣ
    // *
    // * @param request
    // * @param response
    // * @param modelMap
    // * @throws ShrWebBizException
    // * @throws BOSException
    // */
    //public void synTaxPersonRecordAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws ShrWebBizException, BOSException {
    //    //ID
    //    String cmpschemeid = request.getParameter("cmpschemeid");
    //    if (StringUtils.isEmpty(cmpschemeid)) {
    //        throw new ShrWebBizException("IDΪգ");
    //    }
    //    //
    //    ICalScheme iCalScheme = CalSchemeFactory.getLocalInstance(ctx);
    //    try {
    //        CalSchemeInfo calSchemeInfo = iCalScheme.getCalSchemeInfo(new ObjectUuidPK(cmpschemeid));
    //        //ȡһµļ  ͳ꣺periodYear   ͳ£periodMonth
    //        LocalDate date = LocalDate.of(calSchemeInfo.getPeriodYear(), calSchemeInfo.getPeriodMonth(), 1);
    //        LocalDate previousMonthDate = date.minusMonths(1);
    //        //ȡϸµн
    //        //CalSchemeInfo calSchemeUp = iCalScheme.getCalSchemeInfo("where periodYear = '" + previousMonthDate.getYear() + "' and  periodMonth = '" + previousMonthDate.getMonthValue() + "'");
    //        CmpCalTableCollection cmpCalTableCollectionUp = getCalSchemeColl(calSchemeInfo.getId().toString(), previousMonthDate.getYear(), previousMonthDate.getMonthValue());
    //        logger.error("cmpCalTableCollectionUp--------" + cmpCalTableCollectionUp.size());
    //
    //        //ȡǰн
    //        CmpCalTableCollection cmpCalTableCollection = getCalSchemeColl(calSchemeInfo.getId().toString(), calSchemeInfo.getPeriodYear(), calSchemeInfo.getPeriodMonth());
    //        logger.error("cmpCalTableCollection--------" + cmpCalTableCollection.size());
    //
    //        //ϸµĺԱ
    //        List<String> listUp = new ArrayList<>();
    //        for (int i = 0; i < cmpCalTableCollectionUp.size(); i++) {
    //            listUp.add(cmpCalTableCollectionUp.get(i).getPerson().getId().toString());
    //        }
    //
    //        //浱ǰµĺԱ
    //        List<String> list = new ArrayList<>();
    //        for (int i = 0; i < cmpCalTableCollection.size(); i++) {
    //            list.add(cmpCalTableCollection.get(i).getPerson().getId().toString());
    //        }
    //
    //        Set<String> setUp = new HashSet<>(listUp);
    //        Set<String> set = new HashSet<>(list);
    //
    //        // ҳ ϸºԱ б ǰºԱ  ΪְԱ ޸Ա˰Ϣ Ա״̬Ϊ  ְΪǰһ
    //        Set<String> pseronIdsUp = new HashSet<>(setUp);
    //        pseronIdsUp.removeAll(set);
    //
    //        // ҳ ǰºԱ б ϸºԱ  ΪԱ Ա˰ϢְܹʹҵϢ Ա״̬Ϊ ְܹʹҵΪǰ1
    //        Set<String> pseronIds = new HashSet<>(set);
    //        pseronIds.removeAll(setUp);
    //
    //        SelectorItemCollection updateSic = new SelectorItemCollection();
    //        updateSic.add("personStatus");
    //        updateSic.add("departureDate");
    //        //޸ĵԱ˰Ϣ
    //        ITaxPersonRecordEntry iTaxPersonRecordEntry = TaxPersonRecordEntryFactory.getLocalInstance(ctx);
    //        //ж޸ԱID0 ޸Ա˰Ϣ
    //        if (pseronIdsUp.size() > 0) {
    //            //ȡְܹʹҵϢ   ޸Ա˰Ϣ Ա״̬Ϊ  ְΪǰһ
    //            TaxPersonRecordEntryCollection taxPersonRecordEntryCollUp = getTaxPersonRecordEntryColl(pseronIdsUp, iTaxPersonRecordEntry);
    //            if (taxPersonRecordEntryCollUp.size() > 0) {
    //                for (int i = 0; i < taxPersonRecordEntryCollUp.size(); i++) {
    //                    TaxPersonRecordEntryInfo taxPersonRecordEntryInfo = taxPersonRecordEntryCollUp.get(i);
    //                    //Ա״̬
    //                    taxPersonRecordEntryInfo.setPersonStatus(PersonStatusEnum.NotNormal);
    //                    //ȡǰµһתDate
    //                    Date departureDate = Date.from(date.withDayOfMonth(date.lengthOfMonth()).atStartOfDay(ZoneId.systemDefault()).toInstant());
    //                    //ְΪǰһ
    //                    taxPersonRecordEntryInfo.setDepartureDate(departureDate);
    //                    iTaxPersonRecordEntry.updatePartial(taxPersonRecordEntryInfo, updateSic);
    //                }
    //            }
    //        }
    //        //Ա˰Ϣ
    //        if (pseronIds.size() > 0) {
    //            //Date.from(date.atStartOfDay(ZoneId.systemDefault()).toInstant()) ǰµһ
    //            addTaxPersonRecord(pseronIds, Date.from(date.atStartOfDay(ZoneId.systemDefault()).toInstant()));
    //        }
    //        Map res = new HashMap();
    //        res.put("update", pseronIdsUp.size());
    //        res.put("add", pseronIds.size());
    //        JSONUtils.writeJson(response, res);
    //    } catch (EASBizException e) {
    //        e.printStackTrace();
    //        throw new ShrWebBizException("ID" + cmpschemeid + "δȡϵԱ");
    //    } catch (SQLException e) {
    //        throw new ShrWebBizException(e);
    //    } catch (SHRWebException e) {
    //        throw new ShrWebBizException(e);
    //    }
    //
    //}

    ///**
    // * Ա˰Ϣ
    // *
    // * @param pseronIds
    // */
    //public void addTaxPersonRecord(Set<String> pseronIds, Date oneDay) throws BOSException, EASBizException, SQLException {
    //    logger.error("addTaxPersonRecord--------ʼ");
    //    //pseronIds.forEach(id -> {});
    //    ITaxPersonRecord iTaxPersonRecord = TaxPersonRecordFactory.getLocalInstance(ctx);
    //    IPerson iPerson = PersonFactory.getLocalInstance(ctx);
    //    ITaxPersonRecordEntry iTaxPersonRecordEntry = TaxPersonRecordEntryFactory.getLocalInstance(ctx);
    //    //Ա˰¼
    //    TaxPersonRecordEntryInfo taxPersonRecordEntryInfo = new TaxPersonRecordEntryInfo();
    //    SelectorItemCollection sic = new SelectorItemCollection();
    //    sic.add("*");
    //    FilterInfo filterInfo = new FilterInfo();
    //    filterInfo.getFilterItems().add(new FilterItemInfo("id", pseronIds, CompareType.INCLUDE));
    //    EntityViewInfo entityViewInfo = EntityViewInfo.getInstance(filterInfo, sic, null);
    //    PersonCollection personCollection = iPerson.getPersonCollection(entityViewInfo);
    //    if (personCollection.size() > 0) {
    //        for (int i = 0; i < personCollection.size(); i++) {
    //            PersonInfo personInfo = personCollection.get(i);
    //            boolean exists = iTaxPersonRecordEntry.exists("where person = '" + personInfo.getId().toString() + "'");
    //            if (!exists) {
    //
    //                TaxPersonRecordInfo taxPersonRecordInfo = new TaxPersonRecordInfo();
    //                //Ա
    //                taxPersonRecordInfo.setPerson(personInfo);
    //                //֤
    //                if (personInfo.getIdCardNO() != null || personInfo.getPassportNO() != null) {
    //                    if (null == personInfo.getIdCardNO()) {
    //                        //
    //                        taxPersonRecordInfo.setCardType(CardTypeEnum.Passport);
    //                        taxPersonRecordInfo.setCardNumber(personInfo.getPassportNO());
    //                        //˰
    //                        taxPersonRecordEntryInfo.setPayerType(PayerTypeEnum.NotResident);
    //                    }
    //                    if (null == personInfo.getPassportNO()) {
    //                        //֤
    //                        taxPersonRecordInfo.setCardType(CardTypeEnum.IdCard);
    //                        taxPersonRecordInfo.setCardNumber(personInfo.getIdCardNO());
    //                        //˰
    //                        taxPersonRecordEntryInfo.setPayerType(PayerTypeEnum.Resident);
    //
    //                    }
    //                } else {
    //                    logger.error(personInfo.getName() + "պ֤Ϊգ֤ͱʧܣ");
    //                }
    //                //Ա
    //                taxPersonRecordInfo.setGender(personInfo.getGender());
    //                //
    //                taxPersonRecordInfo.setBirthday(personInfo.getBirthday());
    //                //
    //                taxPersonRecordInfo.setNationality(personInfo.getNationality());
    //                //ǷԱ
    //                taxPersonRecordInfo.setIsOversea(IsOverseaEnum.NotOversea);
    //                //ֻ
    //                taxPersonRecordInfo.setPhoneNumber(personInfo.getCell());
    //                iTaxPersonRecord.save(taxPersonRecordInfo);
    //                //¼
    //                taxPersonRecordEntryInfo.setPerson(personInfo);
    //                taxPersonRecordEntryInfo.setBill(taxPersonRecordInfo);
    //                //ȡ˰λ
    //                String sql = getSalaryOrgMappingByPersonId(personInfo.getId().toString());
    //                IRowSet iRowSet = DbUtil.executeQuery(ctx, sql);
    //                ITaxUnit iTaxUnit = TaxUnitFactory.getLocalInstance(ctx);
    //                if (iRowSet.size() > 0) {
    //                    while (iRowSet.next()) {
    //                        TaxUnitInfo taxUnitInfo = iTaxUnit.getTaxUnitInfo("where number = '" + iRowSet.getString("nsdwmc") + "'");
    //                        taxPersonRecordEntryInfo.setTaxUnit(taxUnitInfo);
    //                        //Ա״̬
    //                        taxPersonRecordEntryInfo.setPersonStatus(PersonStatusEnum.Normal);
    //                        //ȡǰµһתDate //ְܹʹҵΪǰµһ
    //                        taxPersonRecordEntryInfo.setEmployedDate(oneDay);
    //                        //״̬
    //                        taxPersonRecordEntryInfo.setSubmitStatus(SubmitStatusEnum.NotSubmit);
    //                        iTaxPersonRecordEntry.save(taxPersonRecordEntryInfo);
    //                    }
    //                } else {
    //                    logger.error("iRowSet-----Sql---" + sql);
    //                    logger.error("iRowSet--------" + personInfo.getName() + "δȡ˰λֶαʧܣ");
    //                }
    //            }
    //        }
    //    }
    //    logger.error("addTaxPersonRecord--------");
    //}


    ///**
    // * ȡְܹʹҵϢ
    // *
    // * @param pseronIds ԱID
    // * @return
    // * @throws BOSException
    // */
    //public TaxPersonRecordEntryCollection getTaxPersonRecordEntryColl(Set<String> pseronIds, ITaxPersonRecordEntry iTaxPersonRecordEntry) throws BOSException {
    //    //ȡǰµн
    //    FilterInfo filterInfo = new FilterInfo();
    //    filterInfo.getFilterItems().add(new FilterItemInfo("bill.person", pseronIds, CompareType.INCLUDE));
    //    EntityViewInfo entityViewInfo = EntityViewInfo.getInstance(filterInfo, null, null);
    //    return iTaxPersonRecordEntry.getTaxPersonRecordEntryCollection(entityViewInfo);
    //}

    /**
     * ͨidȡн
     *
     * @param cmpschemeid
     * @throws BOSException
     */
    public CmpCalTableCollection getCalSchemeColl(String cmpschemeid, int year, int month) throws BOSException {
        ICmpCalTable iCmpCalTable = CmpCalTableFactory.getLocalInstance(ctx);
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("*");
        sic.add("calScheme.*");
        sic.add("person.*");
        //ȡǰµн
        FilterInfo filterInfo = new FilterInfo();
        filterInfo.getFilterItems().add(new FilterItemInfo("calScheme", cmpschemeid, CompareType.EQUALS));
        filterInfo.getFilterItems().add(new FilterItemInfo("periodYear", year, CompareType.EQUALS));
        filterInfo.getFilterItems().add(new FilterItemInfo("periodMonth", month, CompareType.EQUALS));
        EntityViewInfo entityViewInfo = EntityViewInfo.getInstance(filterInfo, sic, null);
        CmpCalTableCollection cmpCalTableCollection = iCmpCalTable.getCmpCalTableCollection(entityViewInfo);
        return cmpCalTableCollection;
    }
}
