package com.kingdee.eas.custom.compensation.handler;

import cn.com.servyou.dto.ApiResponse;
import cn.com.servyou.dto.AsyncResult;
import cn.com.servyou.dto.declare.CompanyDeclareRequest;
import cn.com.servyou.dto.declare.DeclareCancelRequest;
import cn.com.servyou.dto.declare.DeclareCorrectRequest;
import cn.com.servyou.dto.tax.*;
import cn.com.servyou.rmi.client.ClientProxyFactory;
import cn.com.servyou.service.DeclarationRequest;
import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.ormapping.impl.ImplUtils;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.bos.util.EASResource;
import com.kingdee.eas.basedata.hraux.NationalityInfo;
import com.kingdee.eas.basedata.person.PersonCollection;
import com.kingdee.eas.basedata.person.PersonFactory;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.shuiyou.task.TaskCatalogEnum;
import com.kingdee.eas.custom.shuiyou.uitls.ISYUtilsFacade;
import com.kingdee.eas.custom.shuiyou.uitls.SYUtilsFacadeFactory;
import com.kingdee.eas.custom.shuiyou.utils.ClientProxyFactoryUtils;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.jdbc.rowset.IRowSetMetaData;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.exception.ShrWebBizException;
import com.kingdee.shr.base.syssetting.web.dynamic.util.DynamicUtil;
import com.kingdee.shr.base.syssetting.web.dynamic.util.MD5;
import com.kingdee.shr.base.syssetting.web.json.JSONUtils;
import com.kingdee.shr.base.syssetting.web.util.UserUtil;
import com.kingdee.shr.compensation.TaxDeclareStatusEnum;
import com.kingdee.shr.compensation.TbTypeEnum;
import com.kingdee.shr.compensation.app.incomeTax.ITaxPersonRecordEntry;
import com.kingdee.shr.compensation.app.incomeTax.TaxPersonRecordEntryCollection;
import com.kingdee.shr.compensation.app.incomeTax.TaxPersonRecordEntryFactory;
import com.kingdee.shr.compensation.app.incomeTax.TaxPersonRecordEntryInfo;
import com.kingdee.shr.compensation.app.tax.*;
import com.kingdee.shr.compensation.app.tax.base.TaxIncomeItemInfo;
import com.kingdee.shr.compensation.app.taxCal.*;
import com.kingdee.shr.compensation.helper.CmpConstants;
import com.kingdee.shr.compensation.taxCal.util.TaxCalcFileUtils;
import com.kingdee.shr.compensation.util.*;
import com.kingdee.shr.compensation.web.handler.tax.IncomeTaxDeclareListHandler;
import com.kingdee.shr.compensation.web.handler.tax.dto.TaxDeclarExcelRowDTO;
import com.kingdee.shr.compensation.web.handler.tax.dto.TaxDeclareDTO;
import com.kingdee.util.StringUtils;
import org.apache.log4j.Logger;
import org.apache.poi.hssf.usermodel.*;
import org.springframework.ui.ModelMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.lang.reflect.Type;
import java.math.BigDecimal;
import java.net.URLEncoder;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.*;


/**
 * @author qingwu
 * @date 2024/9/18
 * @apiNote ˰걨չ
 */
public class IncomeTaxDeclareListHandlerEx extends IncomeTaxDeclareListHandler {
    private static final Logger LOG = Logger.getLogger(IncomeTaxDeclareListHandlerEx.class);

    private Context ctx = SHRContext.getInstance().getContext();

    private ObjectMapper mapper = new ObjectMapper();

    /**
     * ˰걨
     *
     * @param request
     * @param response
     * @param modelMap
     */
    @Override
    public void taxDeclareAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws BOSException, SHRWebException {
        LOG.error("taxDeclareAction-----------start-----------");
        Context ctx = SHRContext.getInstance().getContext();
        try {
            boolean isHaveTaxService = CmpTaxUtil.isHaveTaxService(ctx);
            if (!isHaveTaxService) {
                throw new ShrWebBizException(EASResource.getString("com.kingdee.shr.compensation.resource.CommonResource", "label136", ctx.getLocale()));
            } else {
                String selectedId = request.getParameter("selectedId");
                Map<String, Object> resultMap = new HashMap();
                Map<String, Object> declareData = this.getDeclareData(ctx, selectedId);
                Map<String, Object> paramMap = new HashMap();
                paramMap.put("declaData", declareData.get("WATI_TO_DECLARE"));
                LOG.error("paramMap-----------" + paramMap);
                try {
                    //˰λ
                    List<String> advanceDeclareInfo = (List) declareData.get("advanceDeclareInfo");
                    LOG.error("advanceDeclareInfo------------" + advanceDeclareInfo);
                    if (!advanceDeclareInfo.isEmpty()) {
                        throw new ShrWebBizException(this.combineError(advanceDeclareInfo));
                    }
                    //˰ ״̬=ͨ
                    List<IncomeTaxDeclarInfo> waitToDeclareList = (List) paramMap.get("declaData");
                    if (waitToDeclareList.size() <= 0) {
                        resultMap.put("success", false);
                        resultMap.put("excel", "");
                        resultMap.put("hasErrData", true);
                        resultMap.put("hasCheckDataErr", true);
                        resultMap.put("info", "ظ걨");
                        JSONUtils.SUCCESS(resultMap);
                        return;
                    }
                    //˰걨
                    Map<String, Object> checkResultMap = this.checkTaxDeclareData(ctx, request, waitToDeclareList);
                    Boolean hasErr = (Boolean) checkResultMap.get("hasErrData");
                    if (hasErr != null && hasErr) {
                        resultMap.put("success", false);
                        resultMap.put("excel", checkResultMap.get("excel"));
                        resultMap.put("hasErrData", true);
                        resultMap.put("hasCheckDataErr", true);
                        resultMap.put("info", "");
                        JSONUtils.SUCCESS(resultMap);
                        return;
                    }
                    String errMsg = this.checkTaxCalStatus(ctx, waitToDeclareList);
                    if (null != errMsg) {
                        resultMap.put("success", false);
                        resultMap.put("dataError", true);
                        resultMap.put("errMsg", errMsg);
                        JSONUtils.SUCCESS(resultMap);
                        return;
                    }

                    checkResultMap = this.checkIncomeTaxIssue(ctx, waitToDeclareList);
                    if (checkResultMap != null) {
                        checkResultMap.put("success", false);
                        JSONUtils.SUCCESS(checkResultMap);
                        return;
                    }

                    //errMsg = this.checkReductionItems(ctx, waitToDeclareList);
                    //if (null != errMsg) {
                    //    resultMap.put("success", false);
                    //    resultMap.put("reductionError", true);
                    //    resultMap.put("errMsg", errMsg);
                    //    JSONUtils.SUCCESS(resultMap);
                    //    return;
                    //}

                    //Map<String, Object> taxDeclareResult = IncomeTaxDeclareFacadeFactory.getLocalInstance(ctx).taxDeclare(paramMap);
                    //Ӷ˰˰걨
                    Map<String, Object> taxDeclareResult = callShuiYouTaxDeclare(paramMap);
                    Boolean isSuccess = (Boolean) taxDeclareResult.get("success");
                    resultMap.put("success", isSuccess);
                    resultMap.put("excel", "");
                    resultMap.put("hasErrData", !isSuccess);
                    resultMap.put("hasCheckDataErr", false);
                    resultMap.put("info", declareData.get("info"));
                } catch (Exception var17) {
                    var17.printStackTrace();
                    LOG.error(var17.getMessage(), var17);
                    resultMap.put("success", false);
                    resultMap.put("excel", "");
                    resultMap.put("hasErrData", true);
                    resultMap.put("hasCheckDataErr", false);
                    resultMap.put("info", declareData.get("info"));
                    resultMap.put("errorMsg", var17.getMessage());
                }
                LOG.error("taxDeclareAction-----------end-----------");
                JSONUtils.SUCCESS(resultMap);
            }
        } catch (JsonProcessingException e) {
            e.printStackTrace();
            throw new RuntimeException(e);
        }
    }


    /**
     * Ӷ˰˰걨
     *
     * @param paramMap
     * @return
     */
    public Map<String, Object> callShuiYouTaxDeclare(Map paramMap) {
        LOG.error("callShuiYouTaxDeclare--------------------paramMap" + paramMap);
        Map<String, Object> resultMap = new HashMap();
        resultMap.put("success", true);
        resultMap.put("msg", "");
        List<IncomeTaxDeclarInfo> waitToDeclareList = (List) paramMap.get("declaData");
        Map<String, Object> requestParamMap = new HashMap();
        List<Object[]> paramList = new ArrayList();
        try {
            if (waitToDeclareList != null && waitToDeclareList.size() > 0) {
                for (int i = 0; i < waitToDeclareList.size(); i++) {
                    IncomeTaxDeclarInfo taxDeclarInfo = waitToDeclareList.get(i);
                    JSONObject param = new JSONObject();
                    param.put("taxDeclarId", taxDeclarInfo.getId());
                    param.put("taxDeclarBatchNo", taxDeclarInfo.getBatchNo());
                    //˰λ
                    TaxUnitInfo taxUnitInfo = taxDeclarInfo.getTaxUnit();
                    //ͻ˴
                    ClientProxyFactory clientProxyFactory = ClientProxyFactoryUtils.getClientProxyFactory();
                    //˰ӿ
                    DeclarationRequest declarationRequest = clientProxyFactory.getDeclarationRequest();
                    //ȡ
                    CompanyDeclareRequest declareRequestParameter = getDeclareRequestParameter(taxUnitInfo, taxDeclarInfo);
                    LOG.error("declareRequestParameter-----------------" + mapper.writeValueAsString(declareRequestParameter));
                    ApiResponse<AsyncResult> apiResponse = declarationRequest.send(declareRequestParameter);
                    LOG.error("asyncResultApiResponse-----getCode-------" + apiResponse.getHead().getCode());
                    LOG.error("asyncResultApiResponse-----getMsg--------" + apiResponse.getHead().getMsg());
                    resultMap.put("msg", mapper.writeValueAsString(declareRequestParameter));
                    if (apiResponse.getHead().getCode().equals("00000000")) {
                        AsyncResult body = apiResponse.getBody();
                        String requestId = body.getRequestId();
                        LOG.error("requestId-----" + requestId);
                        LOG.error("apiResponse-----" + mapper.writeValueAsString(apiResponse));
                        //ѯ㷴
                        ISYUtilsFacade isyUtilsFacade = SYUtilsFacadeFactory.getLocalInstance(ctx);
                        //backTask(url,requestId,صosf,Զ,)
                        //isyUtilsFacade.backTask(isyUtilsFacade.getConfig().get("ip") + "/gateway/iit/reverseCalculateTax/getASynIndividualIncomeTaxFeedback", requestId, "synIndividualIncomeTaxService", jsonObject.toString(), TaskCatalogEnum.CAL_GET);
                        JSONObject json = new JSONObject();
                        json.put("requestId", requestId);
                        json.put("param", param.toString());
                        isyUtilsFacade.addTask("synIncomeTaxDeclareService", json.toJSONString(), TaskCatalogEnum.TAX, "");
                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
            resultMap.put("success", false);
            resultMap.put("msg", e.getMessage());
            return resultMap;
        }
        return resultMap;

    }

    /**
     * ȡ
     * ע:
     * 1.ͶͬһԲȫһԽãܵ걨Ҫͬнһ걨
     * 2.ͶͬһԲ𡢸ã˰ҪͶͬһԲ𡢸ñд˰
     *
     * @param taxUnitInfo
     * @param taxDeclarInfo
     * @return
     */
    private CompanyDeclareRequest getDeclareRequestParameter(TaxUnitInfo taxUnitInfo,
                                                             IncomeTaxDeclarInfo taxDeclarInfo
    ) throws BOSException, JsonProcessingException, EASBizException, SQLException {
        LOG.error("getDeclareRequestParameter-----------taxDeclarInfo-----" + taxDeclarInfo);
        CompanyDeclareRequest declareRequestPara = new CompanyDeclareRequest();
        Map<String, Object> requestParamMap = new HashMap();
        //id
        String bizNo = UUID.randomUUID().toString();
        LOG.error("bizNo:" + bizNo);
        //ⲿҵ񶩵*
        declareRequestPara.setBizNo(bizNo);
        //ҵ*
        declareRequestPara.setName(taxUnitInfo.getName());
        //˰*
        declareRequestPara.setTaxNo(taxUnitInfo.getTaxNumber());
        //*
        declareRequestPara.setArea(taxUnitInfo.getAreaCode());
        //Ǽ
        declareRequestPara.setRegistrationNumber(taxUnitInfo.getRegNumber());
        String declPassword = taxUnitInfo.getDeclPassword();
        if (StringUtils.isEmpty(declPassword)) {
            throw new BOSException("걨벻Ϊ!");
        }
        declareRequestPara.setDeclarePassword(Base64Utils.decode(declPassword));
        //·
        String yearMonth = taxDeclarInfo.getYearMonth();
        String replaceYearMonth = yearMonth.replace("-", "");
        LOG.error("replaceYearMonth----------------" + replaceYearMonth);
        //˰YYYYMM*
        declareRequestPara.setMonth(replaceYearMonth);
        //ܽ
        //BigDecimal totalMoney = taxDeclarInfo.getTotalMoney();
        //Ӧ˰
        //BigDecimal taxRebate = taxDeclarInfo.getTaxRebate();
        //
        //long totalPerson = taxDeclarInfo.getTotalPerson();
        //걨 1=ԤԤ걨  2=걨   3=Ǿ걨
        //String tbTble = taxDeclarInfo.getTbType().getValue();
        //˰λID
        //String taxUnitId = taxUnitInfo.getId().toString();
        //Map<String, Object> tbTypeMap = new HashMap();
        //if (totalMoney.compareTo(BigDecimal.ZERO) == 0) {
        //    tbTypeMap.put("zje", 0.0);
        //} else {
        //    tbTypeMap.put("zje", totalMoney);
        //}
        //
        //if (taxRebate.compareTo(BigDecimal.ZERO) == 0) {
        //    tbTypeMap.put("ynse", 0.0);
        //} else {
        //    tbTypeMap.put("ynse", taxRebate);
        //}
        //tbTypeMap.put("zrs", totalPerson);
        //Map<String, Object> dataMap = new HashMap();
        //if ("1".equals(tbTble)) {
        //    dataMap.put("ykyj", tbTypeMap);
        //} else if ("2".equals(tbTble)) {
        //    dataMap.put("flsd", tbTypeMap);
        //} else if ("3".equals(tbTble)) {
        //    dataMap.put("fjm", tbTypeMap);
        //}
        //*
        declareRequestPara.setPasswordType("0");
        //ְڴ 11ְԶգԱ״̬ɡΪʱְֶԶգĬ߼
        //22ְڲԶգԱ״̬ɡΪʱְڲԶգͻְֶδַ
        //declareRequestPara.setResignDateStrategy();
        //κ
        String batchNo = taxDeclarInfo.getBatchNo();
        LOG.error("taxCalConfigDetailCollection--------taxDeclarInfo---------" + taxDeclarInfo);
        //˰Ӧ+˰ղϸ
        ITaxCalConfigDetail taxCalConfigDetail = TaxCalConfigDetailFactory.getLocalInstance(ctx);
        TaxCalConfigDetailCollection taxCalConfigDetailCollection = taxCalConfigDetail.getTaxCalConfigDetailCollection("select *,incomeItem.*, person.* where batchNo = '" + batchNo + "' and state = '20'");
        LOG.error("taxCalConfigDetailCollection-----------------" + taxCalConfigDetailCollection.size());
        //ԱϢID
        Set personIds = new HashSet();
        //ۺö
        ComplexIncomeRequest complexIncomeRequest = new ComplexIncomeRequest();
        //н
        NormalSalarySpecIncome normalSalarySpecIncome = new NormalSalarySpecIncome();
        //нб
        List<ComplexIncome> normalSalarySpec = new ArrayList();
        //ȫһԽ
        List<ComplexIncome> annualOneTimeBonusIncome = new ArrayList();
        //ȫһԽ
        List<ComplexIncome> laborRemunerationIncome = new ArrayList();
        if (taxCalConfigDetailCollection.size() > 0) {
            for (int i = 0; i < taxCalConfigDetailCollection.size(); i++) {
                TaxCalConfigDetailInfo taxCalConfigDetailInfo = taxCalConfigDetailCollection.get(i);
                //ԱϢ
                PersonInfo personInfo = taxCalConfigDetailInfo.getPerson();
                personIds.add(personInfo.getId().toString());
                //Ŀ
                TaxIncomeItemInfo incomeItem = taxCalConfigDetailInfo.getIncomeItem();
                //
                Integer sre = null;
                String getSreSql = "select t1 from T_HR_STaxCalConfigDetail where fid ='" + taxCalConfigDetailInfo.getId().toString() + "'";
                IRowSet iRowSet = DbUtil.executeQuery(ctx, getSreSql);
                while (iRowSet.next()) {
                    sre = iRowSet.getInt("t1");
                }
                LOG.error("incomeItem-----------------" + incomeItem);
                //Ŀ
                String incomeItemName = incomeItem.getName();
                //Ŀ
                String incomeItemNumber = incomeItem.getNumber();

                //н
                if ("zcgzxjlb".equals(incomeItemNumber)) {
                    //getComplexIncomeԱϢ Ŀ,룩
                    normalSalarySpec.add(getComplexIncome(personInfo, incomeItemName, sre));
                    //нб 
                    normalSalarySpecIncome.setNormalSalarySpec(normalSalarySpec);
                    LOG.error("normalSalarySpecIncome-----------------" + mapper.writeValueAsString(normalSalarySpecIncome));
                    complexIncomeRequest.setNormalSalarySpecIncome(normalSalarySpecIncome);
                }
                //ȫһԽ
                if ("qnycxjjlb".equals(incomeItemNumber)) {
                    annualOneTimeBonusIncome.add(getComplexIncome(personInfo, incomeItemName, sre));
                    LOG.error("annualOneTimeBonusIncome-----------------" + mapper.writeValueAsString(annualOneTimeBonusIncome));
                    LOG.error("annualOneTimeBonusIncome-----------------" + annualOneTimeBonusIncome);
                    LOG.error("annualOneTimeBonusIncome.size()-----------------" + annualOneTimeBonusIncome.size());
                    //ȫһԽ 
                    complexIncomeRequest.setAnnualOneTimeBonusIncome(annualOneTimeBonusIncome);
                }
                //һ񱨳
                if ("lwbclb".equals(incomeItemNumber)) {
                    laborRemunerationIncome.add(getComplexIncome(personInfo, incomeItemName, sre));
                    LOG.error("laborRemunerationIncome-----------------" + mapper.writeValueAsString(laborRemunerationIncome));
                    //һ񱨳 
                    complexIncomeRequest.setLaborRemunerationIncome(laborRemunerationIncome);
                }
            }
        }
        //ۺ
        declareRequestPara.setComplexIncomeRequest(complexIncomeRequest);
        //ҵԱб
        List<DetailCompanyEmployee> companyEmployeeList = getCompanyEmployeeList(personIds);
        declareRequestPara.setCompanyEmployeeList(companyEmployeeList);
        LOG.error("companyEmployeeList-----------------" + mapper.writeValueAsString(companyEmployeeList));

        return declareRequestPara;
    }


    /***
     * Ա
     * @return
     */
    private ComplexIncome getComplexIncome(PersonInfo personInfo, String incomeItemName, Integer sre) {
        ComplexIncome complexIncome = new ComplexIncome();
        //
        complexIncome.setName(personInfo.getName());
        //֤
        if (personInfo.getIdCardNO() != null) {
            //֤պ
            complexIncome.setLicenseNumber(personInfo.getIdCardNO());
            //֤
            complexIncome.setLicenseType("֤");
        }
        //йղ
        if (personInfo.getPassportNO() != null) {
            //֤
            complexIncome.setLicenseType("й");
            //֤պ
            complexIncome.setLicenseNumber(personInfo.getPassportNO());
        }
        //
        complexIncome.setIncome(new BigDecimal(sre));
        complexIncome.setIncomeItemName(incomeItemName);
        return complexIncome;
    }

    /**
     * ҵԱб*
     *
     * @return
     */
    private List<DetailCompanyEmployee> getCompanyEmployeeList(Set personIds) throws BOSException, EASBizException {
        List<DetailCompanyEmployee> companyEmployeeList = new ArrayList<DetailCompanyEmployee>();
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("*");
        FilterInfo filterInfo = new FilterInfo();
        filterInfo.getFilterItems().add(new FilterItemInfo("id", personIds, CompareType.INCLUDE));
        EntityViewInfo entityViewInfo = EntityViewInfo.getInstance(filterInfo, sic, null);        //ȡԱ
        PersonCollection personCollection = PersonFactory.getLocalInstance(ctx).getPersonCollection(entityViewInfo);
        if (personCollection.size() > 0) {
            for (int i = 0; i < personCollection.size(); i++) {
                PersonInfo personInfo = personCollection.get(i);
                companyEmployeeList.add(getDetailCompanyEmployee(personInfo));
            }
        }

        return companyEmployeeList;
    }

    /**
     * Ա
     *
     * @return
     */
    public DetailCompanyEmployee getDetailCompanyEmployee(PersonInfo personInfo) throws BOSException, EASBizException {

        //Ա
        DetailCompanyEmployee detailCompanyEmployee = new DetailCompanyEmployee();
        ////
        //detailCompanyEmployee.setName("");
        ////֤
        //detailCompanyEmployee.setLicenseType("֤");
        ////֤պ
        //detailCompanyEmployee.setLicenseNumber("429004198601085125");
        //
        detailCompanyEmployee.setName(personInfo.getName());
        //complexIncome.setName("");
        //֤
        if (personInfo.getIdCardNO() != null) {
            //֤պ
            detailCompanyEmployee.setLicenseNumber(personInfo.getIdCardNO());
            //֤
            detailCompanyEmployee.setLicenseType("֤");
            //Ա
            detailCompanyEmployee.setArea("");
        }
        //й
        if (personInfo.getPassportNO() != null) {
            //֤
            detailCompanyEmployee.setLicenseType("й");
            //֤պ
            detailCompanyEmployee.setLicenseNumber(personInfo.getPassportNO());
            //Ա
            detailCompanyEmployee.setArea("");
        }
        //绰
        detailCompanyEmployee.setPhone(personInfo.getCell());

        //Ա״̬
        detailCompanyEmployee.setState(personInfo.getEmployeeType().getName());
        //Ա˰Ϣ->ְܹʹҵϢ
        ITaxPersonRecordEntry iTaxPersonRecordEntry = TaxPersonRecordEntryFactory.getLocalInstance(ctx);
        TaxPersonRecordEntryCollection taxPersonRecordEntryCollection = iTaxPersonRecordEntry.getTaxPersonRecordEntryCollection("where person.id = '" + personInfo.getId() + "'");
        TaxPersonRecordEntryInfo taxPersonRecordEntryInfo = taxPersonRecordEntryCollection.get(0);
        //ְܹ  ѡԱӪԱ֤ȯˡʵϰѧȫѧ
        //detailCompanyEmployee.setIsEmployee("");
        detailCompanyEmployee.setIsEmployee(taxPersonRecordEntryInfo.getEmployedType().getAlias());
        //ܹ  YYYY-MM-DD,ܴڵǰʱ䣬ְܹѡԱӪԱ֤ȯʱ¼
        SimpleDateFormat inputFormat = new SimpleDateFormat("yyyy-MM-dd");
        detailCompanyEmployee.setEmployedDate(inputFormat.format(taxPersonRecordEntryInfo.getEmployedDate()));
        //Ա
        detailCompanyEmployee.setGender(personInfo.getGender().getAlias());
        //
        detailCompanyEmployee.setBirthday(inputFormat.format(personInfo.getBirthday()));
        // nationality
        NationalityInfo nationality = personInfo.getNationality();
        detailCompanyEmployee.setNationality(nationality.getName());

        return detailCompanyEmployee;
    }


    private String getCheckSqlByType(Map<String, Object> incomeIdMap, String taxUnitId, String yearMonth, TbTypeEnum typeEnum) {
        StringBuilder sqlBuf = new StringBuilder();
        sqlBuf.append(" SELECT distinct tx.FTAXUNITID,t1.Fname_l2 as TAXNAME,p1.FNUMBER,p1.Fname_l2 as PERSONNAME, ti.fIncomeCode ");
        sqlBuf.append(" FROM T_HR_STaxCalConfigDetail tx  ");
        sqlBuf.append(" left join T_HR_TAXUNIT as t1 on t1.fid = tx.FTaxUnitID  ");
        sqlBuf.append(" left join T_BD_PERSON as p1 on p1.fid = tx.FPersonId  ");
        sqlBuf.append(" left join t_hr_sTaxIncomeItem as ti on tx.fIncomeItemId = ti.fid ");
        String dateFilter = CmpSQLUtil.generateSqlDateFilter("tx.FPeriodBegin", "tx.FPeriodEnd", yearMonth);
        sqlBuf.append(" where ").append(dateFilter);
        sqlBuf.append(" and tx.FTAXUNITID='").append(taxUnitId).append("'");
        sqlBuf.append(" and tx.FSTATE=10");
        sqlBuf.append(" and tx.FIsLast=1");
        sqlBuf.append(" and tx.FIncomeItemId in ").append(incomeIdMap.get(typeEnum.getValue()));
        return sqlBuf.toString();
    }

    //private Map<String, Object> checkTaxDeclareData(Context ctx, List<IncomeTaxDeclarInfo> waitToDeclareList) throws BOSException {
    //    Map<String, Object> checkDataResultMap = new HashMap();
    //    return null;
    //}
    private Map<String, Object> checkTaxDeclareData(Context ctx, HttpServletRequest request, List<IncomeTaxDeclarInfo> waitToDeclareList) throws BOSException, SQLException, ShrWebBizException {
        Map<String, Object> checkDataResultMap = new HashMap();
        boolean hasErrData = false;
        if (waitToDeclareList != null && waitToDeclareList.size() > 0) {
            List<String> preCheckSql = new ArrayList();
            List<String> specCheckForPre = new ArrayList();
            List<String> notPersonCheckSql = new ArrayList();
            List<String> classifyCheckSql = new ArrayList();
            Map<String, Object> incomeIdMap = new HashMap();
            incomeIdMap.put("1", CmpTaxUtil.genIncomeItemId(ctx, "1"));
            incomeIdMap.put("2", CmpTaxUtil.genIncomeItemId(ctx, "2"));
            incomeIdMap.put("3", CmpTaxUtil.genIncomeItemId(ctx, "3"));
            Iterator i$ = waitToDeclareList.iterator();

            String yearMonth;
            while (i$.hasNext()) {
                IncomeTaxDeclarInfo declareInfo = (IncomeTaxDeclarInfo) i$.next();
                TbTypeEnum tbType = declareInfo.getTbType();
                String taxUnitId = declareInfo.getTaxUnit().getId().toString();
                yearMonth = declareInfo.getYearMonth();
                if (tbType != null) {
                    if ("1".equals(tbType.getValue())) {
                        preCheckSql.add(this.getCheckSqlByType(incomeIdMap, taxUnitId, yearMonth, TbTypeEnum.SB0701));
                        specCheckForPre.add(this.getPreCheckSql(declareInfo));
                    } else if ("3".equals(tbType.getValue())) {
                        notPersonCheckSql.add(this.getCheckSqlByType(incomeIdMap, taxUnitId, yearMonth, TbTypeEnum.SB0703));
                    } else {
                        classifyCheckSql.add(this.getCheckSqlByType(incomeIdMap, taxUnitId, yearMonth, TbTypeEnum.SB0702));
                    }
                }
            }

            Map<String, String> reasonOperaMap = new HashMap();
            reasonOperaMap.put("noCalDataReson", EASResource.getString("com.kingdee.shr.compensation.resource.CommonResource", "label140", ctx.getLocale()));
            reasonOperaMap.put("noCalDataOper", EASResource.getString("com.kingdee.shr.compensation.resource.CommonResource", "label141", ctx.getLocale()));
            reasonOperaMap.put("preDataReason", EASResource.getString("com.kingdee.shr.compensation.resource.CommonResource", "label142", ctx.getLocale()));
            reasonOperaMap.put("preDataOpera", EASResource.getString("com.kingdee.shr.compensation.resource.CommonResource", "label143", ctx.getLocale()));
            List<TaxDeclarExcelRowDTO> taxDeclareExcelRowDTOS = new ArrayList();
            taxDeclareExcelRowDTOS.addAll(this.getExceptData(ctx, preCheckSql, specCheckForPre, reasonOperaMap, TbTypeEnum.SB0701));
            taxDeclareExcelRowDTOS.addAll(this.getExceptData(ctx, classifyCheckSql, specCheckForPre, reasonOperaMap, TbTypeEnum.SB0702));
            taxDeclareExcelRowDTOS.addAll(this.getExceptData(ctx, notPersonCheckSql, specCheckForPre, reasonOperaMap, TbTypeEnum.SB0703));
            String filePath = "";
            if (taxDeclareExcelRowDTOS.size() > 0) {
                hasErrData = true;
                HSSFWorkbook workbook = new HSSFWorkbook();
                yearMonth = EASResource.getString("com.kingdee.shr.compensation.resource.CommonResource", "label144", ctx.getLocale());
                this.fillTitle(ctx, workbook, yearMonth.split(","));
                this.fillWorkdBookData(workbook, taxDeclareExcelRowDTOS);
                SimpleDateFormat format = new SimpleDateFormat("yyyyMMdd");
                File dir = new File(UserUtil.getUserTempDirAbsolutePath(request.getSession()));
                if (!dir.exists()) {
                    dir.mkdirs();
                }

                String fileName = EASResource.getString("com.kingdee.shr.compensation.resource.CommonResource", "label145", ctx.getLocale()) + "_" + format.format(new Date()) + ".xls";
                String realFileName = MD5.md5Hash(fileName);
                File file = new File(dir, realFileName);
                FileOutputStream out = null;

                try {
                    out = new FileOutputStream(file);
                    workbook.write(out);
                    out.flush();
                } catch (FileNotFoundException var33) {
                    LOG.error(var33.getMessage(), var33);
                } catch (IOException var34) {
                    LOG.error(var34.getMessage(), var34);
                } finally {
                    if (out != null) {
                        try {
                            out.close();
                        } catch (IOException var32) {
                            LOG.error(var32.getMessage(), var32);
                        }
                    }

                }

                Map<String, String> params = new HashMap();
                params.put("method", "tmp");
                params.put("file", realFileName);
                params.put("filename", fileName);
                filePath = DynamicUtil.assembleUrl("/downloadfile.do", params);
            }

            checkDataResultMap.put("excel", filePath);
        }

        checkDataResultMap.put("hasErrData", hasErrData);
        return checkDataResultMap;
    }

    private void fillTitle(Context ctx, HSSFWorkbook workbook, String[] titleArr) {
        HSSFSheet sheet = workbook.createSheet();
        HSSFRow createRow = sheet.createRow(0);
        HSSFCell infoCell = createRow.createCell(0);
        infoCell.setCellValue(EASResource.getString("com.kingdee.shr.compensation.resource.CommonResource", "label146", ctx.getLocale()));
        sheet.setColumnWidth(0, 12800);
        createRow = sheet.createRow(1);
        HSSFFont font = workbook.createFont();
        font.setColor((short) 8);
        font.setFontHeightInPoints((short) 12);
        font.setBoldweight((short) 700);
        HSSFCellStyle style = workbook.createCellStyle();
        style.setFont(font);
        style.setAlignment((short) 2);
        style.setVerticalAlignment((short) 1);
        if (titleArr != null && titleArr.length > 0) {
            for (int i = 0; i < titleArr.length; ++i) {
                HSSFCell cell = createRow.createCell(i);
                cell.setCellStyle(style);
                cell.setCellValue(titleArr[i]);
                if (i > 3) {
                    sheet.setColumnWidth(i, 15360);
                } else {
                    sheet.setColumnWidth(i, 7680);
                }
            }
        }

    }

    private void fillWorkdBookData(HSSFWorkbook workbook, List<TaxDeclarExcelRowDTO> dataList) {
        HSSFSheet sheet = workbook.getSheetAt(0);
        if (dataList != null && dataList.size() > 0) {
            for (int i = 0; i < dataList.size(); ++i) {
                HSSFRow row = sheet.createRow(i + 2);
                TaxDeclarExcelRowDTO excelRowDTO = (TaxDeclarExcelRowDTO) dataList.get(i);
                HSSFCell cell = row.createCell(0);
                cell.setCellValue(excelRowDTO.getPersonNum());
                cell = row.createCell(1);
                cell.setCellValue(excelRowDTO.getPersonName());
                cell = row.createCell(2);
                cell.setCellValue(excelRowDTO.getTaxName());
                cell = row.createCell(3);
                cell.setCellValue(excelRowDTO.getDeclarType());
                cell = row.createCell(4);
                cell.setCellValue(excelRowDTO.getReason());
                cell = row.createCell(5);
                cell.setCellValue(excelRowDTO.getOperation());
            }
        }

    }

    private String getSqlDateFilterLqDate(String dateStr) {
        String[] beginDateArr = dateStr.split("-");
        Calendar calendar = Calendar.getInstance();
        calendar.set(Integer.parseInt(beginDateArr[0]), Integer.parseInt(beginDateArr[1]) - 1, 1, 0, 0, 0);
        Date beginDate = calendar.getTime();
        return CmpDateUtil.toKSqlDate(beginDate);
    }

    private List<TaxDeclarExcelRowDTO> getExceptData(Context ctx, List<String> preCheckSql, List<String> specCheckForPre, Map<String, String> noCalDataOper, TbTypeEnum typeEnum) throws BOSException, SQLException, ShrWebBizException {
        List<TaxDeclarExcelRowDTO> taxDeclarExcelRowDTOS = new ArrayList();
        Iterator i$;
        String s;
        IRowSet rowSet;
        TaxDeclarExcelRowDTO taxDeclareExcelRow;
        if (preCheckSql != null && preCheckSql.size() > 0) {
            i$ = preCheckSql.iterator();

            while (i$.hasNext()) {
                s = (String) i$.next();
                rowSet = DbUtil.executeQuery(ctx, s);

                while (rowSet.next()) {
                    taxDeclareExcelRow = new TaxDeclarExcelRowDTO();
                    taxDeclareExcelRow.setPersonNum(rowSet.getString("FNUMBER"));
                    taxDeclareExcelRow.setPersonName(rowSet.getString("PERSONNAME"));
                    String taxUnitName = rowSet.getString("TAXNAME");
                    taxDeclareExcelRow.setTaxName(taxUnitName);
                    taxDeclareExcelRow.setDeclarType(typeEnum.getAlias());
                    taxDeclareExcelRow.setReason((String) noCalDataOper.get("noCalDataReson"));
                    taxDeclareExcelRow.setOperation((String) noCalDataOper.get("noCalDataOper"));
                    String incomeCode = (String) noCalDataOper.get("fIncomeCode");
                    taxDeclarExcelRowDTOS.add(taxDeclareExcelRow);
                }
            }
        }

        if ("1".equals(typeEnum.getValue()) && specCheckForPre != null && specCheckForPre.size() > 0) {
            i$ = specCheckForPre.iterator();

            while (i$.hasNext()) {
                s = (String) i$.next();
                rowSet = DbUtil.executeQuery(ctx, s);

                while (rowSet.next()) {
                    taxDeclareExcelRow = new TaxDeclarExcelRowDTO();
                    taxDeclareExcelRow.setPersonNum(rowSet.getString("FNUMBER"));
                    taxDeclareExcelRow.setPersonName(rowSet.getString("PERSONNAME"));
                    taxDeclareExcelRow.setTaxName(rowSet.getString("TAXNAME"));
                    taxDeclareExcelRow.setDeclarType(typeEnum.getAlias());
                    taxDeclareExcelRow.setReason((String) noCalDataOper.get("preDataReason"));
                    taxDeclareExcelRow.setOperation((String) noCalDataOper.get("preDataOpera"));
                    taxDeclarExcelRowDTOS.add(taxDeclareExcelRow);
                }
            }
        }

        return taxDeclarExcelRowDTOS;
    }

    private String getPreCheckSql(IncomeTaxDeclarInfo incomeTaxDeclarInfo) {
        StringBuilder sqlBuf = new StringBuilder();
        String yearMonth = incomeTaxDeclarInfo.getYearMonth();
        String taxUnitId = incomeTaxDeclarInfo.getTaxUnit().getId().toString();
        String sql = "select FPersonID from T_HR_STaxCalConfigDetail where FTaxUnitId='" + taxUnitId + "' and FPeriodBegin = " + CmpDateUtil.toKSqlDate(incomeTaxDeclarInfo.getYearMonthDate());
        sqlBuf.append(" SELECT distinct ent.FTAXUNITID, t.Fname_l2 as TAXNAME, p.FNUMBER, p.Fname_l2 as PERSONNAME ");
        sqlBuf.append(" FROM T_HR_STaxPersonRecordEntry ent ");
        sqlBuf.append(" left join T_HR_TAXUNIT as t on t.fid = ent.FTaxUnitID ");
        sqlBuf.append(" left join T_BD_PERSON as p on p.fid = ent.FPersonId ");
        sqlBuf.append(" where ent.FSubmitStatus='2' and ent.FPersonStatus='1' ");
        sqlBuf.append(" and ent.FTaxUnitID='").append(taxUnitId).append("'");
        sqlBuf.append(" and ent.FENDDATE <=").append(this.getSqlDateFilterLqDate(yearMonth));
        sqlBuf.append(" and ent.FPersonID not in ( ").append(sql).append(" )");
        return sqlBuf.toString();
    }

    private Map<String, Object> checkIncomeTaxIssue(Context ctx, List<IncomeTaxDeclarInfo> waitToDeclareList) throws BOSException {
        StringBuilder taxUnitIds = new StringBuilder();

        IncomeTaxDeclarInfo declareInfo;
        for (Iterator i$ = waitToDeclareList.iterator(); i$.hasNext(); taxUnitIds.append(declareInfo.getTaxUnit().getId().toString())) {
            declareInfo = (IncomeTaxDeclarInfo) i$.next();
            if (taxUnitIds.length() > 0) {
                taxUnitIds.append(",");
            }
        }

        String oql = "select person.person.name where taxUnit.id in " + CmpStrUtil.buildInSql(taxUnitIds.toString()) + " and result = " + 1 + " and status = " + 2 + " and inviteStatus = " + 0;
        IncomeTaxIssueCollection collection = IncomeTaxIssueFactory.getLocalInstance(ctx).getIncomeTaxIssueCollection(oql);
        if (collection != null && !collection.isEmpty()) {
            StringBuilder errMsg = new StringBuilder();

            for (int i = 0; i < collection.size() && i != 5; ++i) {
                if (errMsg.length() > 0) {
                    errMsg.append(",");
                }

                errMsg.append("[").append(collection.get(i).getPerson().getPerson().getName()).append("]");
            }

            Map<String, Object> map = new HashMap();
            map.put("errMsg", "Աʵ飬δȷϣҪзȷϺſɽи˰걨߽зԱͣԱ˰ϢеԱ״̬ΪԱͳɹԱ" + errMsg.toString() + "ѡ[]ת[-ʵԱ]бѡ[]ת[Ա˰Ϣ]б");
            map.put("issueError", true);
            return map;
        } else {
            return null;
        }
    }

    private String checkTaxCalStatus(Context ctx, List<IncomeTaxDeclarInfo> waitToDeclareList) throws SHRWebException {
        String sql = "select t.fState, u.fName_l2 taxUnitName, d.fIncomeItemId  from t_hr_sTaxCalConfigDetail d left join t_hr_sTaxCalInitDetail t  on d.fCmpCalTableId = t.fCmpCalTableId and d.fIncomeItemId = t.fIncomeItemId  left join t_hr_taxUnit u on d.fTaxUnitId = u.fid  where d.fTaxUnitId = ? and d.fPeriodBegin = ?";

        try {
            Iterator i$ = waitToDeclareList.iterator();

            boolean isTaxCalFinished;
            String taxUnitName;
            do {
                if (!i$.hasNext()) {
                    return null;
                }

                IncomeTaxDeclarInfo declareInfo = (IncomeTaxDeclarInfo) i$.next();
                String taxUnitId = declareInfo.getTaxUnit().getId().toString();
                Date periodDate = declareInfo.getYearMonthDate();
                Object[] param = new Object[]{taxUnitId, CmpDateUtil.toSqlDate(periodDate)};
                IRowSet rs = DbUtil.executeQuery(ctx, sql, param);
                boolean havingSalaryIncome = false;
                isTaxCalFinished = true;
                taxUnitName = "";

                while (rs.next()) {
                    int state = rs.getInt("fState");
                    taxUnitName = rs.getString("taxUnitName");
                    String incomeItemId = rs.getString("fIncomeItemId");
                    if (state != 40) {
                        isTaxCalFinished = false;
                    }

                    if ("8r0AAABCg2PDiOoP".equals(incomeItemId)) {
                        havingSalaryIncome = true;
                    }
                }

                TbTypeEnum typeEnum = declareInfo.getTbType();
                if (!havingSalaryIncome && typeEnum == TbTypeEnum.SB0701) {
                    return "˰λ[" + taxUnitName + "]ԤԤ걨δĿΪнõԱ걨ȷ";
                }
            } while (isTaxCalFinished);

            return "˰λ" + taxUnitName + "ڽӿ˰δɵݣȷ";
        } catch (Exception var15) {
            LOG.error("checkTaxCalStatus error: ", var15);
            throw new SHRWebException(var15.getMessage());
        }
    }

    /**
     * 쳣
     *
     * @param advanceDeclareInfo
     * @return
     */
    private String combineError(List<String> advanceDeclareInfo) {
        StringBuilder error = new StringBuilder();
        error.append("˰λδ걨ʱ䣬벻Ҫǰ걨");
        Iterator i$ = advanceDeclareInfo.iterator();

        while (i$.hasNext()) {
            String taxUnitInfo = (String) i$.next();
            if (advanceDeclareInfo.indexOf(taxUnitInfo) == 5) {
                error.append("...");
                break;
            }

            if (advanceDeclareInfo.indexOf(taxUnitInfo) > 0) {
                error.append("");
            }

            String[] arr = taxUnitInfo.split("_");
            error.append(arr[0]).append("").append(arr[1]).append("");
        }

        return error.toString();
    }


    /**
     * ȡ˰걨ͨ
     *
     * @param ctx
     * @param selectedId
     * @return
     * @throws BOSException
     */
    private Map<String, Object> getDeclareData(Context ctx, String selectedId) throws BOSException, JsonProcessingException {
        Map<String, Object> resultMap = new HashMap();
        List<TaxDeclareDTO> declaredList = new ArrayList();
        List<IncomeTaxDeclarInfo> waitToDeclareList = new ArrayList();
        String sqlInString = CmpUtils.spiltToSqlString(selectedId);
        if (StringUtils.isEmpty(sqlInString)) {
            sqlInString = "''";
        }

        String currentYearMonth = CmpDateUtil.getDateStr(new Date(), "yyyy-MM");
        String oqlBuffer = "select id,yearMonth,totalPerson,totalMoney,taxRebate,declareStatus,versionCode,yearMonthDate,tbType,taxUnit.id,taxUnit.name,taxUnit.taxNumber,taxUnit.regNumber,taxUnit.areaCode,taxUnit.declPassword, batchNo where id in ( " + sqlInString + " )";
        LOG.error("getDeclareData----------oqlBuffer------" + oqlBuffer);
        IncomeTaxDeclarCollection declareCollection = IncomeTaxDeclarFactory.getLocalInstance(ctx).getIncomeTaxDeclarCollection(oqlBuffer);
        LOG.error("getDeclareData----------declareCollection------" + declareCollection.size());
        String ms1 = EASResource.getString("com.kingdee.shr.compensation.resource.CommonResource", "label137", ctx.getLocale());
        String ms2 = EASResource.getString("com.kingdee.shr.compensation.resource.CommonResource", "label138", ctx.getLocale());
        String ms3 = EASResource.getString("com.kingdee.shr.compensation.resource.CommonResource", "label139", ctx.getLocale());
        List<String> taxUnitInfo = new ArrayList();
        if (declareCollection != null && declareCollection.size() > 0) {
            for (int i = 0; i < declareCollection.size(); ++i) {
                IncomeTaxDeclarInfo declareInfo = declareCollection.get(i);
                String declareStatus = declareInfo.getDeclareStatus().getValue();
                LOG.error("getDeclareData----------declareStatus------" + declareStatus);
                String taxUnitName = declareInfo.getTaxUnit().getName();
                String tbTypeAlia = declareInfo.getTbType().getAlias();
                if (currentYearMonth.compareTo(declareInfo.getYearMonth()) <= 0) {
                    taxUnitInfo.add(declareInfo.getTaxUnit().getName() + "_" + declareInfo.getYearMonth());
                }
                if (!"1".equals(declareStatus) && !"2".equals(declareStatus)) {
                    waitToDeclareList.add(declareInfo);
                    LOG.error("getDeclareData----------waitToDeclareList------" + waitToDeclareList);
                } else {
                    TaxDeclareDTO dto = new TaxDeclareDTO(taxUnitName, tbTypeAlia);
                    declaredList.add(dto);
                }
            }

            if (declaredList.size() == declareCollection.size()) {
                resultMap.put("info", ms1);
            } else if (declaredList.size() == 0) {
                resultMap.put("info", ms2);
            } else {
                resultMap.put("info", ms3);
            }
        }
        LOG.error("getDeclareData----------resultMap------" + resultMap);

        resultMap.put("DECLARED", declaredList);
        resultMap.put("advanceDeclareInfo", taxUnitInfo);
        resultMap.put("WATI_TO_DECLARE", waitToDeclareList);
        return resultMap;
    }
	
	
	
	
	
	private void updateOrCancel(HttpServletRequest request, HttpServletResponse response, TaskCatalogEnum catalog)
    		throws SHRWebException {
    	Context ctx = SHRContext.getInstance().getContext();
    	String selectedId = request.getParameter("selectedId");
    	String oql = "select id, tbType, yearMonth, yearMonthDate, taxUnit.id, taxUnit.name, taxUnit.areaCode, taxUnit.taxNumber, taxUnit.regNumber, taxUnit.declPassword, taxUnit.realPassword, acceptId where id = '"
    			+ selectedId + "'";
    	
    	try {
    		IncomeTaxDeclarCollection collection = IncomeTaxDeclarFactory.getLocalInstance(ctx)
    				.getIncomeTaxDeclarCollection(oql);
    		if (null != collection && collection.size() != 0) {
    			IncomeTaxDeclarInfo incomeTaxDeclare = collection.get(0);
    			if (TaskCatalogEnum.TaxDeclareUpdate == catalog) {
    				//
    				updateDeclare(ctx,incomeTaxDeclare);
    			} else {
    				//
    				if (TaskCatalogEnum.CancelTaxDeclare != catalog) {
    					//
    					System.out.print("ҵ");
    					cancelUpdate( ctx ,incomeTaxDeclare);
    					return;
    				}
    				//걨
    				System.out.print("걨ҵ");
    				cancelDeclare(ctx,incomeTaxDeclare);
    				System.out.print("걨");
    			}
    			
    			String templateId = "4i4AAAAS76+Vh943";
    			String columnSQL = "select t.fieldsn, f.FPROPNAME,f.fname_l2,f.fcustomfield from T_BS_SHRFileTemplateFields f left join t_HR_sTaxItem t on f.FPROPNAME = t.FNUMBER where f.fcmpimporttempid = '"
    					+ templateId + "' order by f.fsortsn ";
    			IRowSet columnSet = DbUtil.executeQuery(ctx, columnSQL);
    			StringBuilder tmpSQL = new StringBuilder();
    			tmpSQL.append("select ");
    			String dynamicFieldPrefix = "t";
    			String local = SHRContext.getInstance().getContext().getLocale().getDisplayLanguage();
    			int columnSize = columnSet.size();
    			
    			while (columnSet.next()) {
    				int index = columnSet.getInt(1);
    				String propName = columnSet.getString(2);
    				int isCustom = columnSet.getInt(4);
    				if (isCustom == 1 && index > 0) {
    					tmpSQL.append(dynamicFieldPrefix).append(index).append(",");
    				} else if (propName.endsWith("_")) {
    					tmpSQL.append(propName).append(local).append(",");
    				} else {
    					tmpSQL.append(propName).append(",");
    				}
    			}
    			
    			String sql = tmpSQL.substring(0, tmpSQL.length() - 1);
    			Date date = incomeTaxDeclare.getYearMonthDate();
    			String taxUnitId = incomeTaxDeclare.getTaxUnit().getId().toString();
    			TbTypeEnum tbType = incomeTaxDeclare.getTbType();
    			String personType = CmpConstants.getPayerTypeByTbType(tbType.getValue());
    			String dataSQL = sql
    					+ " from t_hr_sTaxCalConfigDetail t left join T_BD_Person person on t.fPersonId = person.fid left join T_HR_STaxPersonRecord taxPersonRec on t.fPersonId = taxPersonRec.fPersonId left join T_HR_TaxUnit taxUnit on t.fTaxUnitId = taxUnit.fid left join T_HR_STaxIncomeItem item on t.fIncomeItemId = item.fid left join T_HR_STaxPersonRecordEntry pEntry on taxPersonRec.fid = pEntry.fBillId where t.fPeriodBegin = "
    					+ CmpDateUtil.toKSqlDate(date) + " and t.fTaxUnitId = '" + taxUnitId
    					+ "' and pEntry.fTaxUnitId = '" + taxUnitId + "' and pEntry.fPayerType = '" + personType
    					+ "'";
    			IRowSet dataSet = DbUtil.executeQuery(ctx, dataSQL);
    			List<List<Object>> dataList = new ArrayList();
    			IRowSetMetaData metaData = dataSet.getRowSetMetaData();
    			
    			for (int rowIndex = 1; dataSet.next(); ++rowIndex) {
    				List<Object> row = new ArrayList();
    				row.add(rowIndex);
    				
    				for (int i = 1; i <= columnSize; ++i) {
    					int dataType = metaData.getColumnType(i);
    					row.add(ImplUtils.getDataFromDr(dataType, dataSet, i));
    				}
    				
    				dataList.add(row);
    			}
    			
    			String template = request.getSession().getServletContext().getRealPath("/")
    					+ "addon/compensation/web/resource/incomeTaxSbbExportTemplate.xlsx";
    			String taxUnitName = incomeTaxDeclare.getTaxUnit().getName();
    			String tbTypeName = incomeTaxDeclare.getTbType().getAlias();
    			String period = TaxCalcFileUtils.getCnPeriod1(incomeTaxDeclare.getYearMonthDate());
    			String timestamp = TaxCalcFileUtils.getTimestamp(new Date());
    			String userTempDirAbsolutePath = UserUtil.getUserTempDirAbsolutePath(request.getSession());
    			userTempDirAbsolutePath = userTempDirAbsolutePath + "/exportExcel";
    			File dir = new File(userTempDirAbsolutePath);
    			if (!dir.exists()) {
    				dir.mkdirs();
    			}
    			
    			String fileName = "˰걨_" + taxUnitName + "_" + tbTypeName + "_" + period + "_" + timestamp
    					+ ".xlsx";
    			String path = dir.getAbsolutePath() + File.separator + fileName;
    			Map<String, String> params = new HashMap();
    			params.put("startAndEnd", TaxCalcFileUtils.getCnPeriod2(incomeTaxDeclare.getYearMonthDate()));
    			params.put("taxUnitName", taxUnitName);
    			params.put("taxUnitNumber", incomeTaxDeclare.getTaxUnit().getTaxNumber());
    			CmpExcelUtil.writeData2Template(dataList, template, 8, path, params);
    			String headerStr = "attachment;filename=" + URLEncoder.encode(fileName, "utf-8");
    			response.setHeader("Content-disposition", headerStr);
    			response.getOutputStream().write(TaxCalcFileUtils.file2ByteArray(new File(path)));
    			response.getOutputStream().flush();
    			return;
    		} else {
    			throw new SHRWebException("ûҵ걨¼");
    		}
    	} catch (Exception var37) {
    		LOG.error("updateDeclareAction error: ", var37);
    		throw new SHRWebException(var37.getMessage());
    	}
    }
		
		
		
    protected Map cancelUpdate(Context ctx, IncomeTaxDeclarInfo taxDeclare) throws BOSException {
    	try {
    		String sql = "select t.fAccept_id as acceptId from t_hr_sIncomeTaxDeclar d left join t_hr_sTaskIncomeTaxRelation r on d.fid = r.fBizId left join t_hr_sTaxCalTask t on r.fTaskId = t.fid where d.fid = '"
    				+ taxDeclare.getId().toString() + "' and t.fCatalog = " + 120;
    		IRowSet rowSet = DbUtil.executeQuery(ctx, sql);
    		if (rowSet.size() == 0) {
    			throw new BOSException("Ҳ걨id");
    		} else {
    			while (rowSet.next()) {
    				taxDeclare.setAcceptId(rowSet.getString("acceptId"));
    			}
    			
    			return  updateOrCancel(ctx, taxDeclare, TaskCatalogEnum.CancelTaxUpdate);
    		}
    	} catch (SQLException var5) {
    		LOG.error("_cancelUpdate error: ", var5);
    		throw new BOSException(var5.getMessage());
    	}
    }
    
    
    
    private Map updateOrCancel(Context ctx, IncomeTaxDeclarInfo taxDeclare, TaskCatalogEnum catalog)
    		throws BOSException {
    	JSONObject param = new JSONObject();
    	String billId = StringUtils.cnulls(taxDeclare.getId());
    	param.put("taxDeclarId", billId);
    	param.put("taxDeclarBatchNo", StringUtils.cnulls(taxDeclare.getBatchNo()) );
    	Map<String, Object> paramMap = new HashMap();
    	DeclareCancelRequest requestObj = new DeclareCancelRequest();
    	TaxUnitInfo taxUnit = taxDeclare.getTaxUnit();
    	/// bizNo	ⲿҵ	String(64)		ⲿҵţΨһݵҪ64λ,ʹUUID
    	String bizNo = UUID.randomUUID().toString();
    	paramMap.put("bizNo" , bizNo);
    	requestObj.setBizNo(bizNo);
    	//qymc	ҵ	String(64)		ҵȫ
    	System.out.print("ҵΪ"+taxUnit.getName());
    	paramMap.put("qymc" , taxUnit.getName() );
    	requestObj.setName(taxUnit.getName());
    	//djxhid	Ǽ	String(64)		ڶǼʱҪָһ.10117440105249764755
    	paramMap.put("djxhid" , taxUnit.getRegNumber());
    	requestObj.setRegistrationNumber(taxUnit.getRegNumber());
    	//nsrsbh	˰	String(64)		۽ɵλ˰ʶ
    	paramMap.put("nsrsbh" , taxUnit.getTaxNumber());
    	requestObj.setTaxNo(taxUnit.getTaxNumber());
    	//areaid		String(64)		6λ,ȷм磺440100,οʡ
    	paramMap.put("areaid" , taxUnit.getAreaCode());
    	requestObj.setArea(taxUnit.getAreaCode());
    	//bmbh	ű	String(64)		ֲŴʱش
    	//bmmc		String(64)		
    	//skssq		String(64)		ʽYYYYMMΪʱ, ְܹжϣ
    	String period = taxDeclare.getYearMonth();
    	period = period.contains("-") ? period.replace("-", "") : period;
    	period = period.substring(0, 6);
    	requestObj.setMonth(period);
    	paramMap.put("skssq" , period);
    	//sblx	걨	String(64)		1:ۺ;2:;3:Ǿ;4:۹
    	paramMap.put("sblx" , "1");
    	requestObj.setDeclarationType("1");
    	//sfqksd	Ƿ	String(64)		0 1 , ĬΪ0, 걨ͬʱ
    	requestObj.setCancelImportDataOption("0");
    	//jmsmmm	ʵ	String(64)		ĬϲΪ00ʾܣ1ʾ
    	paramMap.put("jmsbmm" , "0");
    	requestObj.setEncryptedRealNamePassword("0");
    	if (!StringUtils.isEmpty(taxUnit.getRealPassword())) {
    		//mmlx		String(64)		ĬϲΪ0 0ʾ걨룻2ʾʵ˺ʵ
    		paramMap.put("mmlx" , "2");
    		requestObj.setPasswordType("2");
    		//smzh	ʵ˺	String(64)		mmlx=2ʱ
    		paramMap.put("smzh",  false);
    		requestObj.setRealNameAccount("");
    		//smmm	ʵ	String(64)		mmlx=2ʱ
    		paramMap.put("smmm", Base64Utils.decode(taxUnit.getRealPassword()));
    		requestObj.setRealNamePassword(Base64Utils.decode(taxUnit.getRealPassword()));
    	}
    	if (!StringUtils.isEmpty(taxUnit.getDeclPassword())) {
    		//sbmm	걨	String(64)		mmlx=0ʱ
    		paramMap.put("sbmm", Base64Utils.decode(taxUnit.getDeclPassword()));
    		requestObj.setDeclarePassword(Base64Utils.decode(taxUnit.getDeclPassword()));
    		//mmlx		String(64)		ĬϲΪ0 0ʾ걨룻2ʾʵ˺ʵ
    		paramMap.put("mmlx" , "0");
    		requestObj.setPasswordType("0");
    	}
    	
    	
    	//ͻ˴
    	try {
    		ClientProxyFactory clientProxyFactory  = ClientProxyFactoryUtils.getClientProxyFactory();
    		//˰ӿ
    		DeclarationRequest declarationRequest = clientProxyFactory.getDeclarationRequest();
    		//ȡ
    		if(  catalog.equals(TaskCatalogEnum.CancelTaxDeclare) ) {
//    			Gson gson = new Gson();  
//    			Type personType = new TypeToken<DeclareCancelRequest>(){}.getType();  
//    			DeclareCancelRequest newObj = gson.fromJson(gson.toJson(requestObj), personType);  
    			LOG.error("걨ִв"+mapper.writeValueAsString(requestObj));
    			//CancelTaxDeclare  걨  140
    			ApiResponse<AsyncResult> apiResponse = declarationRequest.cancel (requestObj);
    			LOG.error("걨ִн"+apiResponse.getHead().getMsg());
    			if (apiResponse.getHead().getCode().equals("00000000")) {
    				AsyncResult body = apiResponse.getBody();
    				String requestId = body.getRequestId();
    				LOG.error("requestId-----" + requestId);
    				ISYUtilsFacade isyUtilsFacade = SYUtilsFacadeFactory.getLocalInstance(ctx);
    				//backTask(url,requestId,صosf,Զ,)
    				JSONObject json = new JSONObject();
    				json.put("requestId", requestId);
    				json.put("reportType", "1");
//    				
//    				JSONObject paramJson = new JSONObject();
//    				paramJson.put("taxDeclarId", taxDeclare.getId().toString());
//    				paramJson.put("taxDeclarBatchNo", taxDeclare.getBatchNo());
    				json.put("param", param );
    				LOG.error("걨ִеų́ʼ"+param);
    				isyUtilsFacade.addTask("CancelDeclareService", json.toJSONString(), TaskCatalogEnum.CancelTaxDeclare, "");
    				LOG.error("걨ִеų́");
    			}
    		}else if(catalog.equals(TaskCatalogEnum.TaxDeclareUpdate)) {
    			//걨  120
//    			Gson gson = new Gson();  
//    			Type personType = new TypeToken<DeclareCorrectRequest>(){}.getType();  
//    			DeclareCorrectRequest newObj = gson.fromJson(gson.toJson(paramMap), personType);  
    			ObjectMapper mapper = new ObjectMapper();  
    			DeclareCorrectRequest newObj = mapper.convertValue(paramMap, DeclareCorrectRequest.class);  
    			LOG.error("걨ִв"+mapper.writeValueAsString(newObj));
    			ApiResponse<AsyncResult> apiResponse = declarationRequest.correct (newObj);
    			LOG.error("걨ִн"+apiResponse.getHead().getMsg());
    			if (apiResponse.getHead().getCode().equals("00000000")) {
    				//ͬӿڣ
    				//˰걨κ
    				String taxDeclarBatchNo = taxDeclare.getBatchNo();
    				IIncomeTaxDeclar iIncomeTaxDeclar = IncomeTaxDeclarFactory.getLocalInstance(ctx);
    				IncomeTaxDeclarInfo incomeTaxDeclarInfo = iIncomeTaxDeclar.getIncomeTaxDeclarInfo(new ObjectUuidPK(billId));
    				SelectorItemCollection updateSic = new SelectorItemCollection();
    				updateSic.add("declareStatus");
    				if (null != incomeTaxDeclarInfo) {
    					incomeTaxDeclarInfo.setDeclareStatus(TaxDeclareStatusEnum.DECLARE_NO);
    					iIncomeTaxDeclar.updatePartial(incomeTaxDeclarInfo, updateSic);
    				}
    			}
    		}else if(catalog.equals(TaskCatalogEnum.CancelTaxUpdate )) {
    			System.out.print("ִ");
    			//걨
//    			Gson gson = new Gson();  
//    			Type personType = new TypeToken<DeclareCorrectRequest>(){}.getType();  
//    			DeclareCorrectRequest newObj = gson.fromJson(gson.toJson(paramMap), personType);  
    			ObjectMapper mapper = new ObjectMapper();
    			DeclareCorrectRequest convertValue = mapper.convertValue(paramMap, DeclareCorrectRequest.class);
    			LOG.error("ִв"+mapper.writeValueAsString(convertValue));
    			ApiResponse<AsyncResult> apiResponse = declarationRequest.cancelCorrect (convertValue);
    			LOG.error("ִн"+apiResponse.getHead().getMsg());
    			if (apiResponse.getHead().getCode().equals("00000000")) {
    				//ͬӿڣ
    				//˰걨κ
    				String taxDeclarBatchNo = taxDeclare.getBatchNo();
    				IIncomeTaxDeclar iIncomeTaxDeclar = IncomeTaxDeclarFactory.getLocalInstance(ctx);
//    				IncomeTaxDeclarCollection incomeTaxDeclarCollection = iIncomeTaxDeclar.getIncomeTaxDeclarCollection("where batchNo = '" + taxDeclarBatchNo + "'");
    				IncomeTaxDeclarInfo incomeTaxDeclarInfo = iIncomeTaxDeclar.getIncomeTaxDeclarInfo(new ObjectUuidPK(billId));
    				SelectorItemCollection updateSic = new SelectorItemCollection();
    				updateSic.add("declareStatus");
    				if (null != incomeTaxDeclarInfo) {
//    					IncomeTaxDeclarInfo incomeTaxDeclarInfo = incomeTaxDeclarCollection.get(0);
    					incomeTaxDeclarInfo.setDeclareStatus(TaxDeclareStatusEnum.DECLARE_SUCCESS);
    					iIncomeTaxDeclar.updatePartial(incomeTaxDeclarInfo, updateSic);
    				}
    			}
    		}
    	} catch (IOException e) {
    		e.printStackTrace();
    	} catch (EASBizException e) {
    		e.printStackTrace();
    	}
    	return paramMap;
    }
    

		
		
		
    
    
    
    /**
     * 
     * @param ctx
     * @param taxDeclare
     * @return
     * @throws BOSException
     */
    protected Map cancelDeclare(Context ctx, IncomeTaxDeclarInfo taxDeclare) throws BOSException {
    	return this.updateOrCancel(ctx, taxDeclare, TaskCatalogEnum.CancelTaxDeclare);
    }
    
    
    
    
    /**
     * 
     * @param ctx
     * @param taxDeclare
     * @return
     * @throws BOSException
     */
    protected Map updateDeclare(Context ctx, IncomeTaxDeclarInfo taxDeclare) throws BOSException {
    	return  updateOrCancel(ctx, taxDeclare, TaskCatalogEnum.TaxDeclareUpdate);
    }
    
    
    /**
     * 걨
     * 
     */
    public void cancelDeclareAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap)
    		throws SHRWebException {
    	this.updateOrCancel(request, response, TaskCatalogEnum.CancelTaxDeclare);
    	request.setAttribute(CmpConstants.CMP_LOG_OPERATE, "cancelDeclare");
    }
    
    /**
     * 
     */
    public void updateDeclareAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap)
    		throws SHRWebException {
    	this.updateOrCancel(request, response, TaskCatalogEnum.TaxDeclareUpdate);
    	request.setAttribute(CmpConstants.CMP_LOG_OPERATE, "updateDeclare");
    }
    
    /**
     * 
     * 
     */
    public void cancelUpdateAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap)
    		throws SHRWebException {
    	this.updateOrCancel(request, response, TaskCatalogEnum.CancelTaxUpdate);
    	request.setAttribute(CmpConstants.CMP_LOG_OPERATE, "cancelUpdate");
    }
    
    
	
}
