package com.kingdee.eas.custom.compensation.service;

import java.io.IOException;
import java.math.BigDecimal;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.log4j.Logger;

import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.bsf.service.app.IHRMsfService;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.metadata.entity.EntityViewInfo;
import com.kingdee.bos.metadata.entity.FilterInfo;
import com.kingdee.bos.metadata.entity.FilterItemInfo;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.eas.basedata.person.IPerson;
import com.kingdee.eas.basedata.person.PersonFactory;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.shuiyou.interfacelog.LogInfoFactory;
import com.kingdee.eas.custom.shuiyou.interfacelog.LogInfoInfo;
import com.kingdee.eas.custom.shuiyou.task.MessageResult;
import com.kingdee.eas.custom.shuiyou.utils.ClientProxyFactoryUtils;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.shr.compensation.TaxDeclareStatusEnum;
import com.kingdee.shr.compensation.app.incomeTax.TaxPersonRecordFactory;
import com.kingdee.shr.compensation.app.incomeTax.TaxPersonRecordInfo;
import com.kingdee.shr.compensation.app.tax.IIncomeTaxDeclar;
import com.kingdee.shr.compensation.app.tax.ITaxDeclaration;
import com.kingdee.shr.compensation.app.tax.IncomeTaxDeclarCollection;
import com.kingdee.shr.compensation.app.tax.IncomeTaxDeclarFactory;
import com.kingdee.shr.compensation.app.tax.IncomeTaxDeclarInfo;
import com.kingdee.shr.compensation.app.tax.TaxDeclarationCollection;
import com.kingdee.shr.compensation.app.tax.TaxDeclarationFactory;
import com.kingdee.shr.compensation.app.tax.TaxDeclarationInfo;
import com.kingdee.shr.compensation.app.tax.TaxUnitInfo;
import com.kingdee.shr.compensation.app.tax.base.ITaxIncomeItem;
import com.kingdee.shr.compensation.app.tax.base.TaxIncomeItemFactory;
import com.kingdee.shr.compensation.app.tax.base.TaxIncomeItemInfo;

import cn.com.servyou.dto.ApiResponse;
import cn.com.servyou.dto.declare.Feedback;
import cn.com.servyou.rmi.client.ClientProxyFactory;
import cn.com.servyou.service.DeclarationRequest;

/**
 * 걨
 * @author coyle
 *
 */
public class CancelDeclareService implements IHRMsfService {
    Logger logger = Logger.getLogger("com.kingdee.eas.custom.compensation.service.CancelDeclareService");

    public Object process(Context context, Map map) throws EASBizException, BOSException {
        //ӿ־ʵ
        LogInfoInfo logInfo = new LogInfoInfo();
        //
        logInfo.setEntrance(this.getClass().getName());
        logInfo.setBizDate(new Date());
        Map resMap = new HashMap();
        logger.error("CancelDeclareService----------OSF----Start");
        JSONObject paramData = JSONObject.parseObject((String) map.get("paramData"));
        logger.error("paramData--------" + paramData);
        String requestId = paramData.getString("requestId");
        JSONObject param = paramData.getJSONObject("param");
        logger.error("requestId--------" + requestId);
        logger.error("param--------" + param);
        ObjectMapper mapper = new ObjectMapper();
        try {
            //ͻ˴
            ClientProxyFactory clientProxyFactory = ClientProxyFactoryUtils.getClientProxyFactory();
            //˰ӿ
            DeclarationRequest declarationRequest = clientProxyFactory.getDeclarationRequest();
            //걨ݷ  requestIdId   reportType:걨[1:ۺ;2:;3:Ǿ;4:۹]
            ApiResponse<Feedback> feedback = declarationRequest.getCancelFeedback(requestId, "1");
            logInfo.setInterfaceAddress("/gateway/iit/report/getCancelFeedback");//ӿڵַ
            logInfo.setInterfaceName("getCancelFeedback");//ӿ
            logger.error("getCancelFeedback--------" + mapper.writeValueAsString(feedback));
            String status = feedback.getHead().getStatus();
            Feedback body = null;
            if ("N".equals(status)) {
                //ʧӦ
                String msg = feedback.getHead().getMsg();
                return MessageResult.FAILED(msg);
            } else {
                //óɹ
                //id
                body = feedback.getBody();
                logInfo.setOutParameter(mapper.writeValueAsString(body));//ز
                LogInfoFactory.getLocalInstance(context).addnew(logInfo);
                saveTaxDeclaration(context, param);
            }
            return MessageResult.SUCCESS(mapper.writeValueAsString(body));
        } catch (IOException e) {
            e.printStackTrace();
            logInfo.setErrorInfo(e.getMessage());//Ϣ
            LogInfoFactory.getLocalInstance(context).save(logInfo);
            //throw new BOSException(e);
            return MessageResult.ERROR(e.getMessage());
        }
    }

    /**
     * ˰걨
     *
     * @param param
     */
    public void saveTaxDeclaration(Context ctx, JSONObject param) throws BOSException, EASBizException {
        logger.error("saveTaxDeclaration------------------");
        //˰걨ID
        String taxDeclarId = param.getString("taxDeclarId");

        //˰걨κ
//        String taxDeclarBatchNo = param.getString("taxDeclarBatchNo");
        IIncomeTaxDeclar iIncomeTaxDeclar = IncomeTaxDeclarFactory.getLocalInstance(ctx);
        IncomeTaxDeclarCollection incomeTaxDeclarCollection = iIncomeTaxDeclar.getIncomeTaxDeclarCollection("where id = '" + taxDeclarId + "'");
        SelectorItemCollection updateSic = new SelectorItemCollection();
        updateSic.add("isCancelled");
        updateSic.add("declareStatus");
        logger.info("ѯ˰걨ݣ"+incomeTaxDeclarCollection.size()+"") ;
        if (incomeTaxDeclarCollection.size() > 0) {
            IncomeTaxDeclarInfo incomeTaxDeclarInfo = incomeTaxDeclarCollection.get(0);
            logger.info("ѯ˰걨ݣ"+incomeTaxDeclarInfo.getId()) ;
            incomeTaxDeclarInfo.setIsCancelled(1);
            incomeTaxDeclarInfo.setDeclareStatus(TaxDeclareStatusEnum.DECLARE_NO );
            iIncomeTaxDeclar.updatePartial(incomeTaxDeclarInfo, updateSic);
            logger.error("saveTaxDeclaration------");
        }
          
    }

     
    
	
	
	
	
	
}

