package com.kingdee.eas.custom.compensation.service;

import cn.com.servyou.dto.ApiResponse;
import cn.com.servyou.dto.declare.Feedback;
import cn.com.servyou.rmi.client.ClientProxyFactory;
import cn.com.servyou.service.DeclarationRequest;
import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.bsf.service.app.IHRMsfService;
import com.kingdee.bos.ctrl.swing.StringUtils;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.metadata.entity.EntityViewInfo;
import com.kingdee.bos.metadata.entity.FilterInfo;
import com.kingdee.bos.metadata.entity.FilterItemInfo;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.eas.basedata.person.IPerson;
import com.kingdee.eas.basedata.person.PersonFactory;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.shuiyou.interfacelog.LogInfoFactory;
import com.kingdee.eas.custom.shuiyou.interfacelog.LogInfoInfo;
import com.kingdee.eas.custom.shuiyou.task.MessageResult;
import com.kingdee.eas.custom.shuiyou.utils.ClientProxyFactoryUtils;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.shr.compensation.TaxDeclareStatusEnum;
import com.kingdee.shr.compensation.app.incomeTax.TaxPersonRecordFactory;
import com.kingdee.shr.compensation.app.incomeTax.TaxPersonRecordInfo;
import com.kingdee.shr.compensation.app.tax.*;
import com.kingdee.shr.compensation.app.tax.base.ITaxIncomeItem;
import com.kingdee.shr.compensation.app.tax.base.TaxIncomeItemFactory;
import com.kingdee.shr.compensation.app.tax.base.TaxIncomeItemInfo;
import com.kingdee.shr.compensation.app.taxCal.ITaxCalConfigDetail;
import com.kingdee.shr.compensation.app.taxCal.TaxCalConfigDetailCollection;
import com.kingdee.shr.compensation.app.taxCal.TaxCalConfigDetailFactory;
import com.kingdee.shr.compensation.app.taxCal.TaxCalConfigDetailInfo;
import org.apache.log4j.Logger;

import java.io.IOException;
import java.math.BigDecimal;
import java.sql.SQLException;
import java.util.*;

/**
 * @author qingwu
 * @date 2024/9/19
 * @apiNote
 */
public class SynIncomeTaxDeclareService implements IHRMsfService {
    Logger logger = Logger.getLogger("com.kingdee.eas.custom.compensation.service.SynIncomeTaxDeclareService");

    public Object process(Context context, Map map) throws EASBizException, BOSException {
        //ӿ־ʵ
        LogInfoInfo logInfo = new LogInfoInfo();
        //
        logInfo.setEntrance(this.getClass().getName());
        logInfo.setBizDate(new Date());
        Map resMap = new HashMap();
        logger.error("SynIncomeTaxDeclareService----------OSF----Start");
        JSONObject paramData = JSONObject.parseObject((String) map.get("paramData"));
        logger.error("paramData--------" + paramData);
        String requestId = paramData.getString("requestId");
        JSONObject param = paramData.getJSONObject("param");
        logger.error("requestId--------" + requestId);
        logger.error("param--------" + param);
        ObjectMapper mapper = new ObjectMapper();
        try {
            //ͻ˴
            ClientProxyFactory clientProxyFactory = ClientProxyFactoryUtils.getClientProxyFactory();
            //˰ӿ
            DeclarationRequest declarationRequest = clientProxyFactory.getDeclarationRequest();
            //걨ݷ  requestIdId   reportType:걨[1:ۺ;2:;3:Ǿ;4:۹]
            ApiResponse<Feedback> feedback = declarationRequest.getFeedback(requestId, "1");
            logInfo.setInterfaceAddress("/gateway/iit/report/getFeedback");//ӿڵַ
            logInfo.setInterfaceName("getFeedback");//ӿ
            logger.error("feedback--------" + mapper.writeValueAsString(feedback));
            String status = feedback.getHead().getStatus();
            Feedback body = null;
            if ("N".equals(status)) {
                //ʧӦ
                String msg = feedback.getHead().getMsg();
                //throw new BOSException(msg);
                logInfo.setStatus("");
                return MessageResult.FAILED(msg);
            } else {
                //óɹ
                //id
                body = feedback.getBody();
                logInfo.setOutParameter(mapper.writeValueAsString(body));//ز
                if (body.getDeclarationStateCode().equals("6") || body.getDeclarationStateCode().equals("5")) {
                    saveTaxDeclaration(context, param);
                }
                logInfo.setStatus("ɹ");
            }
            LogInfoFactory.getLocalInstance(context).addnew(logInfo);
            return MessageResult.SUCCESS(mapper.writeValueAsString(body));
        } catch (IOException e) {
            e.printStackTrace();
            logInfo.setErrorInfo(e.getMessage());//Ϣ
            logInfo.setStatus("ʧ");
            LogInfoFactory.getLocalInstance(context).save(logInfo);
            //throw new BOSException(e);
            return MessageResult.ERROR(e.getMessage());
        }
    }

    /**
     * ˰걨
     *
     * @param param
     */
    public void saveTaxDeclaration(Context ctx, JSONObject param) throws BOSException, EASBizException {
        logger.error("saveTaxDeclaration------------------");
        //˰걨ID
        //String taxDeclarId = param.getString("taxDeclarId");
        //˰걨κ
        String taxDeclarBatchNo = param.getString("taxDeclarBatchNo");
        IIncomeTaxDeclar iIncomeTaxDeclar = IncomeTaxDeclarFactory.getLocalInstance(ctx);
        IncomeTaxDeclarCollection incomeTaxDeclarCollection = iIncomeTaxDeclar.getIncomeTaxDeclarCollection("where batchNo = '" + taxDeclarBatchNo + "'");
        SelectorItemCollection updateSic = new SelectorItemCollection();
        updateSic.add("declareStatus");
        if (incomeTaxDeclarCollection.size() > 0) {
            IncomeTaxDeclarInfo incomeTaxDeclarInfo = incomeTaxDeclarCollection.get(0);
            incomeTaxDeclarInfo.setDeclareStatus(TaxDeclareStatusEnum.DECLARE_SUCCESS);
            iIncomeTaxDeclar.updatePartial(incomeTaxDeclarInfo, updateSic);
        }
        ////˰Ӧ+˰ղϸ
        //ITaxCalConfigDetail taxCalConfigDetail = TaxCalConfigDetailFactory.getLocalInstance(ctx);
        //TaxCalConfigDetailCollection taxCalConfigDetailCollection = taxCalConfigDetail.getTaxCalConfigDetailCollection("select *,incomeItem.*, person.* where batchNo = '" + taxDeclarBatchNo + "' and state = '20'");
        //for (int i = 0; i < taxCalConfigDetailCollection.size(); i++) {
        //    TaxCalConfigDetailInfo taxCalConfigDetailInfo = taxCalConfigDetailCollection.get(i);
        //    //ԱϢ
        //    PersonInfo person = taxCalConfigDetailInfo.getPerson();
        //}
        try {
            //˰걨
            ITaxDeclaration iTaxDeclaration = TaxDeclarationFactory.getLocalInstance(ctx);
            //˰Ŀ
            ITaxIncomeItem iTaxIncomeItem = TaxIncomeItemFactory.getLocalInstance(ctx);
            IPerson iPerson = PersonFactory.getLocalInstance(ctx);
            List<Map<String, Object>> taxDeclarationDate = getTaxDeclarationDate(ctx, taxDeclarBatchNo);
            for (int i = 0; i < taxDeclarationDate.size(); i++) {
                Map<String, Object> map = taxDeclarationDate.get(i);
                TaxIncomeItemInfo taxIncomeItemInfo = iTaxIncomeItem.getTaxIncomeItemCollection("where id = '" + map.get("incomeitmemId") + "'").get(0);
                logger.error("taxIncomeItemInfo------------------" + taxIncomeItemInfo);
                FilterInfo filterInfo = new FilterInfo();
                filterInfo.getFilterItems().add(new FilterItemInfo("person", map.get("personId"), CompareType.EQUALS));
                filterInfo.getFilterItems().add(new FilterItemInfo("taxUnit", map.get("taxunitId"), CompareType.EQUALS));
                filterInfo.getFilterItems().add(new FilterItemInfo("taxPeriodBegin", map.get("periodbegin"), CompareType.EQUALS));
                filterInfo.getFilterItems().add(new FilterItemInfo("taxPeriodEnd", map.get("periodend"), CompareType.EQUALS));
                filterInfo.getFilterItems().add(new FilterItemInfo("proceedItem", taxIncomeItemInfo.getName(), CompareType.EQUALS));
                EntityViewInfo entityViewInfo = EntityViewInfo.getInstance(filterInfo, null, null);
                TaxDeclarationCollection taxDeclarationCollection = iTaxDeclaration.getTaxDeclarationCollection(entityViewInfo);
                logger.error("taxDeclarationCollection.size------------------" + taxDeclarationCollection.size());
                if (taxDeclarationCollection.size() <= 0) {
                    TaxDeclarationInfo taxDeclarationInfo = new TaxDeclarationInfo();
                    //Ա
                    PersonInfo personInfo = iPerson.getPersonInfo(new ObjectUuidPK((String) map.get("personId")));
                    taxDeclarationInfo.setPerson(personInfo);
                    //֤
                    taxDeclarationInfo.setIdNO(personInfo.getIdCardNO());
                    //֤
                    TaxPersonRecordInfo taxPersonRecordInfo = TaxPersonRecordFactory.getLocalInstance(ctx).getTaxPersonRecordCollection("where person = '" + personInfo.getId() + "'").get(0);
                    String alias = taxPersonRecordInfo.getCardType().getAlias();
                    taxDeclarationInfo.setIdType(alias);
                    //˰λ
                    TaxUnitInfo taxUnitInfo = new TaxUnitInfo();
                    taxUnitInfo.setId(BOSUuid.read((String) map.get("taxunitId")));
                    taxDeclarationInfo.setTaxUnit(taxUnitInfo);
                    //˰ڼʼʱ
                    taxDeclarationInfo.setTaxPeriodBegin((Date) map.get("periodbegin"));
                    //˰ڼֹʱ
                    taxDeclarationInfo.setTaxPeriodEnd((Date) map.get("periodend"));
                    //˰Ŀ
                    taxDeclarationInfo.setProceedItem(taxIncomeItemInfo.getName());
                    taxDeclarationInfo.setCost((BigDecimal) map.get("t25"));//
                    taxDeclarationInfo.setIncome((BigDecimal) map.get(" t1"));//
                    taxDeclarationInfo.setExemptIncome((BigDecimal) map.get("t2"));//˰
                    taxDeclarationInfo.setBasicPension((BigDecimal) map.get("t3"));//ϱշ
                    taxDeclarationInfo.setBasicMedical((BigDecimal) map.get("t4"));//ҽƱշ
                    taxDeclarationInfo.setUnemployment((BigDecimal) map.get("t5"));//ʧҵշ
                    taxDeclarationInfo.setHousingFund((BigDecimal) map.get("t6"));//ס
                    taxDeclarationInfo.setChildEducateSum((BigDecimal) map.get("t7"));//ۼŮ
                    taxDeclarationInfo.setContinueEducateSum((BigDecimal) map.get("t8"));//ۼƼ
                    taxDeclarationInfo.setLoanInterestSum((BigDecimal) map.get("t9"));//ۼסϢ
                    taxDeclarationInfo.setHousingRentSum((BigDecimal) map.get("t10"));//ۼס
                    taxDeclarationInfo.setOldSupportSum((BigDecimal) map.get("t11"));//ۼ
                    taxDeclarationInfo.setIncomeSum((BigDecimal) map.get("t20"));//ۼ
                    taxDeclarationInfo.setDeductionSum((BigDecimal) map.get("t24"));//ۼƼ
                    taxDeclarationInfo.setSpecialDeductSum((BigDecimal) map.get("t26"));//ۼר۳
                    taxDeclarationInfo.setOtherDeductionSum((BigDecimal) map.get("t28"));//ۼ۳
                    taxDeclarationInfo.setAllowDonationSum((BigDecimal) map.get("t29"));//ۼ׼۳ľ
                    taxDeclarationInfo.setTaxableIncomeSum((BigDecimal) map.get("t30"));//ۼӦ˰ö
                    taxDeclarationInfo.setTaxRatio((BigDecimal) map.get("t31"));//˰
                    taxDeclarationInfo.setQuickDeduct((BigDecimal) map.get("t32"));//۳
                    taxDeclarationInfo.setTaxPayableSum((BigDecimal) map.get("t33"));//ۼӦ˰
                    taxDeclarationInfo.setTaxCreditSum((BigDecimal) map.get("t34"));//ۼƼ˰
                    taxDeclarationInfo.setTaxSupOrRefund((BigDecimal) map.get("t38"));//Ӧ/˰
                    taxDeclarationInfo.setInFantSum((BigDecimal) map.get("t45"));//ۼӤ׶ջ
                    taxDeclarationInfo.setPersonalPension((BigDecimal) map.get("t46"));//ۼƸϽ
                    logger.error("taxDeclarationInfo------------------" + taxDeclarationInfo);
                    IObjectPK save = iTaxDeclaration.save(taxDeclarationInfo);
                    logger.error("taxDeclarationInfo----------save--------" + save);

                }
            }
        } catch (SQLException e) {
            e.printStackTrace();
            throw new RuntimeException(e);
        } catch (EASBizException e) {
            throw new RuntimeException(e);
        }

    }

    /***
     * װ˰걨
     * @param batchNo
     * @return
     */
    public List<Map<String, Object>> getTaxDeclarationDate(Context ctx, String batchNo) throws BOSException, SQLException {
        List list = new ArrayList();
        String sql = getSql(batchNo);
        logger.error("getTaxDeclarationDate------sql--------" + sql);
        IRowSet iRowSet = DbUtil.executeQuery(ctx, sql);
        while (iRowSet.next()) {
            Map map = new HashMap();
            map.put("personId", iRowSet.getString("personId"));//ԱId
            map.put("taxunitId", iRowSet.getString("taxunitId"));//˰λId
            map.put("periodbegin", iRowSet.getDate("periodbegin"));//˰ڼʼʱ
            map.put("periodend", iRowSet.getDate("periodend"));//˰ڼֹʱ
            map.put("incomeitmemId", iRowSet.getString("incomeitmemId"));//˰ĿId
            logger.error("getTaxDeclarationDate------iRowSet.getBigDecimal(t1)--------" + iRowSet.getBigDecimal("t1"));
            map.put("t1", iRowSet.getBigDecimal("t1") == null ? BigDecimal.ZERO : iRowSet.getBigDecimal("t1"));//˰
            map.put("t2", iRowSet.getBigDecimal("t2") == null ? BigDecimal.ZERO : iRowSet.getBigDecimal("t2"));//ϱշ
            map.put("t3", iRowSet.getBigDecimal("t3") == null ? BigDecimal.ZERO : iRowSet.getBigDecimal("t3"));//ҽƱշ
            map.put("t4", iRowSet.getBigDecimal("t4") == null ? BigDecimal.ZERO : iRowSet.getBigDecimal("t4"));//ʧҵշ
            map.put("t5", iRowSet.getBigDecimal("t5") == null ? BigDecimal.ZERO : iRowSet.getBigDecimal("t5"));//ס
            map.put("t6", iRowSet.getBigDecimal("t6") == null ? BigDecimal.ZERO : iRowSet.getBigDecimal("t6"));//ۼŮ
            map.put("t7", iRowSet.getBigDecimal("t7") == null ? BigDecimal.ZERO : iRowSet.getBigDecimal("t7"));//ۼƼ
            map.put("t8", iRowSet.getBigDecimal("t8") == null ? BigDecimal.ZERO : iRowSet.getBigDecimal("t8"));//ۼסϢ
            map.put("t9", iRowSet.getBigDecimal("t9") == null ? BigDecimal.ZERO : iRowSet.getBigDecimal("t9"));//ۼס
            map.put("t10", iRowSet.getBigDecimal("t10") == null ? BigDecimal.ZERO : iRowSet.getBigDecimal("t10"));//ۼ
            map.put("t25", iRowSet.getBigDecimal("t25") == null ? BigDecimal.ZERO : iRowSet.getBigDecimal("t25"));//
            map.put("t11", iRowSet.getBigDecimal("t11") == null ? BigDecimal.ZERO : iRowSet.getBigDecimal("t11"));//
            map.put("t15", iRowSet.getBigDecimal("t15") == null ? BigDecimal.ZERO : iRowSet.getBigDecimal("t15"));//ۼ
            map.put("t20", iRowSet.getBigDecimal("t20") == null ? BigDecimal.ZERO : iRowSet.getBigDecimal("t20"));//ۼ˰
            map.put("t22", iRowSet.getBigDecimal("t22") == null ? BigDecimal.ZERO : iRowSet.getBigDecimal("t22"));//ۼƼ
            map.put("t24", iRowSet.getBigDecimal("t24") == null ? BigDecimal.ZERO : iRowSet.getBigDecimal("t24"));//ۼר۳
            map.put("t26", iRowSet.getBigDecimal("t26") == null ? BigDecimal.ZERO : iRowSet.getBigDecimal("t26"));//ۼ۳
            map.put("t28", iRowSet.getBigDecimal("t28") == null ? BigDecimal.ZERO : iRowSet.getBigDecimal("t28"));//ۼ׼۳ľ
            map.put("t29", iRowSet.getBigDecimal("t29") == null ? BigDecimal.ZERO : iRowSet.getBigDecimal("t29"));//ۼӦ˰ö
            map.put("t30", iRowSet.getBigDecimal("t30") == null ? BigDecimal.ZERO : iRowSet.getBigDecimal("t30"));//˰
            map.put("t31", iRowSet.getBigDecimal("t31") == null ? BigDecimal.ZERO : iRowSet.getBigDecimal("t31"));//۳
            map.put("t32", iRowSet.getBigDecimal("t32") == null ? BigDecimal.ZERO : iRowSet.getBigDecimal("t32"));//ۼӦ˰
            map.put("t33", iRowSet.getBigDecimal("t33") == null ? BigDecimal.ZERO : iRowSet.getBigDecimal("t33"));//ۼƼ˰
            map.put("t34", iRowSet.getBigDecimal("t34") == null ? BigDecimal.ZERO : iRowSet.getBigDecimal("t34"));//ۼӦ۽˰
            map.put("t35", iRowSet.getBigDecimal("t35") == null ? BigDecimal.ZERO : iRowSet.getBigDecimal("t35"));//ۼԤ˰
            map.put("t36", iRowSet.getBigDecimal("t36") == null ? BigDecimal.ZERO : iRowSet.getBigDecimal("t36"));//Ӧˣ˰
            map.put("t38", iRowSet.getBigDecimal("t38") == null ? BigDecimal.ZERO : iRowSet.getBigDecimal("t38"));//ע
            map.put("t41", iRowSet.getBigDecimal("t41") == null ? BigDecimal.ZERO : iRowSet.getBigDecimal("t41"));//ۼӤ׶ջ
            map.put("t45", iRowSet.getBigDecimal("t45") == null ? BigDecimal.ZERO : iRowSet.getBigDecimal("t45"));//ۼƸϽ
            list.add(map);
        }
        return list;
    }

    /**
     * ѯ˰걨Ա
     *
     * @param batchNo
     * @return
     */
    public String getSql(String batchNo) {
        StringBuilder sb = new StringBuilder();
        sb.append("select").append("\n");
        sb.append(" taxCalConfigDetail.FPERSONID as personId,").append("\n");
        sb.append(" taxCalConfigDetail.FTAXUNITID as taxunitId,").append("\n");
        sb.append("taxCalConfigDetail.FPERIODBEGIN as periodbegin,\n").append("\n");
        sb.append("taxCalConfigDetail.FPERIODEND as periodend,\n").append("\n");
        sb.append("taxCalConfigDetail.FINCOMEITEMID as incomeitmemId,\n").append("\n");
        sb.append(" t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t15,t20,t22,t24,t25,t26,t28,t29,t30,t31,t32,t33,t34,t35,t36,t38,t41,t45,t46\n").append("\n");
        sb.append(" from T_HR_STaxCalConfigDetail taxCalConfigDetail\n").append("\n");
        sb.append("where").append("\n");
        sb.append("FBATCHNO = '").append(batchNo).append("'").append("\n");
        return sb.toString();
    }


}
