package com.kingdee.eas.custom.compensation.service;

import cn.com.servyou.dto.ApiResponse;
import cn.com.servyou.dto.tax.CalculateTaxResultRequest;
import cn.com.servyou.dto.tax.ComplexIncome;
import cn.com.servyou.dto.tax.ComplexIncomeResultRequest;
import cn.com.servyou.dto.tax.ComplexTaxCalculateResult;
import cn.com.servyou.rmi.client.ClientProxyFactory;
import cn.com.servyou.service.TaxRequest;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.bsf.service.app.IHRMsfService;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.metadata.entity.EntityViewInfo;
import com.kingdee.bos.metadata.entity.FilterInfo;
import com.kingdee.bos.metadata.entity.FilterItemInfo;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.eas.basedata.person.IPerson;
import com.kingdee.eas.basedata.person.PersonCollection;
import com.kingdee.eas.basedata.person.PersonFactory;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.individualback.*;
import com.kingdee.eas.custom.shuiyou.interfacelog.LogInfoFactory;
import com.kingdee.eas.custom.shuiyou.interfacelog.LogInfoInfo;
import com.kingdee.eas.custom.shuiyou.task.MessageResult;
import com.kingdee.eas.custom.shuiyou.utils.ClientProxyFactoryUtils;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.shr.compensation.CalSchemeFactory;
import com.kingdee.util.StringUtils;
import org.apache.log4j.Logger;

import java.io.IOException;
import java.math.BigDecimal;
import java.sql.SQLException;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author qingwu
 * @date 2024/9/9
 * @apiNote
 */
public class SynIndividualIncomeTaxService implements IHRMsfService {
    Logger logger = Logger.getLogger("com.kingdee.eas.custom.compensation.service.SynIndividualIncomeTaxService");

    @Override
    public Object process(Context context, Map map) throws EASBizException, BOSException {
        //ӿ־ʵ
        LogInfoInfo logInfo = new LogInfoInfo();
        //
        logInfo.setEntrance(this.getClass().getName());
        logInfo.setBizDate(new Date());
        Map resMap = new HashMap();
        logger.error("SynIndividualIncomeTaxService----------OSF----Start");
        JSONObject paramData = JSONObject.parseObject((String) map.get("paramData"));
        logger.error("paramData--------" + paramData);
        String requestId = paramData.getString("requestId");
        JSONObject param = paramData.getJSONObject("param");
        logger.error("requestId--------" + requestId);
        logger.error("param--------" + param);
        try {
            ObjectMapper mapper = new ObjectMapper();
            //ͻ˴
            ClientProxyFactory clientProxyFactory = ClientProxyFactoryUtils.getClientProxyFactory();
            //˰ӿ
            TaxRequest taxRequest = clientProxyFactory.getTaxRequest();
            ApiResponse<CalculateTaxResultRequest> aSynIndividualIncomeTaxFeedback = taxRequest.getReverseASynIndividualIncomeTaxFeedback(requestId);
            logger.error("aSynIndividualIncomeTaxFeedback--------" + mapper.writeValueAsString(aSynIndividualIncomeTaxFeedback));
            String status = aSynIndividualIncomeTaxFeedback.getHead().getStatus();
            logInfo.setInterfaceAddress("/gateway/iit/reverseCalculateTax/getASynIndividualIncomeTaxFeedback");//ӿڵַ
            logInfo.setInterfaceName("getASynIndividualIncomeTaxFeedback");//ӿ
            logInfo.setInParameter(mapper.writeValueAsString(aSynIndividualIncomeTaxFeedback));//
            CalculateTaxResultRequest body = null;
            if ("N".equals(status)) {
                //ʧӦ
                String msg = aSynIndividualIncomeTaxFeedback.getHead().getMsg();
                logInfo.setStatus("");
                //throw new BOSException(msg);
                return MessageResult.FAILED(msg);
            } else {
                //óɹ
                //id
                body = aSynIndividualIncomeTaxFeedback.getBody();
                logger.error("SynIndividualIncomeTaxService----------body---" + mapper.writeValueAsString(body));
                logInfo.setOutParameter(mapper.writeValueAsString(body));//ز
                //if (body.getEmployeeDeclareFeedbackList() != null) {
                logInfo.setStatus("ɹ");
                disposeTaxPaymentBackCalculate(context, body, param);
                //} else {
                //    logInfo.setStatus("Ա");
                //}
            }
            LogInfoFactory.getLocalInstance(context).addnew(logInfo);
            return MessageResult.SUCCESS(mapper.writeValueAsString(body));
        } catch (IOException e) {
            e.printStackTrace();
            logInfo.setErrorInfo(e.getMessage());//Ϣ
            logInfo.setStatus("ʧ");
            LogInfoFactory.getLocalInstance(context).save(logInfo);
            logger.error("SynIndividualIncomeTaxService----------error---" + e.getMessage());

            //throw new BOSException(e);
            return MessageResult.ERROR(e.getMessage());
        }
    }

    /**
     * ˰
     *
     * @param resBody ѯ㷴ӿڷؽ
     * @param param   ԱID
     * @return
     */
    public void disposeTaxPaymentBackCalculate(Context ctx, CalculateTaxResultRequest
            resBody, com.alibaba.fastjson.JSONObject param) throws BOSException, EASBizException, JsonProcessingException {
        logger.error("addTaxPaymentBackCalculate============Start===============");
        ObjectMapper mapper = new ObjectMapper();

        ITaxPaymentBackCalculate iTaxPaymentBackCalculate = TaxPaymentBackCalculateFactory.getLocalInstance(ctx);

        String taxItemPlanNumber = param.getString("taxItemPlanNumber");//˰Ŀ
        logger.error("taxItemPlanNumber============" + taxItemPlanNumber);

        ComplexTaxCalculateResult complexTaxCalculateResult = null;
        //zhsd   ۺ
        ComplexIncomeResultRequest complexIncomeResultRequest = resBody.getComplexIncomeResultRequest();
        logger.error("complexIncomeResultRequest============" + mapper.writeValueAsString(complexIncomeResultRequest));
        //ȫһԽ
        //if ("2024083001".equals(taxItemPlanNumber)) {
        if ("GS003".equals(taxItemPlanNumber)) {
            //qnycxjjsslb  ȫһԽ
            complexTaxCalculateResult = complexIncomeResultRequest.getAnnualOneTimeBonusIncome();
        }
        //һ񱨳б
        if ("GS002".equals(taxItemPlanNumber)) {
            //lwbclb  һ񱨳б
            complexTaxCalculateResult = complexIncomeResultRequest.getLaborRemunerationIncome();
        }
        //н
        if ("GS001".equals(taxItemPlanNumber)) {
            //zcgzxj  н
            complexTaxCalculateResult = complexIncomeResultRequest.getNormalSalarySpecIncome();
        }

        IPerson iPerson = PersonFactory.getLocalInstance(ctx);
        List<ComplexIncome> successComplexIncomes = complexTaxCalculateResult.getSuccessComplexIncomes();
        for (ComplexIncome complexIncome : successComplexIncomes) {
            //֤
            String licenseType = complexIncome.getLicenseType();
            PersonInfo personInfo = null;
            if ("֤".equals(licenseType)) {
                //֤
                String licenseNumber = complexIncome.getLicenseNumber();
                PersonCollection personCollection = iPerson.getPersonCollection("where idCardNO = '" + licenseNumber + "'");
                if (personCollection.size() > 0) {
                    personInfo = personCollection.get(0);

                }
            }
            if ("й".equals(licenseType)) {
                //֤
                String licenseNumber = complexIncome.getLicenseNumber();
                PersonCollection personCollection = iPerson.getPersonCollection("where passportNO = '" + licenseNumber + "'");
                if (personCollection.size() > 0) {
                    personInfo = personCollection.get(0);
                }
            }
            param.put("personId", personInfo.getId());
            saveTaxPaymentBackCalculateCollection(ctx, param, complexIncome);
        }
        logger.error("addTaxPaymentBackCalculate============end===============");
    }

    public String getParamContent(String requestId) {
        return "select CFParamContent as paramContent  from CT_TK_TaskRequestParam where CFTaskID in (select FID from CT_TK_Task where CFRequestId = '" + requestId + "')";
    }

    public TaxPaymentBackCalculateCollection saveTaxPaymentBackCalculateCollection(Context ctx, JSONObject
            param, ComplexIncome complexIncome) throws BOSException, EASBizException {
        TaxPaymentBackCalculateInfo taxPaymentBackCalculateInfo = new TaxPaymentBackCalculateInfo();
        String personId = param.getString("personId");//ԱID
        String periodYear = param.getString("periodYear");//ͳ
        String periodMonth = param.getString("periodMonth");//ͳ
        String cmpschemeid = param.getString("cmpschemeid");//ID
        String taxItemPlanName = param.getString("taxItemPlanName");//˰Ŀ
        String taxItemPlanNumber = param.getString("taxItemPlanNumber");//˰Ŀ

        FilterInfo filterInfo = new FilterInfo();
        filterInfo.getFilterItems().add(new FilterItemInfo("person", personId, CompareType.EQUALS));
        filterInfo.getFilterItems().add(new FilterItemInfo("periodMonth", periodMonth, CompareType.EQUALS));
        filterInfo.getFilterItems().add(new FilterItemInfo("periodYear", periodYear, CompareType.EQUALS));
        filterInfo.getFilterItems().add(new FilterItemInfo("cmpscheme", cmpschemeid, CompareType.EQUALS));
        EntityViewInfo entityViewInfo = EntityViewInfo.getInstance(filterInfo, null, null);
        ////ѯ˰Ƿڸ
        ITaxPaymentBackCalculate iTaxPaymentBackCalculate = TaxPaymentBackCalculateFactory.getLocalInstance(ctx);
        TaxPaymentBackCalculateCollection taxPaymentBackCalculateCollection = iTaxPaymentBackCalculate.getTaxPaymentBackCalculateCollection(entityViewInfo);
        if (taxPaymentBackCalculateCollection.size() > 0) {
            taxPaymentBackCalculateInfo = taxPaymentBackCalculateCollection.get(0);
            taxPaymentBackCalculateInfo.setId(taxPaymentBackCalculateCollection.get(0).getId());
        }
        //Ա
        taxPaymentBackCalculateInfo.setPerson(PersonFactory.getLocalInstance(ctx).getPersonInfo(new ObjectUuidPK(personId)));
        //ͳ
        taxPaymentBackCalculateInfo.setPeriodYear(periodYear);
        //ͳ
        taxPaymentBackCalculateInfo.setPeriodMonth(periodMonth);
        //
        taxPaymentBackCalculateInfo.setCmpscheme(CalSchemeFactory.getLocalInstance(ctx).getCalSchemeInfo(new ObjectUuidPK(cmpschemeid)));
        //˰Ŀ
        taxPaymentBackCalculateInfo.setTaxItemPlan(taxItemPlanName);
        //sre  
        BigDecimal income = complexIncome.getIncome();
        taxPaymentBackCalculateInfo.setSalarySum(income);
        //ybtse refundTax  Ӧ˰
        BigDecimal refundTax = complexIncome.getRefundTax();
        taxPaymentBackCalculateInfo.setIndividual(refundTax);
        IObjectPK save = iTaxPaymentBackCalculate.save(taxPaymentBackCalculateInfo);
        logger.error("saveTaxPaymentBackCalculateCollection----------save---" + save);
        return taxPaymentBackCalculateCollection;
    }
}
