package com.kingdee.eas.custom.individualback;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.ctrl.swing.StringUtils;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.metadata.entity.EntityViewInfo;
import com.kingdee.bos.metadata.entity.FilterInfo;
import com.kingdee.bos.metadata.entity.FilterItemInfo;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.eas.basedata.person.IPerson;
import com.kingdee.eas.basedata.person.PersonCollection;
import com.kingdee.eas.basedata.person.PersonFactory;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.shuiyou.six.handler.TaxPersonRecordListHandlerEx;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.ShrWebBizException;
import com.kingdee.shr.compensation.*;
import com.kingdee.shr.compensation.app.incomeTax.*;
import com.kingdee.shr.compensation.app.tax.ITaxUnit;
import com.kingdee.shr.compensation.app.tax.TaxUnitFactory;
import com.kingdee.shr.compensation.app.tax.TaxUnitInfo;
import com.kingdee.shr.compensation.web.handler.incometax.TaxPersonRecordListHandler;
import org.apache.log4j.Logger;
import org.springframework.ui.ModelMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.sql.SQLException;
import java.time.LocalDate;
import java.time.YearMonth;
import java.time.ZoneId;
import java.time.format.DateTimeFormatter;
import java.util.*;

import static org.hsqldb.types.IntervalSecondData.oneDay;

/**
 * @author qingwu
 * @date 2024/9/4
 * @apiNote
 */
public class TaxPersonRecordListHandlerExEx extends TaxPersonRecordListHandlerEx {
    private Context ctx = SHRContext.getInstance().getContext();
    Logger logger = Logger.getLogger("com.kingdee.eas.custom.individualback.TaxPersonRecordListHandlerExEx");

    /**
     * ͬԱ˰Ϣ
     *
     * @param request
     * @param response
     * @param modelMap
     * @throws ShrWebBizException
     * @throws BOSException
     */
    public void synTaxPersonRecordAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws ShrWebBizException, BOSException {
        String taxUnitIds = (String) request.getParameter("taxUnitIds");
        String yearMonth = (String) request.getParameter("yearMonth");
        if (StringUtils.isEmpty(taxUnitIds)) {
            throw new ShrWebBizException("˰λΪ!!");
        }
        if (StringUtils.isEmpty(yearMonth)) {
            throw new ShrWebBizException("²Ϊ!!");
        }
        try {
            //ȡ
            String[] parts = yearMonth.split("-");
            int year = Integer.parseInt(parts[0]);
            int month = Integer.parseInt(parts[1]);
            String[] taxUnitIdArray = taxUnitIds.split(",");
            for (int i = 0; i < taxUnitIdArray.length; i++) {
                String taxUnitId = taxUnitIdArray[i];
                //getSCmpCalTablePersonsSql ȡнԱsqlhjkl;
                String sCmpCalTablePersonsSql = getSCmpCalTablePersonsSql(year, month, taxUnitId);
                logger.error("sCmpCalTablePersonsSql--" + sCmpCalTablePersonsSql);
                IRowSet iRowSet = DbUtil.executeQuery(ctx, sCmpCalTablePersonsSql);
                //洢ԱID
                List personIds = new ArrayList();
                while (iRowSet.next()) {
                    personIds.add(iRowSet.getString("personId"));
                }
                logger.error("personIds--" + personIds);
                //
                ////ȡµһ
                //LocalDate currentDate = LocalDate.of(year, month, 1);
                //Date oneDay = Date.from(currentDate.atStartOfDay(ZoneId.systemDefault()).toInstant());
                //
                ////ȡyearMonthµһ
                //YearMonth yearAndMonth = YearMonth.parse(yearMonth);
                //LocalDate lastDayOfMonth = yearAndMonth.atEndOfMonth();
                //
                //Date date = Date.from(lastDayOfMonth.withDayOfMonth(lastDayOfMonth.lengthOfMonth()).atStartOfDay(ZoneId.systemDefault()).toInstant());
                //////Ա˰Ϣ
                ////addTaxPersonRecord(personIds, oneDay, taxUnitIds, yearMonth);
                //ȡݽжԱ
                comparison(personIds, taxUnitId, year, month, yearMonth);
            }

        } catch (SQLException | EASBizException e) {
            e.printStackTrace();
            throw new ShrWebBizException(e);
        }

    }

    /**
     * Ա ޸ְܹʹҵϢ
     *
     * @param personIdSet нԱ
     * @param taxUnitId   ˰λ
     * @param periodYear  
     * @param periodMonth 
     * @param yearMonth   
     */
    public void comparison(List personIdSet, String taxUnitId, int periodYear, int periodMonth, String yearMonth) throws BOSException, EASBizException, SQLException {
        ITaxPersonRecordEntry iTaxPersonRecordEntry = TaxPersonRecordEntryFactory.getLocalInstance(ctx);
        ITaxPersonRecord iTaxPersonRecord = TaxPersonRecordFactory.getLocalInstance(ctx);
        //ȡһµļ  ͳ꣺periodYear   ͳ£periodMonth
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM");
        LocalDate date = LocalDate.of(periodYear, periodMonth, 1);
        LocalDate previousMonthDate = date.minusMonths(1);
        String previousMonth = previousMonthDate.format(formatter);
        //ϸ
        //TaxPersonRecordEntryCollection taxPersonRecordEntryCollUp = iTaxPersonRecordEntry.getTaxPersonRecordEntryCollection("select * ,person.* where  taxUnit = '" + taxUnitId + "' and lastReportMonth = '" + previousMonth + "' ");
        //Ա˰Ϣ
        TaxPersonRecordEntryCollection taxPersonRecordEntryCollDn = iTaxPersonRecordEntry.getTaxPersonRecordEntryCollection("select * ,person.*  where  taxUnit = '" + taxUnitId + "' and  personStatus = '1' ");
        TaxPersonRecordEntryCollection taxPersonRecordEntryCollAll = iTaxPersonRecordEntry.getTaxPersonRecordEntryCollection("select * ,person.*  where personStatus = '1' ");
        //ϸµĺԱ
        //List<String> listUp = new ArrayList<>();
        //for (int i = 0; i < personIds.size(); i++) {
        //    listUp.add(personIds.get(i));
        //}
        //Ա˰Ϣ˰λ
        Map<String, String> taxUnitMap = new HashMap();
        //浱ǰµĺԱ
        List<String> list = new ArrayList<>();
        for (int i = 0; i < taxPersonRecordEntryCollDn.size(); i++) {
            String personId = taxPersonRecordEntryCollDn.get(i).getPerson().getId().toString();
            String taxPersonTaxUnitId = taxPersonRecordEntryCollDn.get(i).getTaxUnit().getId().toString();
            TaxPersonRecordCollection taxPersonRecordCollection = iTaxPersonRecord.getTaxPersonRecordCollection("where person = '" + personId + "'");
            if (taxPersonRecordCollection.size() > 0) {
                logger.error("comparison--personId--------------" + personId);
                list.add(personId);
            }
        }
        //ȡԱ˰ϢԱ˰λ
        for (int i = 0; i < taxPersonRecordEntryCollAll.size(); i++) {
            String personId = taxPersonRecordEntryCollAll.get(i).getPerson().getId().toString();
            String taxPersonTaxUnitId = taxPersonRecordEntryCollAll.get(i).getTaxUnit().getId().toString();
            TaxPersonRecordCollection taxPersonRecordCollection = iTaxPersonRecord.getTaxPersonRecordCollection("where person = '" + personId + "'");
            if (taxPersonRecordCollection.size() > 0) {
                logger.error("comparisonAll--personId--------------" + personId);
                taxUnitMap.put(personId, taxPersonTaxUnitId);
            }
        }
        //Ա˰
        Set<String> setUp = new HashSet<>(list);
        logger.error("comparison--setUp--------------" + setUp);

        //н
        Set<String> set = new HashSet<>(personIdSet);
        logger.error("comparison--set--------------" + set);


        // ҳ ϸºԱ б ǰºԱ  ΪְԱ ޸Ա˰Ϣ Ա״̬Ϊ  ְΪǰһ
        Set<String> pseronIdsUp = new HashSet<>(setUp);
        pseronIdsUp.removeAll(set);
        logger.error("comparison--pseronIdsUp--------------" + pseronIdsUp);

        // ҳ ǰºԱ б ϸºԱ  ΪԱ Ա˰ϢְܹʹҵϢ Ա״̬Ϊ ְܹʹҵΪǰ1
        Set<String> pseronIds = new HashSet<>(set);
        pseronIds.removeAll(setUp);
        logger.error("comparison--pseronIds--------------" + pseronIds);

        SelectorItemCollection updateSic = new SelectorItemCollection();
        updateSic.add("personStatus");
        updateSic.add("departureDate");

        //ȡǰµһתDate
        Date departureDate = Date.from(date.withDayOfMonth(date.lengthOfMonth()).atStartOfDay(ZoneId.systemDefault()).toInstant());
        //ȡµһ
        LocalDate currentDate = LocalDate.of(periodYear, periodMonth, 1);
        Date oneDay = Date.from(currentDate.atStartOfDay(ZoneId.systemDefault()).toInstant());
        logger.error("comparison--currentDate--------------" + currentDate);
        logger.error("comparison--oneDay--------------" + oneDay);
        if (pseronIdsUp.size() > 0) {
            //ȡְܹʹҵϢ   ޸Ա˰Ϣ Ա״̬Ϊ  ְΪǰһ
            TaxPersonRecordEntryCollection taxPersonRecordEntryCollUp2 = getTaxPersonRecordEntryColl(pseronIdsUp, iTaxPersonRecordEntry);
            if (taxPersonRecordEntryCollUp2.size() > 0) {
                for (int i = 0; i < taxPersonRecordEntryCollUp2.size(); i++) {
                    TaxPersonRecordEntryInfo taxPersonRecordEntryInfo = taxPersonRecordEntryCollUp2.get(i);
                    //Ա״̬
                    taxPersonRecordEntryInfo.setPersonStatus(PersonStatusEnum.NotNormal);
                    //ְΪǰһ
                    taxPersonRecordEntryInfo.setDepartureDate(departureDate);
                    iTaxPersonRecordEntry.updatePartial(taxPersonRecordEntryInfo, updateSic);
                }
            }
        }
        if (pseronIds.size() > 0) {
            //Ա˰Ϣ
            addTaxPersonRecord(pseronIds, oneDay, taxUnitId, yearMonth);
        }

        //ԱԱ˰λǷһ ȡнԱ˰ϢͬԱ
        Set<String> sameData = new HashSet<>();
        TaxPersonRecordEntryCollection taxPersonRecordEntryColl = iTaxPersonRecordEntry.getTaxPersonRecordEntryCollection("select * ,person.* ");
        for (int i = 0; i < taxPersonRecordEntryColl.size(); i++) {
            TaxPersonRecordEntryInfo taxPersonRecordEntryInfo = taxPersonRecordEntryColl.get(i);
            PersonInfo person = taxPersonRecordEntryInfo.getPerson();
            logger.error("person------" + person.getId().toString());
            if (set.contains(person.getId().toString())) {
                sameData.add(person.getId().toString());
            }
        }
        //Set<String> sameData = new HashSet<>();
        //for (String item : setUp) {
        //    if (set.contains(item)) {
        //        sameData.add(item);
        //    }
        //}
        logger.error("sameData------" + sameData);
        //жͬ˰λǷԱ˰Ϣ˰λһ
        for (String personId : sameData) {
            logger.error("sameData---personId------" + personId);
            String taxPersonTaxUnitId = taxUnitMap.get(personId);
            logger.error("taxPersonTaxUnitId------" + taxPersonTaxUnitId);
            logger.error("taxUnitId------" + taxUnitId);
            logger.error("taxUnitMap-------" + taxUnitMap);
            //һ ҪְܹʹҵϢ ֮ǰĸΪ
            if (!taxUnitId.equals(taxPersonTaxUnitId) && taxPersonTaxUnitId != null) {
                //departureDate ְ ȡְΪյǸ
                //TaxPersonRecordEntryInfo taxPersonRecordEntryInfo = iTaxPersonRecordEntry.getTaxPersonRecordEntryCollection("select * ,person.*  where departureDate is null ").get(0);
                TaxPersonRecordEntryCollection taxPersonRecordEntryCollection = iTaxPersonRecordEntry.getTaxPersonRecordEntryCollection("select * ,person.*  where personStatus = '1' and  taxUnit = '" + taxPersonTaxUnitId + "'");
                if (taxPersonRecordEntryCollection.size() > 0) {
                    TaxPersonRecordEntryInfo taxPersonRecordEntryInfo = taxPersonRecordEntryCollection.get(0);
                    logger.error("taxPersonRecordEntryInfo------" + taxPersonRecordEntryInfo);
                    //Ա״̬
                    taxPersonRecordEntryInfo.setPersonStatus(PersonStatusEnum.NotNormal);
                    //ְΪǰһ   LocalDate.of(periodYear, periodMonth, 1)
                    LocalDate dateTime = LocalDate.of(periodYear, periodMonth - 1, 1);
                    Date lengthOfMonthDate = Date.from(dateTime.withDayOfMonth(dateTime.lengthOfMonth()).atStartOfDay(ZoneId.systemDefault()).toInstant());
                    if (taxPersonRecordEntryInfo.getEmployedDate().compareTo(lengthOfMonthDate) >= 0) {
                        taxPersonRecordEntryInfo.setDepartureDate(taxPersonRecordEntryInfo.getEmployedDate());
                    } else {
                        taxPersonRecordEntryInfo.setDepartureDate(lengthOfMonthDate);
                    }
                    iTaxPersonRecordEntry.updatePartial(taxPersonRecordEntryInfo, updateSic);


                    //һµ
                    TaxPersonRecordEntryInfo taxPersonRecordEntryInfoNew = new TaxPersonRecordEntryInfo();
                    taxPersonRecordEntryInfoNew.setPerson(taxPersonRecordEntryInfo.getPerson());
                    TaxPersonRecordInfo taxPersonRecordInfo = iTaxPersonRecord.getTaxPersonRecordCollection("where person = '" + personId + "'").get(0);
                    logger.error("taxPersonRecordInfo--------" + taxPersonRecordInfo);

                    taxPersonRecordEntryInfoNew.setBill(taxPersonRecordInfo);
                    //ȡ˰λ
                    ITaxUnit iTaxUnit = TaxUnitFactory.getLocalInstance(ctx);
                    TaxUnitInfo taxUnitInfo = iTaxUnit.getTaxUnitInfo("where id = '" + taxUnitId + "'");
                    logger.error("taxUnitInfo--------" + taxUnitInfo);
                    taxPersonRecordEntryInfoNew.setTaxUnit(taxUnitInfo);
                    //Ա״̬
                    taxPersonRecordEntryInfoNew.setPersonStatus(PersonStatusEnum.Normal);
                    //ȡǰµһתDate //ְܹʹҵΪǰµһ
                    taxPersonRecordEntryInfoNew.setEmployedDate(oneDay);
                    taxPersonRecordEntryInfoNew.setPayerType(taxPersonRecordEntryInfo.getPayerType());
                    //״̬
                    taxPersonRecordEntryInfoNew.setSubmitStatus(SubmitStatusEnum.NotSubmit);
                    taxPersonRecordEntryInfoNew.setLastReportMonth(yearMonth);
                    //ְܹʹҵ  ĬϹԱ
                    taxPersonRecordEntryInfoNew.setEmployedType(EmployedTypeEnum.Employee);
                    //Ƿ۳ Ĭ
                    taxPersonRecordEntryInfoNew.setDeductFees(DeductFeesEnum.Deduct);
                    IObjectPK saveEntry = iTaxPersonRecordEntry.save(taxPersonRecordEntryInfoNew);
                    logger.error("saveEntry--------¼ID" + saveEntry);
                }
            }
        }
    }

    /**
     * ȡְܹʹҵϢ
     *
     * @param pseronIds ԱID
     * @return
     * @throws BOSException
     */
    public TaxPersonRecordEntryCollection getTaxPersonRecordEntryColl(Set<String> pseronIds, ITaxPersonRecordEntry iTaxPersonRecordEntry) throws BOSException {
        //ȡǰµн
        FilterInfo filterInfo = new FilterInfo();
        filterInfo.getFilterItems().add(new FilterItemInfo("bill.person", pseronIds, CompareType.INCLUDE));
        EntityViewInfo entityViewInfo = EntityViewInfo.getInstance(filterInfo, null, null);
        return iTaxPersonRecordEntry.getTaxPersonRecordEntryCollection(entityViewInfo);
    }

    /**
     * Ա˰Ϣ
     *
     * @param pseronIds Ա
     * @param oneDay    һ
     * @param taxUnitId ˰λID
     * @throws BOSException
     * @throws EASBizException
     * @throws SQLException
     */
    public void addTaxPersonRecord(Set<String> pseronIds, Date oneDay, String taxUnitId, String yearMonth) throws BOSException, EASBizException, SQLException {
        logger.error("addTaxPersonRecord--------ʼ");
        //pseronIds.forEach(id -> {});
        ITaxPersonRecord iTaxPersonRecord = TaxPersonRecordFactory.getLocalInstance(ctx);
        IPerson iPerson = PersonFactory.getLocalInstance(ctx);
        ITaxPersonRecordEntry iTaxPersonRecordEntry = TaxPersonRecordEntryFactory.getLocalInstance(ctx);

        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("*");
        sic.add("person.*");
        FilterInfo filterInfo = new FilterInfo();
        filterInfo.getFilterItems().add(new FilterItemInfo("id", pseronIds, CompareType.INCLUDE));
        EntityViewInfo entityViewInfo = EntityViewInfo.getInstance(filterInfo, sic, null);
        PersonCollection personCollection = iPerson.getPersonCollection(entityViewInfo);
        if (personCollection.size() > 0) {
            for (int i = 0; i < personCollection.size(); i++) {
                PersonInfo personInfo = personCollection.get(i);
                boolean exists = iTaxPersonRecordEntry.exists("where person = '" + personInfo.getId().toString() + "' and taxUnit = '" + taxUnitId + "' and lastReportMonth = '" + yearMonth + "' ");
                boolean exists2 = iTaxPersonRecord.exists("where person = '" + personInfo.getId().toString() + "'");
                logger.error("exists--------" + exists2);
                logger.error("exists2--------" + exists2);
                if (!exists && !exists2) {
                    TaxPersonRecordInfo taxPersonRecordInfo = new TaxPersonRecordInfo();
                    //Ա˰¼
                    TaxPersonRecordEntryInfo taxPersonRecordEntryInfo = new TaxPersonRecordEntryInfo();
                    //Ա
                    taxPersonRecordInfo.setPerson(personInfo);
                    //˰
                    taxPersonRecordInfo.setReportName(personInfo.getName());
                    //֤
                    if (personInfo.getIdCardNO() != null || personInfo.getPassportNO() != null) {
                        if (null == personInfo.getIdCardNO()) {
                            //
                            taxPersonRecordInfo.setCardType(CardTypeEnum.Passport);
                            taxPersonRecordInfo.setCardNumber(personInfo.getPassportNO());
                            //˰
                            taxPersonRecordEntryInfo.setPayerType(PayerTypeEnum.NotResident);
                        }
                        if (null == personInfo.getPassportNO()) {
                            //֤
                            taxPersonRecordInfo.setCardType(CardTypeEnum.IdCard);
                            taxPersonRecordInfo.setCardNumber(personInfo.getIdCardNO());
                            //˰
                            taxPersonRecordEntryInfo.setPayerType(PayerTypeEnum.Resident);

                        }
                    } else {
                        logger.error(personInfo.getName() + "պ֤Ϊգ֤ͱʧܣ");
                    }
                    //Ա
                    taxPersonRecordInfo.setGender(personInfo.getGender());
                    //
                    taxPersonRecordInfo.setBirthday(personInfo.getBirthday());
                    //
                    taxPersonRecordInfo.setNationality(personInfo.getNationality());
                    //ǷԱ
                    taxPersonRecordInfo.setIsOversea(IsOverseaEnum.NotOversea);
                    //ֻ
                    taxPersonRecordInfo.setPhoneNumber(personInfo.getCell());
                    IObjectPK save = iTaxPersonRecord.save(taxPersonRecordInfo);
                    if (save != null) {
                        //¼
                        taxPersonRecordEntryInfo.setPerson(personInfo);
                        taxPersonRecordEntryInfo.setBill(taxPersonRecordInfo);
                        //ȡ˰λ
                        ITaxUnit iTaxUnit = TaxUnitFactory.getLocalInstance(ctx);
                        TaxUnitInfo taxUnitInfo = iTaxUnit.getTaxUnitInfo("where id = '" + taxUnitId + "'");
                        taxPersonRecordEntryInfo.setTaxUnit(taxUnitInfo);
                        //Ա״̬
                        taxPersonRecordEntryInfo.setPersonStatus(PersonStatusEnum.Normal);
                        //ȡǰµһתDate //ְܹʹҵΪǰµһ
                        taxPersonRecordEntryInfo.setEmployedDate(oneDay);
                        //״̬
                        taxPersonRecordEntryInfo.setSubmitStatus(SubmitStatusEnum.NotSubmit);
                        taxPersonRecordEntryInfo.setLastReportMonth(yearMonth);
                        //ְܹʹҵ  ĬϹԱ
                        taxPersonRecordEntryInfo.setEmployedType(EmployedTypeEnum.Employee);
                        //Ƿ۳ Ĭ
                        taxPersonRecordEntryInfo.setDeductFees(DeductFeesEnum.Deduct);
                        IObjectPK saveEntry = iTaxPersonRecordEntry.save(taxPersonRecordEntryInfo);
                        logger.error("saveEntry--------¼ID" + saveEntry);
                    }
                }
            }
        }
        logger.error("addTaxPersonRecord--------");
    }

    /**
     * ȡнԱ
     *
     * @param year      ͳ
     * @param month     ͳ
     * @param taxUnitId ˰λ
     */
    public String getSCmpCalTablePersonsSql(Integer year, Integer month, String taxUnitId) {
        StringBuilder sb = new StringBuilder();
        sb.append("SELECT").append("\n");
        sb.append("FPersonID as personId").append("\n");
        sb.append("FROM T_HR_SCmpCalTable").append("\n");
        sb.append("WHERE").append("\n");
        sb.append("FPeriodYear = '").append(year).append("'").append("\n");
        sb.append(" and ").append("\n");
        sb.append("FPeriodMonth = '").append(month).append("'").append("\n");
        sb.append(" and ").append("\n");
        sb.append("FTaxUnitID = '").append(taxUnitId).append("'").append("\n");
        return sb.toString();
    }
}
