package com.kingdee.eas.custom.shuiyou.inter.handler;

import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import com.kingdee.bos.Context;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.metadata.entity.FilterInfo;
import com.kingdee.bos.metadata.entity.FilterItemCollection;
import com.kingdee.bos.metadata.entity.FilterItemInfo;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.bos.metadata.entity.SelectorItemInfo;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.bos.sql.util.StringUtil;
import com.kingdee.eas.custom.shuiyou.task.ITask;
import com.kingdee.eas.custom.shuiyou.task.TaskCatalogEnum;
import com.kingdee.eas.custom.shuiyou.task.TaskFactory;
import com.kingdee.eas.custom.shuiyou.task.TaskInfo;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.web.handler.ListHandler;
import com.kingdee.shr.base.syssetting.web.json.JSONUtils;
import com.kingdee.shr.compensation.app.taxCal.TaxCalTaskCatalogEnum;
import com.kingdee.shr.compensation.request.ParseRequestHelper;
import com.kingdee.shr.compensation.util.filter.CmpTaxUnitPermFilter;

import org.apache.commons.lang3.StringUtils;
import org.apache.log4j.Logger;
import org.springframework.ui.ModelMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * description: TaskListHandler <br>
 * date: 2024/9/12 10:56 <br>
 * author: lhbj <br>
 * version: 1.0 <br>
 */
public class TaskListHandler extends ListHandler {
    private static Logger logger = Logger
	.getLogger("com.kingdee.eas.custom.shuiyou.inter.handler.TaskListHandler");

    public String enableAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws SHRWebException {
        String billId = this.getBillId(request);
        Context ctx = SHRContext.getInstance().getContext();
        try {
            ITask iTask = TaskFactory.getLocalInstance(ctx);
            SelectorItemCollection sc = new SelectorItemCollection();
            sc.add(new SelectorItemInfo("id"));
            sc.add(new SelectorItemInfo("url"));
            sc.add(new SelectorItemInfo("requestId"));
            sc.add(new SelectorItemInfo("requestType"));
            sc.add(new SelectorItemInfo("requestParam.id"));
            sc.add(new SelectorItemInfo("requestParam.paramContent"));
            sc.add(new SelectorItemInfo("requestResult.id"));
            sc.add(new SelectorItemInfo("requestResult.resultContent"));
            sc.add(new SelectorItemInfo("requestState"));
            sc.add(new SelectorItemInfo("state"));
            sc.add(new SelectorItemInfo("name"));
            sc.add(new SelectorItemInfo("osfServiceName"));
            sc.add(new SelectorItemInfo("number"));
            sc.add(new SelectorItemInfo("taskPre.id"));
            sc.add(new SelectorItemInfo("taskPre.state"));
            sc.add(new SelectorItemInfo("taskPre.requestState"));
            String[] ids = billId.split(",");
            for(String id : ids) {
                //ָidִ
                TaskInfo taskInfo = iTask.getTaskInfo(new ObjectUuidPK(id), sc);
                taskInfo.setContext(ctx).execute();
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        this.writeSuccessData(billId);
        return null;
    }
    
    
    


    protected FilterInfo getDefaultFilter(HttpServletRequest request,
    		HttpServletResponse response) throws SHRWebException {
    	FilterInfo filterInfo = super.getDefaultFilter(request, response);
    	if (null == filterInfo) {
    		filterInfo = new FilterInfo();
    	}
    	Context ctx = SHRContext.getInstance().getContext();
    	FilterItemCollection filterItems = filterInfo.getFilterItems();
    	String catalog = StringUtil.cnulls(ParseRequestHelper.getParameterByRequest(request, "catalog"));
   
    	TaskCatalogEnum catalogEnum = null;
    	if (!(StringUtils.isEmpty(catalog))) {
    		catalogEnum = TaskCatalogEnum.getEnum(catalog);
    	}
    	String fastFilterItems = request.getParameter("fastFilterItems");
    	Map fastFilterMap = null;
    	if (fastFilterItems != null) {
    		fastFilterMap = JSONUtils.convertJsonToObject(ctx, fastFilterItems);
    	}
    	boolean isUseURLCatalog = true;
    	if ((null != fastFilterMap) && (fastFilterMap.containsKey("catalog"))) {
    		Map catalogMap = (Map) fastFilterMap.get("catalog");
    		String values = (String) catalogMap.get("values");
    		if (!(StringUtils.isEmpty(values))) {
    			isUseURLCatalog = false;
    		}
    		
    	}
    	
    	if ((null != catalogEnum) && (isUseURLCatalog)) {
    		if (TaskCatalogEnum.CAL == catalogEnum) {
    			Set set = new HashSet();
    			set.add(Integer.valueOf(30));//˰
    			set.add(Integer.valueOf(32));//˰ɾԱ
    			set.add(Integer.valueOf(50));//רӿ۳걨
//    			set.add(Integer.valueOf(90));//6Աȡ
    			set.add(Integer.valueOf(35));//˰ȡ
    			FilterItemInfo catalogFilterItem = new FilterItemInfo(
    					"catalog", set, CompareType.INCLUDE);
    			filterItems.add(catalogFilterItem);
    		} else if (TaskCatalogEnum.TAX == catalogEnum) {
    			Set set = new HashSet();
    			set.add(Integer.valueOf(20));//˰걨
    			set.add(Integer.valueOf(40));//˰걨
    			set.add(Integer.valueOf(131));//걨
    			set.add(Integer.valueOf(130));//
    			set.add(Integer.valueOf(132));//걨
    			FilterItemInfo catalogFilterItem = new FilterItemInfo(
    					"catalog", set, CompareType.INCLUDE);
    			filterItems.add(catalogFilterItem);
    		} else if (TaskCatalogEnum.TAXPAYMENT == catalogEnum) {
    			Set set = new HashSet();
    			set.add(Integer.valueOf(60));//Эȡ
    			set.add(Integer.valueOf(70));//˰
    			set.add(Integer.valueOf(110));//
    			set.add(Integer.valueOf(75));//˰ɲѯ
    		 
    			FilterItemInfo catalogFilterItem = new FilterItemInfo(
    					"catalog", set, CompareType.INCLUDE);
    			filterItems.add(catalogFilterItem);
    		} else if (TaskCatalogEnum.COLLECTION == catalogEnum) {
    			Set set = new HashSet();
//    			set.add(Integer.valueOf(90));//6Աȡ
//    			set.add(Integer.valueOf(100));//6ֱӿ۳Աȷ
    			set.add(Integer.valueOf(90));//Ա鼯
    			set.add(Integer.valueOf(95));// 
    			set.add(Integer.valueOf(100));// 
    			set.add(Integer.valueOf(105));
    			FilterItemInfo catalogFilterItem = new FilterItemInfo(
    					"catalog", set, CompareType.INCLUDE);
    			filterItems.add(catalogFilterItem);
    		} else {
    			FilterItemInfo catalogFilterItem = new FilterItemInfo(
    					"catalog", catalogEnum, CompareType.EQUALS);
    			filterItems.add(catalogFilterItem);
    		}
    	}
    	
//    	String curPersonPermTaxUnitSql = CmpTaxUnitPermFilter .getCurPersonPermTaxUnitSql(ctx);
//    	if (!(StringUtils.isEmpty(curPersonPermTaxUnitSql))) {
//    		FilterItemInfo taxUnitFilterItem = new FilterItemInfo("taxUnit",
//    				curPersonPermTaxUnitSql, CompareType.INNER);
//    		filterItems.add(taxUnitFilterItem);
//    	}
    	return filterInfo;
    }
    
    
}
