package com.kingdee.eas.custom.shuiyou.six.handler;

import cn.hutool.json.JSONUtil;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.google.common.collect.Maps;
import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.metadata.entity.EntityViewInfo;
import com.kingdee.bos.metadata.entity.FilterInfo;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.bos.metadata.entity.SelectorItemInfo;
import com.kingdee.bos.sql.ParserException;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.eas.basedata.hraux.BirthplaceFactory;
import com.kingdee.eas.basedata.hraux.NationalityFactory;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.shuiyou.incomeTax.ITaxPersonReportExFacade;
import com.kingdee.eas.custom.shuiyou.incomeTax.TaxPersonReportExFacadeFactory;
import com.kingdee.eas.custom.shuiyou.task.TaskCatalogEnum;
import com.kingdee.eas.custom.shuiyou.uitls.ISYUtilsFacade;
import com.kingdee.eas.custom.shuiyou.uitls.SYUtilsFacadeFactory;
import com.kingdee.eas.framework.CoreBaseCollection;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.eas.framework.util.FilterUtility;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.exception.ShrWebBizException;
import com.kingdee.shr.base.syssetting.util.SqlFilter;
import com.kingdee.shr.base.syssetting.web.json.JSONUtils;
import com.kingdee.shr.compensation.*;
import com.kingdee.shr.compensation.app.entity.TaxPersonEntity;
import com.kingdee.shr.compensation.app.entity.Triple;
import com.kingdee.shr.compensation.app.incomeTax.*;
import com.kingdee.shr.compensation.app.tax.TaxUnitCollection;
import com.kingdee.shr.compensation.app.tax.TaxUnitFactory;
import com.kingdee.shr.compensation.app.tax.TaxUnitInfo;
import com.kingdee.shr.compensation.app.taxCal.ITaxServiceTaskFacade;
import com.kingdee.shr.compensation.app.taxCal.TaxCalTaskCatalogEnum;
import com.kingdee.shr.compensation.app.taxCal.TaxServiceTaskFacadeFactory;
import com.kingdee.shr.compensation.util.Base64Utils;
import com.kingdee.shr.compensation.util.CmpDateUtil;
import com.kingdee.shr.compensation.util.TaxReportUtil;
import com.kingdee.shr.compensation.util.filter.CmpTaxUnitPermFilter;
import com.kingdee.shr.compensation.web.handler.incometax.TaxPersonRecordListHandler;
import com.kingdee.util.StringUtils;
import org.apache.log4j.Logger;
import org.springframework.ui.ModelMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import java.lang.reflect.Field;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * description: TaxPersonRecordListHandlerEx <br>
 * date: 2024/9/11 14:25 <br>
 * author: lhbj <br>
 * version: 1.0 <br>
 */
public class TaxPersonRecordListHandlerEx extends TaxPersonRecordListHandler {
    private static Logger logger = Logger.getLogger("com.kingdee.eas.custom.shuiyou.TaxUnitListHandlerEx");
    /**
     * Ա
     * @param request
     * @param response
     * @param modelMap
     * @throws SHRWebException
     */
    @Override
    public String reportAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws SHRWebException {
        Context ctx = SHRContext.getInstance().getContext();
        String selectedIds = request.getParameter("selectedIds");
        String taxPeriodDate = request.getParameter("taxPeriodDate");
        HashMap map = new HashMap();

        try {
            if (!StringUtils.isEmpty(selectedIds)) {
                int count = 0;
                selectedIds = "'" + selectedIds.replaceAll(",", "','") + "'";
                String oql = " select id,submitStatus where id in (" + selectedIds + ")";
                ITaxPersonRecordEntry iTaxPersonRecordEntry = TaxPersonRecordEntryFactory.getLocalInstance(ctx);
                TaxPersonRecordEntryCollection taxRecordEntryCollection = iTaxPersonRecordEntry.getTaxPersonRecordEntryCollection(oql);

                for(int i = 0; i < taxRecordEntryCollection.size(); ++i) {
                    TaxPersonRecordEntryInfo taxPersonRecordEntryInfo = taxRecordEntryCollection.get(i);
                    if (SubmitStatusEnum.Submiting.equals(taxPersonRecordEntryInfo.getSubmitStatus()) || SubmitStatusEnum.HaveSubmit.equals(taxPersonRecordEntryInfo.getSubmitStatus())) {
                        ++count;
                    }
                }

                if (count == taxRecordEntryCollection.size()) {
                    map.put("message", TaxReportMessageEnum.Report_False.getAlias());
                } else if (count == 0) {
                    map.put("message", TaxReportMessageEnum.Report_True.getAlias());
                } else {
                    map.put("message", TaxReportMessageEnum.Report_Between.getAlias());
                }
            } else {
                map.put("message", TaxReportMessageEnum.Report_Between.getAlias());
            }

            String filter = this.getFilter(request, response, modelMap);


            logger.error("------------>>>>reportActiontaxPeriodDate" + taxPeriodDate);
            ITaxPersonReportExFacade iTaxPersonReportFacade = TaxPersonReportExFacadeFactory.getLocalInstance(ctx);
            Map<String,Object> paramMap = Maps.newHashMap();

            paramMap.put("filter",filter);
            paramMap.put("entryIDs",selectedIds);
            paramMap.put("taxPeriodDate",taxPeriodDate);

            iTaxPersonReportFacade.report(paramMap);
            //this._report(ctx,selectedIds, taxPeriodDate, filter);
            JSONUtils.SUCCESS(map);
            return null;
        } catch (Exception var14) {
            logger.error(var14.getMessage(), var14);
            System.err.println("--------------->>>>>>>>쳣" + var14.getMessage().toString());
            throw new ShrWebBizException(var14.getMessage());
        }
    }
    private Set<String> getPersonsSet(List<TaxPersonEntity> taxPersonEntitys, String sdyf) {
        Set<String> result = new HashSet();
        if (null != taxPersonEntitys && taxPersonEntitys.size() >= 1) {
            Iterator i$ = taxPersonEntitys.iterator();

            while(i$.hasNext()) {
                TaxPersonEntity taxPersonEntity = (TaxPersonEntity)i$.next();
                result.add(taxPersonEntity.getXm() + "_" + taxPersonEntity.getZzhm() + "_" + taxPersonEntity.getZzlx() + "_" + sdyf);
            }

            return result;
        } else {
            return result;
        }
    }
    private Map<TaxUnitInfo, List<TaxPersonRecordEntryInfo>> getEntryMap(TaxPersonRecordEntryCollection taxRecordEntryCollection) {
        Map<TaxUnitInfo, List<TaxPersonRecordEntryInfo>> entryMap = new HashMap();
        Map<String, List<TaxPersonRecordEntryInfo>> stringEntryMap = new HashMap();
        Map<String, TaxUnitInfo> taxUnitMap = new HashMap();

        for(int i = 0; i < taxRecordEntryCollection.size(); ++i) {
            TaxPersonRecordEntryInfo taxPersonRecordEntryInfo = taxRecordEntryCollection.get(i);
            TaxUnitInfo taxUnit = taxPersonRecordEntryInfo.getTaxUnit();
            if (!taxUnitMap.containsKey(taxUnit.getId().toString())) {
                taxUnitMap.put(taxUnit.getId().toString(), taxUnit);
            }

            if (stringEntryMap.containsKey(taxUnit.getId().toString())) {
                List<TaxPersonRecordEntryInfo> taxPersonRecordEntryInfos = (List)stringEntryMap.get(taxUnit.getId().toString());
                taxPersonRecordEntryInfos.add(taxPersonRecordEntryInfo);
            } else {
                List<TaxPersonRecordEntryInfo> taxPersonRecordEntryInfos = new ArrayList();
                taxPersonRecordEntryInfos.add(taxPersonRecordEntryInfo);
                stringEntryMap.put(taxUnit.getId().toString(), taxPersonRecordEntryInfos);
            }
        }

        Iterator i$ = stringEntryMap.entrySet().iterator();

        while(i$.hasNext()) {
            Map.Entry<String, List<TaxPersonRecordEntryInfo>> entry = (Map.Entry)i$.next();
            entryMap.put(taxUnitMap.get(entry.getKey()), entry.getValue());
        }

        return entryMap;
    }
    private List<Object[]> getParamsList(CoreBaseCollection coreBaseCollection, String taskId) {
        List<Object[]> paramsList = new ArrayList();

        for(int i = 0; i < coreBaseCollection.size(); ++i) {
            CoreBaseInfo coreBaseInfo = coreBaseCollection.get(i);
            Object[] object;
            String bankCardStatus;
            String id;
            if (coreBaseInfo instanceof TaxPersonRecordEntryInfo) {
                object = new Object[6];
                TaxPersonRecordEntryInfo taxPersonRecordEntryInfo = (TaxPersonRecordEntryInfo)coreBaseInfo;
                bankCardStatus = taxPersonRecordEntryInfo.getSubmitStatus().getValue();
                String identityStatus = taxPersonRecordEntryInfo.getIdentityStatus().getValue();
                String lastReportMonth = taxPersonRecordEntryInfo.getLastReportMonth();
                id = taxPersonRecordEntryInfo.getId().toString();
                object[0] = bankCardStatus;
                object[1] = identityStatus;
                object[2] = taskId != null ? taskId : "-1";
                object[3] = lastReportMonth;
                object[4] = CmpDateUtil.toSqlDate(lastReportMonth + "-01");
                object[5] = id;
                paramsList.add(object);
            }

            if (coreBaseInfo instanceof TaxPersonRecordInfo) {
                object = new Object[2];
                TaxPersonRecordInfo taxPersonRecordInfo = (TaxPersonRecordInfo)coreBaseInfo;
                bankCardStatus = taxPersonRecordInfo.getBankCardStatus().getValue();
                id = taxPersonRecordInfo.getId().toString();
                object[0] = bankCardStatus;
                object[1] = id;
                paramsList.add(object);
            }
        }

        return paramsList;
    }

    protected Map<TaxUnitInfo, Triple<List<TaxPersonEntity>, CoreBaseCollection, CoreBaseCollection>> getTripleMap(TaxPersonRecordEntryCollection taxRecordEntryCollection, String taxPeriodDate) {
        Map<TaxUnitInfo, Triple<List<TaxPersonEntity>, CoreBaseCollection, CoreBaseCollection>> tripleMap = new HashMap();
        Map<TaxUnitInfo, List<TaxPersonRecordEntryInfo>> entryMap = this.getEntryMap(taxRecordEntryCollection);
        Set<String> billIdSet = new HashSet();
        Iterator i$ = entryMap.entrySet().iterator();

        while(i$.hasNext()) {
            Map.Entry<TaxUnitInfo, List<TaxPersonRecordEntryInfo>> entry = (Map.Entry)i$.next();
            Triple<List<TaxPersonEntity>, CoreBaseCollection, CoreBaseCollection> triple = new Triple();
            TaxUnitInfo key = (TaxUnitInfo)entry.getKey();
            List<TaxPersonRecordEntryInfo> value = (List)entry.getValue();
            List<TaxPersonEntity> taxPersonEntitys = new ArrayList();
            CoreBaseCollection entryBaseCollection = new CoreBaseCollection();
            CoreBaseCollection billBaseCollection = new CoreBaseCollection();
            Iterator i$value = value.iterator();

            while(i$value.hasNext()) {
                TaxPersonRecordEntryInfo taxPersonRecordEntryInfo = (TaxPersonRecordEntryInfo)i$value.next();
                TaxPersonEntity taxPersonEntity = TaxReportUtil.taxPersonRecordEntryInfo2TaxPersonEntity(taxPersonRecordEntryInfo);
                taxPersonEntitys.add(taxPersonEntity);
                taxPersonRecordEntryInfo.setSubmitStatus(SubmitStatusEnum.Submiting);
                taxPersonRecordEntryInfo.setIdentityStatus(IdentityStatusEnume.VerifyING);
                taxPersonRecordEntryInfo.setLastReportMonth(taxPeriodDate);
                entryBaseCollection.add(taxPersonRecordEntryInfo);
                TaxPersonRecordInfo bill = taxPersonRecordEntryInfo.getBill();
                if (!billIdSet.contains(bill.getId().toString())) {
                    bill.setBankCardStatus(BankCardStatusEnum.VerifyING);
                    billBaseCollection.add(bill);
                    billIdSet.add(bill.getId().toString());
                }
            }

            triple.setFirst(taxPersonEntitys);
            triple.setSecond(entryBaseCollection);
            triple.setThree(billBaseCollection);
            tripleMap.put(key, triple);
        }

        return tripleMap;
    }
    protected List<IObjectPK> _report(Context ctx, String entryIDs, String taxPeriodDate, String filter) throws BOSException {
        String curPersonPermTaxUnitSql = CmpTaxUnitPermFilter.getCurPersonPermTaxUnitSql(ctx);
        String oql = "select *,bill.*,bill.person.*,bill.nationality.*,bill.position.*,bill.birthPlace.*,bill.eduLevel.*,bill.bank.name,bill.hrBank.name,taxUnit.id,taxUnit.areacode,taxUnit.name,taxUnit.taxNumber,taxUnit.areaCode,taxUnit.regNumber,taxUnit.declPassword,taxUnit.realPassword where (submitStatus=0 or submitStatus=3) ";
        logger.error("------------>>>>_report" + oql);
        if (!StringUtils.isEmpty(entryIDs)) {
            oql = oql + " and taxUnit.id in (" + curPersonPermTaxUnitSql + ")";
            oql = oql + " and id in (" + entryIDs + ")";
        } else {
            if (StringUtils.isEmpty(filter)) {
                return null;
            }

            oql = oql + " and " + filter;
        }
        ArrayList arrayList = new ArrayList();
        try {
            ITaxPersonRecordEntry iTaxPersonRecordEntry = TaxPersonRecordEntryFactory.getLocalInstance(ctx);
            TaxPersonRecordEntryCollection taxRecordEntryCollection = iTaxPersonRecordEntry.getTaxPersonRecordEntryCollection(oql);
            if (taxRecordEntryCollection.size() == 0) {
                return null;
            } else {
                Map<TaxUnitInfo, Triple<List<TaxPersonEntity>, CoreBaseCollection, CoreBaseCollection>> tripleMap = this.getTripleMap(taxRecordEntryCollection, taxPeriodDate);
                ITaxServiceTaskFacade iTaxServiceTaskFacade = TaxServiceTaskFacadeFactory.getLocalInstance(ctx);
                Iterator i$ = tripleMap.entrySet().iterator();
                ISYUtilsFacade localInstance = SYUtilsFacadeFactory.getLocalInstance(ctx);
                Map<String,String> propt=localInstance.getConfig();
                while(i$.hasNext()) {
                    Map.Entry<TaxUnitInfo, Triple<List<TaxPersonEntity>, CoreBaseCollection, CoreBaseCollection>> entry = (Map.Entry)i$.next();
                    TaxUnitInfo taxUnitInfo = (TaxUnitInfo)entry.getKey();
                    Triple<List<TaxPersonEntity>, CoreBaseCollection, CoreBaseCollection> value = (Triple)entry.getValue();
                    List<TaxPersonEntity> taxPersonEntitys = (List)value.getFirst();
                    CoreBaseCollection entryBaseCollection = (CoreBaseCollection)value.getSecond();
                    CoreBaseCollection billBaseCollection = (CoreBaseCollection)value.getThree();
                    Map<String, Object> reMap = new HashMap();
                    reMap.put("nsrsbh", taxUnitInfo.getTaxNumber());
                    reMap.put("areaid", taxUnitInfo.getAreaCode());
                    reMap.put("djxhid", taxUnitInfo.getRegNumber());
                    reMap.put("ver", "V2.0.000");
                    reMap.put("sbmm", Base64Utils.decode(taxUnitInfo.getDeclPassword()));
                    String realPassword = taxUnitInfo.getRealPassword();
                    if (!StringUtils.isEmpty(realPassword)) {
                        reMap.put("smmm", Base64Utils.decode(realPassword));
                    }

                    reMap.put("zrs", taxPersonEntitys.size());
                    String sdyf = TaxReportUtil.getCurrentYearMonth(taxPeriodDate);
                    reMap.put("sdyf", sdyf);
                    reMap.put("bmbh", "");
                    reMap.put("nsrlb", taxPersonEntitys);
                    reMap.put("TAXUNITID", taxUnitInfo.getId().toString());
                    Set<String> persons = this.getPersonsSet(taxPersonEntitys, sdyf);
                    reMap.put("persons", persons);
                    //ʼ
                    String bizNo = UUID.randomUUID().toString().replace("-", "");
                    String qymc = taxUnitInfo.getName();//ҵ
                    String mmlx = "0";// 0ʾ걨룻2ʾʵ˺ʵ
                    String smzh = "";//ʵ˺
                    String smmm = "";//ʵ
                    String jmsmmm = "";//ʵ
                    String sbmm = "";
                    sbmm=( Base64Utils.decode(taxUnitInfo.getDeclPassword()));
                    String jmsbmm = "";//걨
                    String djxhid = taxUnitInfo.getRegNumber();//Ǽ
                    String nsrsbh = taxUnitInfo.getTaxNumber();//˰
                    String areaid = taxUnitInfo.getAreaCode();//
                    String bmbh = "";//ű
                    String bmmc = "";//ű
                    String skssq = sdyf;//
                    String lzrqcl = "";
                    JSONObject postBody = new JSONObject();
                    postBody.put("bizNo",bizNo);
                    postBody.put("qymc", qymc);
                    postBody.put("mmlx", mmlx);
                    postBody.put("smzh", smzh);
                    postBody.put("smmm", smmm);
                    postBody.put("jmsmmm", jmsmmm);
                    postBody.put("sbmm", sbmm);
                    postBody.put("jmsbmm", jmsbmm);
                    postBody.put("djxhid", djxhid);
                    postBody.put("nsrsbh", nsrsbh);
                    postBody.put("areaid", areaid);
                    postBody.put("bmbh", bmbh);
                    postBody.put("bmmc", bmmc);
                    postBody.put("skssq", skssq);
                    postBody.put("lzrqcl", lzrqcl);
                    BOSUuid id = taxUnitInfo.getId();
                    JSONArray rylb = new JSONArray();
                    for(TaxPersonEntity personEntity : taxPersonEntitys){
                        Map<String,Object> person = this.objectToMap(personEntity);

                        TaxPersonRecordInfo rInfo=null;
                        String zzhm=personEntity.getZzhm();
                        for(int i=0;i<billBaseCollection.size();i++){
                            TaxPersonRecordInfo r1Info= (TaxPersonRecordInfo) billBaseCollection.get(i);
                            if(zzhm.equals(r1Info.getCardNumber())) {
                                rInfo=r1Info;
                                break;
                            }
                        }
                        person.put("skssq",sdyf);
                        Optional<IsOverseaEnum> oversea = Optional.ofNullable(rInfo.getIsOversea());
                        person.put("rydq","0".equals(oversea.orElse(IsOverseaEnum.NotOversea).getValue())?"":"");
                        person.put("grgbbl",rInfo.getInvestmentRate());//Ͷܶ
                        person.put("grgbze",rInfo.getInvestmentTotal());//Ͷʱ
                        person.put("khyhsfmz",rInfo.getBankCardProvince());//ʡ()
                        person.put("rybscl","");//ʡ()
                        rylb.add(person);
                    }
                    postBody.put("rylb",rylb);
                    String ip = propt.get("ip");
                    String url = ip + "/gateway/iit/declare/declareEmployeeInfo";
                    logger.error("====="+postBody+"========");
                    String post = localInstance.post(url, postBody.toJSONString());
                    System.out.println(post);
                    JSONObject postJSON = JSONObject.parseObject(post);
                    //У Ƿɹ
                    JSONObject head = postJSON.getJSONObject("head");
                    String code = (String) head.get("code");
                    if ("00000000".equals(code)){
                        JSONObject body = postJSON.getJSONObject("body");

                        String taskId = localInstance.addTask("personnelReportService", JSONUtil.toJsonStr(body), TaskCatalogEnum.PERSON,null);
                        List<Object[]> recordEntryParamsList = this.getParamsList(entryBaseCollection, taskId);
                        String recordEntrySql = "update T_HR_STaxPersonRecordEntry set FSubmitStatus= ?, FIdentityStatus=?,CFTaskID=?, FLastReportMonth=?,FEndDate=? where fid =?";
                        DbUtil.executeBatch(ctx, recordEntrySql, recordEntryParamsList);
                        logger.info("--------->>>>>±״̬֤״̬recordEntrySql:" + recordEntrySql + "------>>>>recordEntryParamsList:" + recordEntryParamsList + "---------->>>addTask:" + taskId);
                        List<Object[]> recordParamsList = this.getParamsList(billBaseCollection, (String)null);
                        String recordSql = "update T_HR_STaxPersonRecord set FBankCardStatus=? where fid =?";
                        DbUtil.executeBatch(ctx, recordSql, recordParamsList);
                        logger.info("--------->>>>>п״̬recordSql:" + recordSql + "------>>>>recordParamsList:" + recordParamsList);
                        arrayList.add(taskId);
                    }
                }
                return arrayList;
            }
        } catch (Exception var28) {
            logger.error(var28.getMessage(), var28);
            logger.error("------------>>>>쳣" + var28.getMessage());
            throw new BOSException(var28.getMessage(), var28);
        }
    }

    public Map<String,Object> objectToMap(Object obj){
        Map<String,Object> map = Maps.newHashMap();
        Class<?> clazz = obj.getClass();
        for(Field field : clazz.getDeclaredFields()){
            try{
                field.setAccessible(true);
                map.put(field.getName(),field.get(obj));
            }catch (IllegalAccessException e){
                e.printStackTrace();
            }
        }
        return map;
    }



    protected String getFilter(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws SHRWebException {
        super.prepareQueryList(request, response, modelMap);
        EntityViewInfo assembleEntityViewInfo = this.assembleEntityViewInfo(request, modelMap);
        FilterInfo filter = assembleEntityViewInfo.getFilter();
        return filter.toSql();
    }
    protected EntityViewInfo assembleEntityViewInfo(HttpServletRequest request, ModelMap modelMap) throws SHRWebException {
        EntityViewInfo defaultEntityViewInfo = (EntityViewInfo)modelMap.get("DataGridEntityView");
        if (defaultEntityViewInfo == null) {
            defaultEntityViewInfo = new EntityViewInfo();
        }

        String[] selector;
        SelectorItemCollection sic;
        int len$;
        if (!StringUtils.isEmpty(request.getParameter("selector"))) {
            selector = request.getParameter("selector").split(",");
            sic = defaultEntityViewInfo.getSelector();
            int i = 0;

            for(len$ = selector.length; i < len$; ++i) {
                sic.add(new SelectorItemInfo(selector[i]));
            }
        }

        if (!StringUtils.isEmpty(request.getParameter("columnModel"))) {
            selector = request.getParameter("columnModel").split(",");
            sic = defaultEntityViewInfo.getSelector();
            String[] arr$ = selector;
            len$ = selector.length;

            for(int i$ = 0; i$ < len$; ++i$) {
                String s = arr$[i$];
                if (SqlFilter.isvalid(s)) {
                    sic.add(new SelectorItemInfo(s));
                }
            }
        }

        String filter = (String)modelMap.get("filter");
        if (StringUtils.isEmpty(filter)) {
            filter = request.getParameter("filter");
        }

        if (!StringUtils.isEmpty(filter)) {
            try {
                FilterInfo filterInfo = new FilterInfo(filter);
                if (FilterUtility.hasFilterItem(defaultEntityViewInfo.getFilter())) {
                    defaultEntityViewInfo.getFilter().mergeFilter(filterInfo, "AND");
                } else {
                    defaultEntityViewInfo.setFilter(new FilterInfo(filter));
                }
            } catch (ParserException var12) {
                throw new SHRWebException(var12.getMessage(), var12);
            } catch (BOSException var13) {
                throw new SHRWebException(var13.getMessage(), var13);
            }
        }

        String filterItems = (String)modelMap.get("filterItems");
        if (StringUtils.isEmpty(filterItems)) {
            filterItems = request.getParameter("filterItems");
        }

        if (!StringUtils.isEmpty(filterItems)) {
            try {
                FilterInfo filterInfo = new FilterInfo(filterItems);
                if (FilterUtility.hasFilterItem(defaultEntityViewInfo.getFilter())) {
                    defaultEntityViewInfo.getFilter().mergeFilter(filterInfo, "AND");
                } else {
                    defaultEntityViewInfo.setFilter(new FilterInfo(filterItems));
                }
            } catch (ParserException var10) {
                throw new SHRWebException(var10);
            } catch (BOSException var11) {
                throw new SHRWebException(var11);
            }
        }
        return defaultEntityViewInfo;
    }
    public String personnelReportAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws SHRWebException {
        logger.error("==뵽==com.kingdee.eas.custom.shuiyou.TaxUnitListHandlerEx.personnelReportAction=====================");
        Context context = SHRContext.getInstance().getContext();
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd");
        Map<String,Object> returnMap = new HashMap<String,Object>();
        String selectedIds = request.getParameter("selectedIds");
        String taxPeriodDate = request.getParameter("taxPeriodDate");
        if (taxPeriodDate==null||"".equals(taxPeriodDate)){
            SimpleDateFormat taxPeriodFormat = new SimpleDateFormat("yyyyMM");
            taxPeriodDate=taxPeriodFormat.format(new Date());
        }
        try {
            ISYUtilsFacade localInstance = SYUtilsFacadeFactory.getLocalInstance(context);
            Map<String,String> propt=localInstance.getConfig();
            TaxUnitCollection taxUnitCollection = TaxUnitFactory.getLocalInstance(context).getTaxUnitCollection();
            for (int i = 0; i < taxUnitCollection.size(); i++) {
                TaxUnitInfo taxUnitInfo = taxUnitCollection.get(i);
                String bizNo = UUID.randomUUID().toString().replace("-", "");
                String qymc = taxUnitInfo.getName();//ҵ
                String mmlx = "0";// 0ʾ걨룻2ʾʵ˺ʵ
                String smzh = "";//ʵ˺
                String smmm = "";//ʵ
                String jmsmmm = "";//ʵ
                String sbmm = "";
                if (taxUnitInfo.getDeclPassword()!=null&&!"".equals(taxUnitInfo.getDeclPassword())){
                    byte[] decode = Base64.getDecoder().decode(taxUnitInfo.getDeclPassword());
                    sbmm  = new String(decode);//;//걨
                }
                String jmsbmm = "";//걨
                String djxhid = taxUnitInfo.getRegNumber();//Ǽ
                String nsrsbh = taxUnitInfo.getTaxNumber();//˰
                String areaid = taxUnitInfo.getAreaCode();//
                String bmbh = "";//ű
                String bmmc = "";//ű
                String skssq = taxPeriodDate;//  ----֪ô
                String lzrqcl = "";
                JSONObject postBody = new JSONObject();
                postBody.put("bizNo",bizNo);
                postBody.put("qymc", qymc);
                postBody.put("mmlx", mmlx);
                postBody.put("smzh", smzh);
                postBody.put("smmm", smmm);
                postBody.put("jmsmmm", jmsmmm);
                postBody.put("sbmm", sbmm);
                postBody.put("jmsbmm", jmsbmm);
                postBody.put("djxhid", djxhid);
                postBody.put("nsrsbh", nsrsbh);
                postBody.put("areaid", areaid);
                postBody.put("bmbh", bmbh);
                postBody.put("bmmc", bmmc);
                postBody.put("skssq", skssq);
                postBody.put("lzrqcl", lzrqcl);
                BOSUuid id = taxUnitInfo.getId();
                //STaxPersonRecordEntry
                TaxPersonRecordEntryCollection taxPersonRecordEntrys = null;
                if (selectedIds!=null&&!selectedIds.equals("")){
                    taxPersonRecordEntrys = TaxPersonRecordEntryFactory.getLocalInstance(context).
                            getTaxPersonRecordEntryCollection("select * , bill.* where taxUnit = '" + id.toString() + "' and id in (" + selectedIds + ")");
                }else {
                    taxPersonRecordEntrys = TaxPersonRecordEntryFactory.getLocalInstance(context).
                            getTaxPersonRecordEntryCollection("select * , bill.* where taxUnit = '" + id.toString() + "' ");
                }


                JSONArray rylb = new JSONArray();
                JSONObject personInfo = null;
                int size = taxPersonRecordEntrys.size();
                if (size==0){
                    break;
                }
                for (int j = 0; j < size; j++) {
                    personInfo = new JSONObject();
                    TaxPersonRecordEntryInfo taxPersonRecordEntryInfo = taxPersonRecordEntrys.get(j);
                    TaxPersonRecordInfo bill = taxPersonRecordEntryInfo.getBill();
                    String xm = bill.getReportName();//
                    String zzlx = bill.getCardType().getAlias();//֤
                    String zzhm = bill.getCardNumber();//֤
                    String s = cardTypeReflection(zzlx);//֤
                    Boolean cardType = isCardType(s);
                    String qtzzlx = "";//֤
                    String qtzzhm = "";//֤
                    if (cardType) {
                        qtzzlx = cardTypeReflection(bill.getOtherCardType().getAlias());//֤
                        qtzzhm = bill.getOtherCardNumber();//֤
                    }
                    String bmbh1 = "";//ű
                    String rybscl = "";//ԱͲ
                    String gh = "";//
                    String skssq1 = taxPeriodDate;//
                    String lxdh = bill.getPhoneNumber(); //绰
                    String nsrzt = taxPersonRecordEntryInfo.getPersonStatus().getValue();//Ա״̬
                    String sfgy = taxPersonRecordEntryInfo.getEmployedType().getAlias();//ְܹ
                    String rzndjyqk = "";//ְȾҵ
                    String rzsgrq = "";//ܹ
                    if ("ԱӪԱ֤ȯ".indexOf(sfgy) >= 0) {
                        Date employedDate = taxPersonRecordEntryInfo.getEmployedDate();
                        rzsgrq = simpleDateFormat.format(employedDate);
                    }
                    String xb = bill.getGender().getAlias();//Ա
                    String csny = simpleDateFormat.format(bill.getBirthday());//
                    String gj = NationalityFactory.getLocalInstance(context).getNationalityInfo(new ObjectUuidPK(bill.getNationality().getId())).getName();//
                    String rydq = bill.getIsOversea().getAlias();//Ƿ
                    if (rydq.equals("")) {
                        rydq = "";
                    } else {
                        rydq = "";
                    }
                    String lzrq = "";//ְ
                    if (nsrzt.equals("0")) {
                        lzrq = simpleDateFormat.format(taxPersonRecordEntryInfo.getDepartureDate());
                    }
                    BigDecimal grgbbl = bill.getInvestmentRate();//Ͷܶ
                    BigDecimal grgbze = bill.getInvestmentTotal();//Ͷʱ
                    String sfcj = bill.isIsDisability() ? "" : "";
                    String cjzjlx = "";//м֤
                    String cjzh = "";//м֤
                    if ("".equals(sfcj)) {
                        cjzjlx = "";//           ϵͳûҪ
                        cjzh = bill.getDisCardNumber();
                    }
                    String sfls = bill.isIsHero() ? "" : "";
                    String lszh = "";
                    if ("".equals(sfls)) {
                        lszh = bill.getHeroCardNumber();
                    }
                    String sfgl = ""; //Ƿ
                    String sfzdw = "";//Ƿ۳
                    String dzyx = "";//
                    String xl = "";
                    String zw = "";//	ְ
                    String khyh = "";//	
                    String khyhsfmz = "";//	ʡ
                    String yhzh = "";//	˺
                    String lxdz_sheng = "";//	סʡ
                    String lxdz_shi = "";//	ס
                    String lxdz_qx = "";//	ס
                    String lxdz_jd = "";//	סֵ
                    String lxdz = "";//	סϸַ
                    String hjszd_sheng = "";//	ʡ
                    String hjszd_shi = "";//	
                    String hjszd_qx = "";//	
                    String hjszd_jd = "";//	ֵ
                    String hjszd_xxdz = "";//	ϸַ
                    String bz = "";//	ע
                    String csd = "";
                    String sssx = "";
                    if (gj.indexOf("й") < 0) {
                        logger.error(JSONObject.toJSONString(bill.getBirthPlace()));
                        logger.error(bill.getBirthPlace().getId());
                        csd = BirthplaceFactory.getLocalInstance(context).
                                getBirthplaceInfo(new ObjectUuidPK(bill.getBirthPlace().getId())).getName();
                        sssx = bill.getTaxReason().getAlias();
                    }
                    String ss = "۰ľڵ֤ͨ۰ľס̨֤½̨֤ͨס֤աþ֤֤A֤B֤Cʱ";
                    String scrjsj = "";
                    String yjljsj = "";
                    if (ss.indexOf(s) >= 0) {
                        scrjsj = simpleDateFormat.format(bill.getEntryDate());
                        yjljsj = simpleDateFormat.format(bill.getLeaveDate());
                    }
                    String wjrlxdz_sheng = "";//	ϵʡ
                    String wjrlxdz_shi = "";//	ϵس
                    String wjrlxdz_qx = "";//	ϵ
                    String wjrlxdz_jd = "";//	ϵؽֵ
                    String wjrlxdz_xxdz = "";//	ϵϸַ
                    String xmzw = "";//	
                    ss = "աþ֤˹֤Aࣩ˹֤Bࣩ˹֤Cࣩ";
                    if (ss.indexOf(s) < 0) {
                        xmzw = bill.getChineseName();
                    }
                    personInfo.put("xm", xm);
                    personInfo.put("zzlx", s);
                    personInfo.put("zzhm", zzhm);
                    personInfo.put("qtzzlx", qtzzlx);
                    personInfo.put("qtzzhm", qtzzhm);
                    personInfo.put("bmbh", bmbh1);
                    personInfo.put("rybscl", rybscl);
                    personInfo.put("gh", gh);
                    personInfo.put("skssq", skssq1);
                    personInfo.put("lxdh", lxdh);
                    if (nsrzt.equals("1")){
                        nsrzt="";
                    }else{
                        nsrzt = "";
                    }
                    personInfo.put("nsrzt", nsrzt);
                    personInfo.put("sfgy", sfgy);
                    personInfo.put("rzndjyqk", rzndjyqk);
                    personInfo.put("rzsgrq", rzsgrq);
                    personInfo.put("xb", xb);
                    personInfo.put("csny", csny);
                    personInfo.put("gj", gj);
                    personInfo.put("rydq", rydq);
                    personInfo.put("lzrq", lzrq);
                    personInfo.put("grgbbl", grgbbl);
                    personInfo.put("grgbze", grgbze);
                    personInfo.put("sfcj", sfcj);
                    personInfo.put("cjzjlx", cjzjlx);
                    personInfo.put("cjzh", cjzh);
                    personInfo.put("sfls", sfls);
                    personInfo.put("lszh", lszh);
                    personInfo.put("sfgl", sfgl);
                    personInfo.put("sfzdw", sfzdw);
                    personInfo.put("dzyx", dzyx);
                    personInfo.put("xl", xl);
                    personInfo.put("zw", zw);
                    personInfo.put("khyh", khyh);
                    personInfo.put("khyhsfmz", khyhsfmz);
                    personInfo.put("yhzh", yhzh);
                    personInfo.put("lxdz_sheng", lxdz_sheng);
                    personInfo.put("lxdz_shi", lxdz_shi);
                    personInfo.put("lxdz_qx", lxdz_qx);
                    personInfo.put("lxdz_jd", lxdz_jd);
                    personInfo.put("lxdz", lxdz);
                    personInfo.put("hjszd_sheng", hjszd_sheng);
                    personInfo.put("hjszd_shi", hjszd_shi);
                    personInfo.put("hjszd_qx", hjszd_qx);
                    personInfo.put("hjszd_jd", hjszd_jd);
                    personInfo.put("hjszd_xxdz", hjszd_xxdz);
                    personInfo.put("bz", bz);
                    personInfo.put("csd", csd);
                    personInfo.put("sssx", sssx);
                    personInfo.put("scrjsj", scrjsj);
                    personInfo.put("yjljsj", yjljsj);
                    personInfo.put("wjrlxdz_sheng", wjrlxdz_sheng);
                    personInfo.put("wjrlxdz_shi", wjrlxdz_shi);
                    personInfo.put("wjrlxdz_qx", wjrlxdz_qx);
                    personInfo.put("wjrlxdz_jd", wjrlxdz_jd);
                    personInfo.put("wjrlxdz_xxdz", wjrlxdz_xxdz);
                    personInfo.put("xmzw", xmzw);
                    rylb.add(personInfo);

                }
                postBody.put("rylb", rylb);
                String ip = propt.get("ip");
                String url = ip + "/gateway/iit/declare/declareEmployeeInfo";
                logger.error("====="+postBody+"========");

                String post = localInstance.post(url, postBody.toJSONString());
                System.out.println(post);
                JSONObject postJSON = JSONObject.parseObject(post);
                //У Ƿɹ
                JSONObject head = postJSON.getJSONObject("head");
                if (head.getString("status").equals("N")){
                    returnMap.put("code",500);
                    returnMap.put("error","ʧ");
                    JSONUtils.SUCCESS(returnMap);
                    return null;
                }
                JSONObject body = postJSON.getJSONObject("body");
                String string = body.getString("requestId");

                String s = localInstance.addTask("personnelReportService", JSONUtil.toJsonStr(body), TaskCatalogEnum.PERSON,null);
                logger.error("ز"+post);
                logger.error("ز"+s);
                returnMap.put("code",200);
                returnMap.put("info","ͳɹ");
                JSONUtils.SUCCESS(returnMap);
            }

        } catch (BOSException e) {
            JSONUtils.ERROR("BOSException",e);
            throw new RuntimeException(e);
        } catch (EASBizException e) {
            JSONUtils.ERROR("EASBizException",e);
            throw new RuntimeException(e);
        }
        return null;
    }
    public String cardTypeReflection(String cardTypeName) {
        switch (cardTypeName) {
            case "֤":
                return "֤";
            case "й":
                return "й";
            case "۰ľڵ֤ͨ":
                return "۰ľڵ֤ͨ";
            case "л񹲺͹۰ľס֤":
                return "۰ľڵ֤ͨ";
            case "̨½֤ͨ":
                return "̨½֤ͨ";
            case "л񹲺͹̨ס֤":
                return "̨ס֤";
            case "":
                return "";
            case "þ֤":
                return "þ֤";
            case "л񹲺͹˹֤Aࣩ":
                return "˹֤Aࣩ";
            case "л񹲺͹˹֤Bࣩ":
                return "˹֤Bࣩ";
            case "л񹲺͹˹֤Cࣩ":
                return "˹֤Cࣩ";
        }
        return "";
    }
    public Boolean isCardType(String cardType) {
        String cardTypes = "۰ľס֤,̨ס֤,þ֤,˹֤Aࣩ,˹֤Bࣩ,˹֤Cࣩ";
        if (cardTypes.indexOf(cardType) >= 0) {
            return true;
        } else {
            return false;
        }
    }
}
