package com.kingdee.eas.custom.shuiyou.six.osf;

import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.bsf.service.app.IHRMsfService;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.shuiyou.task.MessageResult;
import com.kingdee.eas.custom.shuiyou.task.TaskCatalogEnum;
import com.kingdee.eas.custom.shuiyou.uitls.ISYUtilsFacade;
import com.kingdee.eas.custom.shuiyou.uitls.SYUtilsFacadeFactory;
import com.kingdee.eas.custom.shuiyou.uitls.URLConfigEnum;

import java.util.Map;

/**
 * Ͻ
 * description: DownloadService <br>
 * date: 2024/9/12 17:01 <br>
 * author: lhbj <br>
 * version: 1.0 <br>
 */
public class GetPensionDownloadService implements IHRMsfService {
    @Override
    public Object process(Context context, Map map) throws EASBizException, BOSException {
        String this_taskid= (String) map.get("this_taskId");
        String param= (String) map.get("paramData");
        ISYUtilsFacade facade = SYUtilsFacadeFactory.getLocalInstance(context);
        Map<String,String> config =facade.getConfig();
        String result = facade.post(config.get("ip")+ URLConfigEnum.PENSIONDOWNLOAD_VALUE, param);
        MessageResult msgr = null;
        if(null!=result) {
            JSONObject object = JSONUtil.parseObj(result);
            JSONObject head = object.getJSONObject("head");
            if("00000000".equals(head.getStr("code"))) {
                JSONObject body = object.getJSONObject("body");
                body.set("parent_taskid",this_taskid);
                String taskId = facade.addTask("getPensionDownloadFeedback",JSONUtil.toJsonStr(body), TaskCatalogEnum.PERSONAL_PENSION_GET,null);
                msgr = MessageResult.AWAIT_W();
            }else if("00000004".equals(head.getStr("code")))  {
                msgr = MessageResult.AGAIN();
            }else {
                msgr = MessageResult.FAILED(result);
            }
        }else{
            msgr = MessageResult.ERROR(result);
        }
        return msgr;
    }
}
