package com.kingdee.eas.custom.shuiyou.taxCal.service;

import cn.com.servyou.dto.ApiResponse;
import cn.com.servyou.dto.Head;
import cn.com.servyou.dto.employee.EmployeeDeclareFeedback;
import cn.com.servyou.dto.tax.*;
import cn.com.servyou.rmi.client.ClientProxyFactory;
import cn.com.servyou.service.TaxRequest;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.bsf.service.app.IHRMsfService;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.shuiyou.interfacelog.ILogInfo;
import com.kingdee.eas.custom.shuiyou.interfacelog.LogInfoFactory;
import com.kingdee.eas.custom.shuiyou.interfacelog.LogInfoInfo;
import com.kingdee.eas.custom.shuiyou.task.MessageResult;
import com.kingdee.eas.custom.shuiyou.utils.ClientProxyFactoryUtils;
import com.kingdee.eas.hr.ats.AtsUtil;
import com.kingdee.eas.hr.ats.util.AtsDateUtils;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.shr.compensation.CardTypeEnum;
import com.kingdee.shr.compensation.app.incomeTax.*;
import com.kingdee.shr.compensation.app.tax.base.*;
import com.kingdee.shr.compensation.app.taxCal.*;
import com.kingdee.util.StringUtils;
import org.apache.log4j.Logger;

import java.math.BigDecimal;
import java.sql.SQLException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * @Description ȡ첽˰
 * @Date 2024/9/10 15:26
 * @Created by Heyuan
 */
public class GetASynIndividualIncomeTaxFeedback implements IHRMsfService {
    private static Logger logger = Logger.getLogger(GetASynIndividualIncomeTaxFeedback.class);
    private String taxUnitId = null;//˰λid
    private String period = null;//˰ yyyy-MM
    private String creator = null;//id
    private String initIds = null;
    private String periodBegin = null;//˰ yyyy-MM-dd
    private String periodEnd = null;//˰ֹ yyyy-MM-dd
    private ObjectMapper objectMapper = new ObjectMapper();

    //֤map
    //private static Map<String, String> cardTypeEnumMap = null;
    private Map<String, String> incomeItemMap = null;//õĿ
    private Map<String, String> taxItemInitMap = null;//˰Ŀ
    private Map<String, String> taxItemConfigMap = null;//ϸ˰Ŀ
    private Map<String, String> taxPersonRecordMap = null;//ԱϢ key:֤+֤,value:Աid

    @Override
    public MessageResult process(Context ctx, Map paramMap) throws EASBizException, BOSException {
        ILogInfo iLogInfo = LogInfoFactory.getLocalInstance(ctx);
        //ӿ־ʵ
        LogInfoInfo logInfo = new LogInfoInfo();
        //
        logInfo.setEntrance(this.getClass().getName());
        logInfo.setBizDate(new Date());
        try {
            logger.info(" GetASynIndividualIncomeTaxFeedback,  " + objectMapper.writeValueAsString(paramMap));
            MessageResult messageResult = null;
            String this_taskId = (String) paramMap.get("this_taskId");//id
            String paramData = (String) paramMap.get("paramData");
            Map<String, String> paramDataMap = objectMapper.readValue(paramData, Map.class);
            taxUnitId = paramDataMap.get("TAXUNITID");//˰λid
            period = paramDataMap.get("PERIOD");//yyyy-MM
            creator = paramDataMap.get("creator");//id
            initIds = paramDataMap.get("initIds");//id
            String requestId = paramDataMap.get("requestId");
            StringBuilder errorMsg = new StringBuilder();
            if (StringUtils.isEmpty(taxUnitId)) {
                errorMsg.append("˰λidΪ!\n");
            }
            if (StringUtils.isEmpty(period)) {
                errorMsg.append("yyyy-MMΪ!\n");
            }
            if (StringUtils.isEmpty(requestId)) {
                errorMsg.append("requestIdΪ!\n");
            }
            if (errorMsg.length() > 0) {
                throw new BOSException(errorMsg.toString());
            }
            SimpleDateFormat shortsdf = new SimpleDateFormat("yyyy-MM");
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
            Date parse = shortsdf.parse(period);
            periodBegin = sdf.format(AtsDateUtils.getMonthFirstDay(parse));
            periodEnd = sdf.format(AtsDateUtils.getMonthLastDay(parse));
            //ͻ˴
            ClientProxyFactory clientProxyFactory = ClientProxyFactoryUtils.getClientProxyFactory();
            logInfo.setInterfaceAddress("/gateway/iit/calculateTax/getASynIndividualIncomeTaxFeedback");//ӿڵַ
            logInfo.setInterfaceName("getASynIndividualIncomeTaxFeedback");//ӿ
            logInfo.setInParameter("{\"requestId\":\"" + requestId + "\"}");//
            //˰ӿ
            TaxRequest taxRequest = clientProxyFactory.getTaxRequest();
            //첽˰ӿ
            ApiResponse<CalculateTaxResultRequest> apiResponse = taxRequest.getASynIndividualIncomeTaxFeedback(requestId);
            ObjectMapper mapper = new ObjectMapper();
            logInfo.setOutParameter(mapper.writeValueAsString(apiResponse));//ز
            Head head = apiResponse.getHead();
            String status = head.getStatus();
            String code = head.getCode();
            if ("100004".equals(code)) {
                //
                messageResult = MessageResult.AGAIN(head.getMsg());
                logInfo.setErrorInfo(head.getMsg());//Ϣ
                logInfo.setStatus("");
            } else if ("000004".equals(code)) {
                //ʧ
                messageResult = MessageResult.FAILED(head.getMsg());
                logInfo.setErrorInfo(head.getMsg());//Ϣ
                logInfo.setStatus("ʧ");
            } else if ("00000000".equals(code)) {
                logger.info("ɹ");
                //ȡõĿ
                incomeItemMap = getIncomeItemMap(ctx);
                logger.info("objectMapper.writeValueAsString(incomeItemMap)  " + objectMapper.writeValueAsString(incomeItemMap));
                //ȡ˰Ŀ
                getTaxItemMap(ctx);
                logger.info("objectMapper.writeValueAsString(taxItemInitMap)  " + objectMapper.writeValueAsString(taxItemInitMap));
                logger.info("objectMapper.writeValueAsString(taxItemConfigMap)  " + objectMapper.writeValueAsString(taxItemConfigMap));
                //ȡԱϢ
                getTaxPersonRecordMap(ctx);
                logger.info("objectMapper.writeValueAsString(taxPersonRecordMap)  " + objectMapper.writeValueAsString(taxPersonRecordMap));
                //ɹ
                CalculateTaxResultRequest body = apiResponse.getBody();
                //ҵ
//                String qymc = body.getName();
//                //˰
//                String nsrsbh = body.getTaxNo();
//                //ű
//                String bmbh = body.getDeptNo();
//                //
//                String bmmc = body.getDeptName();
//                //
//                String areaid = body.getArea();
//                //˰
//                String skssq = body.getMonth();
//                //ⲿҵ񶩵
//                String bizNo = body.getBizNo();
                //ۺ
                ComplexIncomeResultRequest complexIncomeResult = body.getComplexIncomeResultRequest();
                //Ա걨ʧб
                List<EmployeeDeclareFeedback> employeeDeclareFeedbacks = complexIncomeResult.getEmployeeDeclareFeedbacks();
                String updateSqlTemp = "/*dialect*/update T_HR_STaxCalInitDetail set FERRORINFO = '%s',FSTATE = '50' " +
                        "where fpersonId = '%s' and fid in (%s) and FSTATE =30";
                for (int i = 0; employeeDeclareFeedbacks != null && i < employeeDeclareFeedbacks.size(); i++) {
                    EmployeeDeclareFeedback employeeDeclareFeedback = employeeDeclareFeedbacks.get(i);
                    //ʧԭ
                    String message = employeeDeclareFeedback.getMessage();
                    if (!StringUtils.isEmpty(message)) {
                        //
                        String name = employeeDeclareFeedback.getName();
                        //֤
                        String licenseType = employeeDeclareFeedback.getLicenseType();
                        //֤
                        String licenseNumber = employeeDeclareFeedback.getLicenseNumber();
                        //Աid
                        String personId = taxPersonRecordMap.get(licenseNumber + licenseType);
                        if (StringUtils.isEmpty(personId)) {
                            logger.error("δƥ䵽Ա ֤: " + licenseNumber + " ֤: " + licenseType);
                            continue;
                        }
                        //״̬ 1  2  3 ʧ 4 ɹ
                        //String submissionState = employeeDeclareFeedback.getSubmissionState();
                        //Ա֤״̬ 0 ֤״̬Ϊ֤У֤Ϊݲ֤ 1 ֤ͨ 2 ֤ͨ 4 ֤ 9 ͬ0
                        //String authenticationState = employeeDeclareFeedback.getAuthenticationState();
                        //ר״̬ 2 ɹ 3 ʧ
                        //String deductionSubmissionState = employeeDeclareFeedback.getDeductionSubmissionState();
                        //רͽԭ
                        //String deductionMessage = employeeDeclareFeedback.getDeductionMessage();
                        try {
                            logger.error("ʧԱ    " + name);
                            logger.error("ʧԭ    " + message);
                            String updateSql = String.format(updateSqlTemp, message, personId, initIds);
                            logger.error("ʧܸsql   " + updateSql);
                            DbUtil.execute(ctx, updateSql);
                        } catch (Exception e) {
                            e.printStackTrace();
                        }
                    }
                }
                logger.error("н˰");
                //н˰
                ComplexTaxCalculateResult normalSalarySpecIncome = complexIncomeResult.getNormalSalarySpecIncome();
                handleComplexTaxCalculateResult(ctx, normalSalarySpecIncome);
                logger.error("ȫһԽ˰");
                //ȫһԽ˰
                ComplexTaxCalculateResult annualOneTimeBonusIncome = complexIncomeResult.getAnnualOneTimeBonusIncome();
                handleComplexTaxCalculateResult(ctx, annualOneTimeBonusIncome);
                logger.error("һ񱨳˰");
                //һ񱨳˰
                ComplexTaxCalculateResult laborRemunerationIncome = complexIncomeResult.getLaborRemunerationIncome();
                handleComplexTaxCalculateResult(ctx, laborRemunerationIncome);
                logger.error("ͶͬһԲ˰");
                //ͶͬһԲ˰
                ComplexTaxCalculateResult compensateIncome = complexIncomeResult.getCompensateIncome();
                handleComplexTaxCalculateResult(ctx, compensateIncome);
                messageResult = MessageResult.SUCCESS();
            }
            logger.error("־");
            iLogInfo.addnew(logInfo);
            logger.error("ؽ");
            return messageResult;
        } catch (Exception e) {
            e.printStackTrace();
            logInfo.setErrorInfo(e.getMessage());//Ϣ
            iLogInfo.addnew(logInfo);
            return MessageResult.ERROR(e.getMessage());
        }
    }

    /**
     * Ŀ˰
     *
     * @param ctx
     * @param normalSalarySpecIncome
     * @throws BOSException
     */
    private void handleComplexTaxCalculateResult(
            Context ctx,
            ComplexTaxCalculateResult normalSalarySpecIncome)
            throws BOSException, JsonProcessingException {
        logger.info("handleComplexTaxCalculateResult" + objectMapper.writeValueAsString(normalSalarySpecIncome));
        if (normalSalarySpecIncome != null) {
            //˰
            Integer totalPeople = normalSalarySpecIncome.getTotalPeople();
            //˰ʧ
            Integer failedPeople = normalSalarySpecIncome.getFailedPeople();
            //
            BigDecimal annuityLimit = normalSalarySpecIncome.getAnnuityLimit();
            //
            BigDecimal houseProvidentFundLimit = normalSalarySpecIncome.getHouseProvidentFundLimit();
            //ƽ
            BigDecimal averageAnnual = normalSalarySpecIncome.getAverageAnnual();
            //ҵڵ˰Ƿ걨(нЧ) 0:δ걨 1:걨 2:δ걨
            String etaxDeclaredLastMonth = normalSalarySpecIncome.getEtaxDeclaredLastMonth();
            //ۺ˰ɹб
            List<ComplexIncome> successComplexIncomes = normalSalarySpecIncome.getSuccessComplexIncomes();
            handleSuccessComplexIncome(ctx, successComplexIncomes);
            //ۺ˰ʧнб
            List<ComplexIncome> failedComplexIncomes = normalSalarySpecIncome.getFailedComplexIncomes();
            //handleFailedComplexIncome(failedComplexIncomes);
            //ʧ˰ԭб
            List<CheckTaxCalResult> failedCheckTaxCalResult = normalSalarySpecIncome.getFailedCheckTaxCalResult();
            handleFailedCheckTaxCalResult(ctx, failedCheckTaxCalResult);
        }
    }

    /**
     * ۺ˰ɹб
     */
    private void handleSuccessComplexIncome(Context ctx, List<ComplexIncome> successComplexIncomes) throws BOSException {
        if (successComplexIncomes != null) {
            //SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
            StringBuilder updateSql = new StringBuilder();
            updateSql.append("/*dialect*/update T_HR_STaxCalInitDetail set FSTATE = '40',FERRORINFO = 'ɹ', ");
            for (String key : taxItemInitMap.keySet()) {
                String tableField = taxItemInitMap.get(key);
                updateSql.append(tableField).append("=?, ");
            }
            updateSql.deleteCharAt(updateSql.lastIndexOf(","));
            updateSql.append("  where fpersonId = ? ");
            updateSql.append("  and FTAXUNITID=? and to_char(FPERIODBEGIN,'yyyy-mm-dd') >= ? and to_char(FPERIODEND,'yyyy-mm-dd') <= ? and FINCOMEITEMID=? and FSTATE =30");
            List<Object[]> sqlParams = new ArrayList<>();
            Set<String> personIds = new HashSet<>();
            Set<String> incomeitemIds = new HashSet<>();
            for (int i = 0; successComplexIncomes != null && i < successComplexIncomes.size(); i++) {
                ComplexIncome complexIncome = successComplexIncomes.get(i);
                Map incomeDataMap = new HashMap();
                List updateList = new ArrayList();
                //
                String name = complexIncome.getName();
                //֤
                String licenseType = complexIncome.getLicenseType();
                //String cardTypeValue = cardTypeEnumMap.get(licenseType);
                //֤
                String licenseNumber = complexIncome.getLicenseNumber();
                //Աid
                String personId = taxPersonRecordMap.get(licenseNumber + licenseType);
                if (StringUtils.isEmpty(personId)) {
                    logger.error("δƥ䵽Ա ֤: " + licenseNumber + " ֤: " + licenseType);
                    continue;
                }
                //ܹ
                //String employedDate = complexIncome.getEmployedDate();
                //ְ
                //String resignDate = complexIncome.getResignDate();
                //Ƿϸ걨
                //String isDetailedDeclaration = complexIncome.getIsDetailedDeclaration();
                //
                BigDecimal income = complexIncome.getIncome();
                incomeDataMap.put("sre", income);
                //˰
                BigDecimal exemptIncome = complexIncome.getExemptIncome();
                incomeDataMap.put("mssd", exemptIncome);
                //ϱ
                BigDecimal endowmentInsurance = complexIncome.getEndowmentInsurance();
                incomeDataMap.put("jbylaobxf", endowmentInsurance);
                //ҽƱ
                BigDecimal medicalInsurance = complexIncome.getMedicalInsurance();
                incomeDataMap.put("jbylbxf", medicalInsurance);
                //ʧҵ
                BigDecimal unemploymentInsurance = complexIncome.getUnemploymentInsurance();
                incomeDataMap.put("sybxf", unemploymentInsurance);
                //ס
                BigDecimal houseProvidentFund = complexIncome.getHouseProvidentFund();
                incomeDataMap.put("zfgjj", houseProvidentFund);
                //ԭʼס
                BigDecimal originalHouseProvidentFund = complexIncome.getOriginalHouseProvidentFund();
                //Ů֧
                BigDecimal childEducationExpenditure = complexIncome.getChildEducationExpenditure();
                incomeDataMap.put("dyznjyzc", childEducationExpenditure);
                //֧
                BigDecimal supportElderExpenditure = complexIncome.getSupportElderExpenditure();
                incomeDataMap.put("dysylrzc", supportElderExpenditure);
                //ס֧
                BigDecimal houseRentExpenditure = complexIncome.getHouseRentExpenditure();
                incomeDataMap.put("dyzfzjzc", houseRentExpenditure);
                //ݴ֧
                BigDecimal houseLoanExpenditure = complexIncome.getHouseLoanExpenditure();
                incomeDataMap.put("dyfwdkzc", houseLoanExpenditure);
                //֧
                BigDecimal continueEducationExpenditure = complexIncome.getContinueEducationExpenditure();
                incomeDataMap.put("dyjxjyzc", continueEducationExpenditure);
                //ѧ֧
                BigDecimal unDegreeContinueEducationExpenditure = complexIncome.getUnDegreeContinueEducationExpenditure();
                incomeDataMap.put("dyfxljxjyzc", unDegreeContinueEducationExpenditure);
                //Ӥ׶ջ֧
                BigDecimal babyCareExpenditure = complexIncome.getBabyCareExpenditure();
                incomeDataMap.put("dyyyrzhzc", babyCareExpenditure);
                //ҵ/ְҵ
                BigDecimal annuity = complexIncome.getAnnuity();
                incomeDataMap.put("nj", annuity);
                //ҵ
                BigDecimal commercialHealthInsurance = complexIncome.getCommercialHealthInsurance();
                incomeDataMap.put("syjkbx", commercialHealthInsurance);
                //˰ϱ
                BigDecimal extensionEndowmentInsurance = complexIncome.getExtensionEndowmentInsurance();
                incomeDataMap.put("syylbx", extensionEndowmentInsurance);
                //
                BigDecimal other = complexIncome.getOther();
                incomeDataMap.put("qt", other);
                //˰
                BigDecimal taxDeduction = complexIncome.getTaxDeduction();
                incomeDataMap.put("jmse", taxDeduction);
                //ע Ҫдһڱעд۳Ŀ
                String remark = complexIncome.getRemark();
                incomeDataMap.put("bz", remark);
                //
                BigDecimal deductionAmount = complexIncome.getDeductionAmount();
                incomeDataMap.put("qzd", deductionAmount);
                //۳ϼ
                BigDecimal otherDeductionSum = complexIncome.getOtherDeductionSum();
                incomeDataMap.put("qtckhj", otherDeductionSum);
                //Ӧ˰ö
                BigDecimal taxableIncome = complexIncome.getTaxableIncome();
                incomeDataMap.put("ynssde", taxableIncome);
                //Ӧ˰
                BigDecimal payableAmount = complexIncome.getPayableAmount();
                //ѽ˰
                BigDecimal paidAmount = complexIncome.getPaidAmount();
                //Ӧ۽˰
                BigDecimal withholdingAmount = complexIncome.getWithholdingAmount();
                //˰
                BigDecimal taxRate = complexIncome.getTaxRate();
                incomeDataMap.put("sl", taxRate);
                //۳
                BigDecimal quickDeduction = complexIncome.getQuickDeduction();
                incomeDataMap.put("sskcs", quickDeduction);
                //Ŀ
                String incomeItemName = complexIncome.getIncomeItemName();
                if (!incomeItemMap.containsKey(incomeItemName)) {
                    logger.error("δƥ䵽Ŀ Ϊ: " + incomeItemName);
                    continue;
                }
                String incomeItemId = incomeItemMap.get(incomeItemName);
                incomeDataMap.put("sdxm", incomeItemId);
                //Ӧ˰ ۼӦ۽˰-ۼѽ˰
                BigDecimal refundTax = complexIncome.getRefundTax();
                incomeDataMap.put("bqybtse", refundTax);
                //ۼ ۼ=еĹн֮+ڹн֮ͣ˰㣩
                BigDecimal accumulatedIncome = complexIncome.getAccumulatedIncome();
                incomeDataMap.put("bqljsre", accumulatedIncome);
                //ۼ˰
                BigDecimal accumulatedExemptIncome = complexIncome.getAccumulatedExemptIncome();
                incomeDataMap.put("bqljmssr", accumulatedExemptIncome);
                //ۼר۳
                BigDecimal accumulatedSpecDeduction = complexIncome.getAccumulatedSpecDeduction();
                incomeDataMap.put("zxkchj", accumulatedSpecDeduction);
                //ۼר()۳
                BigDecimal accumulatedSpecAttachDeduction = complexIncome.getAccumulatedSpecAttachDeduction();
                incomeDataMap.put("zxfjkchj", accumulatedSpecAttachDeduction);
                //ۼ۳
                BigDecimal accumulatedOtherDeduction = complexIncome.getAccumulatedOtherDeduction();
                incomeDataMap.put("qtckhj", accumulatedOtherDeduction);
                //ۼƼ˰
                BigDecimal accumulatedTaxDeduction = complexIncome.getAccumulatedTaxDeduction();
                incomeDataMap.put("ljjmse", accumulatedTaxDeduction);
                //ۼƼö
                BigDecimal accumulatedDeductionAmount = complexIncome.getAccumulatedDeductionAmount();
                incomeDataMap.put("jcfy", accumulatedDeductionAmount);
                //todo ۼ¼
                BigDecimal accumulatedMonthDeduction = complexIncome.getAccumulatedMonthDeduction();
                //ۼӦ˰ö
                BigDecimal accumulatedTaxableIncome = complexIncome.getAccumulatedTaxableIncome();
                incomeDataMap.put("ljynssde", accumulatedTaxableIncome);
                //ۼӦ˰
                BigDecimal accumulatedPayableAmount = complexIncome.getAccumulatedPayableAmount();
                incomeDataMap.put("ljynse", accumulatedPayableAmount);
                //ۼӦ۽˰ ۼӦ˰ - ۼƼ˰
                BigDecimal accumulatedWithholdingAmount = complexIncome.getAccumulatedWithholdingAmount();
                incomeDataMap.put("ljyingkjse", accumulatedWithholdingAmount);
                //ۼŮ֧
                BigDecimal accumulatedChildEducation = complexIncome.getAccumulatedChildEducation();
                incomeDataMap.put("znjyzc", accumulatedChildEducation);
                //ۼƼ֧
                BigDecimal accumulatedContinueEducation = complexIncome.getAccumulatedContinueEducation();
                incomeDataMap.put("jxjyzc", accumulatedContinueEducation);
                //ۼѧ֧
                BigDecimal accumulatedDegreeContinueEducationLimit = complexIncome.getAccumulatedDegreeContinueEducationLimit();
                incomeDataMap.put("ljxljxjyzc", accumulatedDegreeContinueEducationLimit);
                //ۼƷѧ֧
                BigDecimal accumulatedUnDegreeContinueEducationLimit = complexIncome.getAccumulatedUnDegreeContinueEducationLimit();
                incomeDataMap.put("ljfxljxjyzc", accumulatedUnDegreeContinueEducationLimit);
                //ۼס֧
                BigDecimal accumulatedHouseRent = complexIncome.getAccumulatedHouseRent();
                incomeDataMap.put("zfzjzc", accumulatedHouseRent);
                //ۼƷݴ֧
                BigDecimal accumulatedHouseLoan = complexIncome.getAccumulatedHouseLoan();
                incomeDataMap.put("zfdklxzc", accumulatedHouseLoan);
                //ۼ֧
                BigDecimal accumulatedSupportElder = complexIncome.getAccumulatedSupportElder();
                incomeDataMap.put("sylrzc", accumulatedSupportElder);
                //todo ۼ3Ӥ׶ջ֧
                BigDecimal accumulatedBabyCare = complexIncome.getAccumulatedBabyCare();
                incomeDataMap.put("yyezhfzc", accumulatedBabyCare);
                //ۼ׼۳ľ
                BigDecimal accumulatedDeductibleDonation = complexIncome.getAccumulatedDeductibleDonation();
                incomeDataMap.put("ljzykcdjze", accumulatedDeductibleDonation);
                //ۼƸϽ
                BigDecimal accumulatedPersonalPension = complexIncome.getAccumulatedPersonalPension();
                incomeDataMap.put("grylj", accumulatedPersonalPension);
                //todo ۼƸϽУ
                String accumulatedPersonalPensionCheckCode = complexIncome.getAccumulatedPersonalPensionCheckCode();
                //׼۳ľ
                BigDecimal deductibleDonation = complexIncome.getDeductibleDonation();
                incomeDataMap.put("zykcjze", deductibleDonation);
                //ۼѽ˰
                BigDecimal accumulatedPaidAmount = complexIncome.getAccumulatedPaidAmount();
                //incomeDataMap.put("ykjse", accumulatedPaidAmount);
                //ҵǷ걨
                String etaxDeclaredLastMonth = complexIncome.getEtaxDeclaredLastMonth();
                //Ա˰ۼѿ۽ɵ˰
                BigDecimal etaxAccumulatedPaidAmount = complexIncome.getEtaxAccumulatedPaidAmount();
                //incomeDataMap.put("ykjse", etaxAccumulatedPaidAmount);
                //ۼƿ۳˰
                BigDecimal monthAccumulatedWithholdingAmount = complexIncome.getMonthAccumulatedWithholdingAmount();
                incomeDataMap.put("ykjse", etaxAccumulatedPaidAmount);
                //Ӧ۽˰
                BigDecimal currentWithholdingAmount = complexIncome.getCurrentWithholdingAmount();
                incomeDataMap.put("ykjse", etaxAccumulatedPaidAmount);
                //۳˰
                BigDecimal taxDeductible = complexIncome.getTaxDeductible();
                incomeDataMap.put("yxkcsf", taxDeductible);
                //չҵɱ
                BigDecimal exhibitionCost = complexIncome.getExhibitionCost();
                incomeDataMap.put("zycb", exhibitionCost);
                //¼
                BigDecimal monthDeduction = complexIncome.getMonthDeduction();
                incomeDataMap.put("qzd", monthDeduction);
                //̯
                Integer apportionYears = complexIncome.getApportionYears();
                // ĬΪ60000
                BigDecimal yearDeduction = complexIncome.getYearDeduction();
                //װ²
                for (String key : taxItemInitMap.keySet()) {
                    updateList.add(incomeDataMap.get(key));
                }
                updateList.add(personId);
                updateList.add(taxUnitId);
                updateList.add(periodBegin);
                updateList.add(periodEnd);
                updateList.add(incomeItemId);
                sqlParams.add(updateList.toArray());
                if (!personIds.contains(personId)) {
                    personIds.add(personId);
                }
                if (!incomeitemIds.contains(incomeItemId)) {
                    incomeitemIds.add(incomeItemId);
                }
            }
            try {
                logger.info("updateSql: " + updateSql);
                logger.info("ۺ˰ɹб sqlParams  " + objectMapper.writeValueAsString(sqlParams));
                if (!sqlParams.isEmpty()) {
                    DbUtil.executeBatch(ctx, updateSql.toString(), sqlParams);
                }
            } catch (Exception e) {
                e.printStackTrace();
                throw new BOSException("ۺ˰ɹб³ݱ" + e.getMessage());
            }
            //ɸ˰Ӧ+˰ղϸ
            try {
                logger.info("ۺ˰ɹб personIds  " + objectMapper.writeValueAsString(personIds));
                logger.info("ۺ˰ɹб incomeitemIds  " + objectMapper.writeValueAsString(incomeitemIds));
                if (!personIds.isEmpty() && !incomeitemIds.isEmpty()) {
                    generateOrUpdateTaxCalConfigDetail(ctx, personIds, incomeitemIds);
                }
            } catch (Exception e) {
                e.printStackTrace();
                throw new BOSException("ۺ˰ɹбɸ˰Ӧ+˰ղϸ" + e.getMessage());
            }
        }
    }

    /**
     * ۺ˰ʧнб
     *
     * @param failedComplexIncomes
     */
    private void handleFailedComplexIncome(List<ComplexIncome> failedComplexIncomes) {
        for (int i = 0; failedComplexIncomes != null && i < failedComplexIncomes.size(); i++) {
            ComplexIncome complexIncome = failedComplexIncomes.get(i);
            //
            String name = complexIncome.getName();
            //֤
            String licenseType = complexIncome.getLicenseType();
            //֤
            String licenseNumber = complexIncome.getLicenseNumber();
            //ܹ
            String employedDate = complexIncome.getEmployedDate();
            //ְ
            String resignDate = complexIncome.getResignDate();
            //Ƿϸ걨
            String isDetailedDeclaration = complexIncome.getIsDetailedDeclaration();
            //
            BigDecimal income = complexIncome.getIncome();
            //˰
            BigDecimal exemptIncome = complexIncome.getExemptIncome();
            //ϱ
            BigDecimal endowmentInsurance = complexIncome.getEndowmentInsurance();
            //ҽƱ
            BigDecimal medicalInsurance = complexIncome.getMedicalInsurance();
            //ʧҵ
            BigDecimal unemploymentInsurance = complexIncome.getUnemploymentInsurance();
            //ס
            BigDecimal houseProvidentFund = complexIncome.getHouseProvidentFund();
            //ԭʼס
            //BigDecimal originalHouseProvidentFund = complexIncome.getOriginalHouseProvidentFund();
            //Ů֧
            BigDecimal childEducationExpenditure = complexIncome.getChildEducationExpenditure();
            //֧
            BigDecimal supportElderExpenditure = complexIncome.getSupportElderExpenditure();
            //ס֧
            BigDecimal houseRentExpenditure = complexIncome.getHouseRentExpenditure();
            //ݴ֧
            BigDecimal houseLoanExpenditure = complexIncome.getHouseLoanExpenditure();
            //֧
            BigDecimal continueEducationExpenditure = complexIncome.getContinueEducationExpenditure();
            //ѧ֧
            BigDecimal unDegreeContinueEducationExpenditure = complexIncome.getUnDegreeContinueEducationExpenditure();
            //Ӥ׶ջ֧
            BigDecimal babyCareExpenditure = complexIncome.getBabyCareExpenditure();
            //ҵ/ְҵ
            BigDecimal annuity = complexIncome.getAnnuity();
            //ҵ
            BigDecimal commercialHealthInsurance = complexIncome.getCommercialHealthInsurance();
            //˰ϱ
            BigDecimal extensionEndowmentInsurance = complexIncome.getExtensionEndowmentInsurance();
            //
            BigDecimal other = complexIncome.getOther();
            //˰
            BigDecimal taxDeduction = complexIncome.getTaxDeduction();
            //ע
            String remark = complexIncome.getRemark();
            //
            BigDecimal deductionAmount = complexIncome.getDeductionAmount();
            //۳ϼ
            BigDecimal otherDeductionSum = complexIncome.getOtherDeductionSum();
            //Ӧ˰ö
            BigDecimal taxableIncome = complexIncome.getTaxableIncome();
            //Ӧ˰
            BigDecimal payableAmount = complexIncome.getPayableAmount();
            //ѽ˰
            BigDecimal paidAmount = complexIncome.getPaidAmount();
            //Ӧ۽˰
            BigDecimal withholdingAmount = complexIncome.getWithholdingAmount();
            //˰
            BigDecimal taxRate = complexIncome.getTaxRate();
            //۳
            BigDecimal quickDeduction = complexIncome.getQuickDeduction();
            //Ŀ
            String incomeItemName = complexIncome.getIncomeItemName();
            //Ӧ˰
            BigDecimal refundTax = complexIncome.getRefundTax();
            //ۼ
            BigDecimal accumulatedIncome = complexIncome.getAccumulatedIncome();
            //ۼ˰
            BigDecimal accumulatedExemptIncome = complexIncome.getAccumulatedExemptIncome();
            //ۼר۳
            BigDecimal accumulatedSpecDeduction = complexIncome.getAccumulatedSpecDeduction();
            //ۼר()۳
            BigDecimal accumulatedSpecAttachDeduction = complexIncome.getAccumulatedSpecAttachDeduction();
            //ۼ۳
            BigDecimal accumulatedOtherDeduction = complexIncome.getAccumulatedOtherDeduction();
            //ۼƼ˰
            BigDecimal accumulatedTaxDeduction = complexIncome.getAccumulatedTaxDeduction();
            //ۼƼö
            BigDecimal accumulatedDeductionAmount = complexIncome.getAccumulatedDeductionAmount();
            //ۼ¼
            BigDecimal accumulatedMonthDeduction = complexIncome.getAccumulatedMonthDeduction();
            //ۼӦ˰ö
            BigDecimal accumulatedTaxableIncome = complexIncome.getAccumulatedTaxableIncome();
            //ۼӦ˰
            BigDecimal accumulatedPayableAmount = complexIncome.getAccumulatedPayableAmount();
            //ۼӦ۽˰
            BigDecimal accumulatedWithholdingAmount = complexIncome.getAccumulatedWithholdingAmount();
            //ۼŮ֧
            BigDecimal accumulatedChildEducation = complexIncome.getAccumulatedChildEducation();
            //ۼƼ֧
            BigDecimal accumulatedContinueEducation = complexIncome.getAccumulatedContinueEducation();
            //ۼѧ֧
            BigDecimal accumulatedDegreeContinueEducationLimit = complexIncome.getAccumulatedDegreeContinueEducationLimit();
            //ۼƷѧ֧
            BigDecimal accumulatedUnDegreeContinueEducationLimit = complexIncome.getAccumulatedUnDegreeContinueEducationLimit();
            //ۼס֧
            BigDecimal accumulatedHouseRent = complexIncome.getAccumulatedHouseRent();
            //ۼƷݴ֧
            BigDecimal accumulatedHouseLoan = complexIncome.getAccumulatedHouseLoan();
            //ۼ֧
            BigDecimal accumulatedSupportElder = complexIncome.getAccumulatedSupportElder();
            //ۼ3Ӥ׶ջ֧
            BigDecimal accumulatedBabyCare = complexIncome.getAccumulatedBabyCare();
            //ۼ׼۳ľ
            BigDecimal accumulatedDeductibleDonation = complexIncome.getAccumulatedDeductibleDonation();
            //ۼƸϽ
            BigDecimal accumulatedPersonalPension = complexIncome.getAccumulatedPersonalPension();
            //ۼƸϽУ
            String accumulatedPersonalPensionCheckCode = complexIncome.getAccumulatedPersonalPensionCheckCode();
            //׼۳ľ
            BigDecimal deductibleDonation = complexIncome.getDeductibleDonation();
            //ۼѽ˰
            BigDecimal accumulatedPaidAmount = complexIncome.getAccumulatedPaidAmount();
            //ҵǷ걨:
            String etaxDeclaredLastMonth = complexIncome.getEtaxDeclaredLastMonth();
            //Ա˰ۼѿ۽ɵ˰
            BigDecimal etaxAccumulatedPaidAmount = complexIncome.getEtaxAccumulatedPaidAmount();
            //ۼƿ۳˰
            BigDecimal monthAccumulatedWithholdingAmount = complexIncome.getMonthAccumulatedWithholdingAmount();
            //Ӧ۽˰
            BigDecimal currentWithholdingAmount = complexIncome.getCurrentWithholdingAmount();
            //۳˰
            BigDecimal taxDeductible = complexIncome.getTaxDeductible();
            //չҵɱ
            BigDecimal exhibitionCost = complexIncome.getExhibitionCost();
            //¼
            BigDecimal monthDeduction = complexIncome.getMonthDeduction();
            //̯
            Integer apportionYears = complexIncome.getApportionYears();
            // ĬΪ60000
            BigDecimal yearDeduction = complexIncome.getYearDeduction();
        }
    }

    /**
     * ʧ˰ԭб
     *
     * @param failedCheckTaxCalResult
     */
    private void handleFailedCheckTaxCalResult(
            Context ctx,
            List<CheckTaxCalResult> failedCheckTaxCalResult)
            throws BOSException, JsonProcessingException {
        logger.info("handleFailedCheckTaxCalResult" + objectMapper.writeValueAsString(failedCheckTaxCalResult));
        if (failedCheckTaxCalResult != null) {
            String updateSql = "/*dialect*/update T_HR_STaxCalInitDetail set FERRORINFO = ?,FSTATE = '50' " +
                    "where fpersonId = ? " +
                    "and FTAXUNITID=? and to_char(FPERIODBEGIN,'yyyy-mm-dd') >= ? and to_char(FPERIODEND,'yyyy-mm-dd') <= ? and FINCOMEITEMID=? and FSTATE =30";
            List<Object[]> udpateParameter = new ArrayList<>();
            for (int i = 0; failedCheckTaxCalResult != null && i < failedCheckTaxCalResult.size(); i++) {
                List list = new ArrayList();
                CheckTaxCalResult checkTaxCalResult = failedCheckTaxCalResult.get(i);
                //֤
                String licenseType = checkTaxCalResult.getLicenseType();
                //String cardTypeValue = cardTypeEnumMap.get(licenseType);
                //֤
                String licenseNumber = checkTaxCalResult.getLicenseNumber();
                //Աid
                String personId = taxPersonRecordMap.get(licenseNumber + licenseType);
                if (StringUtils.isEmpty(personId)) {
                    logger.error("δƥ䵽Ա ֤: " + licenseNumber + " ֤: " + licenseType);
                    continue;
                }
                //Աid
                Long employeeId = checkTaxCalResult.getEmployeeId();
                //Ա
                String employeeName = checkTaxCalResult.getEmployeeName();
                //
                String errorCode = checkTaxCalResult.getErrorCode();
                //Ϣ
                String errorMessage = checkTaxCalResult.getErrorMessage();
                //˰code
                String incomeItemCode = checkTaxCalResult.getIncomeItemCode();
                //˰name
                String incomeItemName = checkTaxCalResult.getIncomeItemName();
                if (!incomeItemMap.containsKey(incomeItemName)) {
                    logger.error("δƥ䵽Ŀ Ϊ: " + incomeItemName);
                    continue;
                }
                String incomeItemId = incomeItemMap.get(incomeItemName);
                list.add(errorMessage);
                list.add(personId);
                list.add(taxUnitId);
                list.add(periodBegin);
                list.add(periodEnd);
                list.add(incomeItemId);
                udpateParameter.add(list.toArray());
            }
            try {
                logger.error("ʧ˰ԭб  updateSql  " + updateSql);
                logger.error("ʧ˰ԭб udpateParameter  " + objectMapper.writeValueAsString(udpateParameter));
                if (!udpateParameter.isEmpty()) {
                    DbUtil.executeBatch(ctx, updateSql, udpateParameter);
                }
            } catch (BOSException e) {
                e.printStackTrace();
                throw new BOSException("´ʧ˰ԭб: " + e.getMessage());
            }
        }
    }

    /**
     * ɸ˰Ӧ+˰ղϸ
     * ٸ
     */
    private void generateOrUpdateTaxCalConfigDetail(Context ctx,
                                                    Set<String> personIds,
                                                    Set<String> incomeitemIds) throws BOSException, SQLException, ParseException, JsonProcessingException {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        Date periodBeginDate = sdf.parse(periodBegin);
        Date periodEndDate = sdf.parse(periodEnd);
        //Ȳɹĳ(Ա˰λidڡĿ״̬=ɹ)
        ITaxCalConfigDetail iTaxCalConfigDetail = TaxCalConfigDetailFactory.getLocalInstance(ctx);
        StringBuilder querySql = new StringBuilder();
        querySql.append("SELECT fid,fpersonId,fincomeitemid,FCALSCHEMEID,FCMPCALTABLEID,FTAXUNITID from T_HR_STaxCalInitDetail where").append("\n");
        querySql.append("   fpersonId in(").append(AtsUtil.convertSetToString(personIds)).append(")").append("\n");
        querySql.append("   and to_char(FPERIODBEGIN, 'yyyy-mm-dd') >= '").append(periodBegin).append("'").append("\n");
        querySql.append("   and to_char(FPERIODEND, 'yyyy-mm-dd') <= '").append(periodEnd).append("'").append("\n");
        querySql.append("   and FINCOMEITEMID in(").append(AtsUtil.convertSetToString(incomeitemIds)).append(")").append("\n");
        querySql.append("   and FTAXUNITID = '").append(taxUnitId).append("'").append("\n");
        querySql.append("   and FSTATE = '40'").append("\n");
        logger.info("generateOrUpdateTaxCalConfigDetail.sql: " + querySql);
        IRowSet iRowSet = DbUtil.executeQuery(ctx, querySql.toString());
        List<Map<String, String>> list = new ArrayList<>();
        while (iRowSet.next()) {
            Map<String, String> map = new HashMap<>();
            map.put("initId", iRowSet.getString("fid"));
            map.put("personId", iRowSet.getString("fpersonId"));
            map.put("incomeitemid", iRowSet.getString("FINCOMEITEMID"));
            map.put("calSchemeId", iRowSet.getString("FCALSCHEMEID"));
            map.put("cmpCalTableId", iRowSet.getString("FCMPCALTABLEID"));
            map.put("taxUnitId", iRowSet.getString("FTAXUNITID"));
            list.add(map);
        }
        //óϸ(ҪжϸǷѾɹ)
        Set<String> initIds = new HashSet<>();
        Set<String> configIds = new HashSet<>();
        for (int i = 0; i < list.size(); i++) {
            try {
                String detailId = null;
                Map<String, String> map = list.get(i);
                String initId = map.get("initId");//id
                String personId = map.get("personId");
                String taxUnitId = map.get("taxUnitId");
                String incomeitemid = map.get("incomeitemid");
                String calSchemeId = map.get("calSchemeId");
                String cmpCalTableId = map.get("cmpCalTableId");
                FilterInfo filterInfo = new FilterInfo();
                FilterItemCollection filterItems = filterInfo.getFilterItems();
                filterItems.add(new FilterItemInfo("person", personId));
                filterItems.add(new FilterItemInfo("taxUnit", taxUnitId));
                filterItems.add(new FilterItemInfo("periodBegin", periodBeginDate, CompareType.GREATER_EQUALS));
                filterItems.add(new FilterItemInfo("periodEnd", periodEndDate, CompareType.LESS_EQUALS));
                filterItems.add(new FilterItemInfo("incomeItem", incomeitemid));
                filterItems.add(new FilterItemInfo("calScheme", calSchemeId));
                filterItems.add(new FilterItemInfo("cmpCalTable", cmpCalTableId));
                SelectorItemCollection sic = new SelectorItemCollection();
                sic.add("state");
                EntityViewInfo instance = EntityViewInfo.getInstance(filterInfo, sic, null);
                logger.info("instance: " + instance.toString());
                TaxCalConfigDetailCollection taxCalConfigDetailCol = iTaxCalConfigDetail.getTaxCalConfigDetailCollection(instance);
                if (taxCalConfigDetailCol.size() > 0) {
                    TaxCalConfigDetailInfo taxCalConfigDetailInfo = taxCalConfigDetailCol.get(0);
                    if (TaxResultStateEnum.UN_CONFIRM.equals(taxCalConfigDetailInfo.getState())) {
                        //δȷ,
                        detailId = taxCalConfigDetailInfo.getId().toString();
                        configIds.add(detailId);
                    } else {
                        //ȷ,ܸ
                        logger.error("ϸ  ȷ,ܸ");
                        continue;
                    }
                } else {
                    //ûҵϸݣ
                    //˰Ӧ+˰ղϸ
                    TaxCalConfigDetailInfo taxCalConfigDetailInfo = new TaxCalConfigDetailInfo();
                    //
                    taxCalConfigDetailInfo.put("calScheme", map.get("calSchemeId"));
                    //id
                    taxCalConfigDetailInfo.put("cmpCalTable", map.get("cmpCalTableId"));
                    //״̬
                    taxCalConfigDetailInfo.setState(TaxResultStateEnum.UN_CONFIRM);
                    //id
                    //taxCalConfigDetailInfo.setRelay();
                    //Ƿһ
                    taxCalConfigDetailInfo.setIsLast(true);
                    //Ƿɸ˰걨
                    taxCalConfigDetailInfo.setIsGenerateTaxDeclare(false);
                    //걨κ
                    //taxCalConfigDetailInfo.setBatchNo();
                    //Ա
                    taxCalConfigDetailInfo.put("person", map.get("personId"));
                    //˰λ
                    taxCalConfigDetailInfo.put("taxUnit", map.get("taxUnitId"));
                    //˰ڼ
                    taxCalConfigDetailInfo.setPeriodBegin(periodBeginDate);
                    //˰ڼֹ
                    taxCalConfigDetailInfo.setPeriodEnd(periodEndDate);
                    //Ŀ
                    taxCalConfigDetailInfo.put("incomeItem", map.get("incomeitemid"));
                    detailId = iTaxCalConfigDetail.addnew(taxCalConfigDetailInfo).toString();
                    configIds.add(detailId);
                }
                initIds.add(initId);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        logger.info("configIds: " + objectMapper.writeValueAsString(configIds));
        logger.info("initIds " + objectMapper.writeValueAsString(initIds));
        if (!configIds.isEmpty() && !initIds.isEmpty()) {
            //ϸ
            StringBuilder updateSql = new StringBuilder();
            StringBuilder querySqlForUpdate = new StringBuilder();
            updateSql.append("update T_HR_STaxCalConfigDetail config set (").append("\n");
            for (String key : taxItemConfigMap.keySet()) {
                updateSql.append(taxItemConfigMap.get(key)).append(",").append("\n");
                querySqlForUpdate.append(taxItemConfigMap.get(key)).append(",").append("\n");
            }
            updateSql.deleteCharAt(updateSql.lastIndexOf(","));
            querySqlForUpdate.deleteCharAt(querySqlForUpdate.lastIndexOf(","));
            updateSql.append(") = (select ").append(querySqlForUpdate).append("\n");
            updateSql.append(" from T_HR_STaxCalInitDetail ").append("\n");
            updateSql.append(" where fid in (").append(AtsUtil.convertSetToString(initIds)).append(")").append("\n");
            updateSql.append("      and config.fpersonId = fpersonId").append("\n");
            updateSql.append("      and config.fCmpCalTableId = fCmpCalTableId").append("\n");
            updateSql.append("      and config.fIncomeItemId = fIncomeItemId").append("\n");
            updateSql.append("      and config.FPERIODBEGIN = FPERIODBEGIN").append("\n");
            updateSql.append("      and config.FPERIODEND = FPERIODEND)").append("\n");
            updateSql.append(" where config.fstate = '10'").append("\n");
            updateSql.append("  and config.fid in(").append(AtsUtil.convertSetToString(configIds)).append(")").append("\n");
            logger.info("ϸsql: " + updateSql);
            DbUtil.execute(ctx, updateSql.toString());
        }
    }

    /**
     * ȡ֤map
     *
     * @return
     */
//    private static Map<String, String> getCardTypeEnumMap() {
//        Map<String, String> cardTypeEnumMap = new HashMap<>();
//        List<Map<String, String>> enumList = CardTypeEnum.getEnumList();
//        for (int i = 0; i < enumList.size(); i++) {
//            CardTypeEnum cardTypeEnum = (CardTypeEnum) enumList.get(i);
//            String value = cardTypeEnum.getValue();
//            String alias = cardTypeEnum.getAlias();
//            cardTypeEnumMap.put(alias, value);
//        }
//        return cardTypeEnumMap;
//    }

    /**
     * ȡĿ
     *
     * @param ctx
     * @return
     * @throws BOSException
     */
    private Map<String, String> getIncomeItemMap(Context ctx) throws BOSException {
        Map<String, String> incomeItemMap = new HashMap<>();
        try {
            TaxIncomeItemCollection taxIncomeItemCollection = TaxIncomeItemFactory.getLocalInstance(ctx).getTaxIncomeItemCollection("where state = 1");
            for (int i = 0; i < taxIncomeItemCollection.size(); i++) {
                TaxIncomeItemInfo taxIncomeItemInfo = taxIncomeItemCollection.get(i);
                String taxIncomeItemId = taxIncomeItemInfo.getId().toString();
                String name = taxIncomeItemInfo.getName();
                incomeItemMap.put(name, taxIncomeItemId);
            }
            return incomeItemMap;
        } catch (BOSException e) {
            e.printStackTrace();
            throw new BOSException("ȡĿݱ: " + e.getMessage());
        }
    }

    /**
     * ȡԱϢ
     *
     * @param ctx
     * @throws BOSException
     */
    private void getTaxPersonRecordMap(Context ctx) throws BOSException {
        if (taxPersonRecordMap == null) {
            taxPersonRecordMap = new HashMap<>();
        }
        String oql = "select bill.person.id,bill.cardType,bill.cardNumber";
        TaxPersonRecordEntryCollection taxPersonRecordEntryCollection =
                TaxPersonRecordEntryFactory.getLocalInstance(ctx).getTaxPersonRecordEntryCollection(oql);
        for (int i = 0; i < taxPersonRecordEntryCollection.size(); i++) {
            TaxPersonRecordInfo taxPersonRecordInfo = taxPersonRecordEntryCollection.get(i).getBill();
            if (taxPersonRecordInfo != null) {
                String personId = taxPersonRecordInfo.getPerson().getId().toString();
                CardTypeEnum cardType = taxPersonRecordInfo.getCardType();
                if (cardType == null) {
                    logger.error("ȡԱϢ Աid[" + personId + "] ֤Ϊ!");
                    continue;
                }
                String cardTypeName = cardType.getAlias();
                String cardNumber = taxPersonRecordInfo.getCardNumber();
                taxPersonRecordMap.put(cardNumber + cardTypeName, personId);
            }
        }
    }

    /**
     * ȡ˰Ŀ
     *
     * @param ctx
     * @return
     * @throws BOSException
     */
    private void getTaxItemMap(Context ctx) throws BOSException {
        if (taxItemInitMap == null) {
            taxItemInitMap = new HashMap<>();
        }
        if (taxItemConfigMap == null) {
            taxItemConfigMap = new HashMap<>();
        }
        //ȡи˰Ŀ
        Set initSet = new HashSet();
        initSet.add("jmse");//˰
        initSet.add("qzd");//
        initSet.add("ynssde");//Ӧ˰ö
        initSet.add("sl");//˰
        initSet.add("sskcs");//۳
        initSet.add("bqybtse");//Ӧ˰
        initSet.add("bqljsre");//ۼ
        initSet.add("bqljmssr");///ۼ˰
        initSet.add("zxkchj");//ۼר۳
        initSet.add("zxfjkchj");//ۼר()۳
        initSet.add("qtckhj");//ۼ۳
        initSet.add("ljjmse");//ۼƼ˰
        initSet.add("jcfy");//ۼƼö
        initSet.add("ljynssde");//ۼӦ˰ö
        initSet.add("ljynse");//ۼӦ˰
        initSet.add("ljyingkjse");//ۼӦ۽˰
        initSet.add("znjyzc");//ۼŮ֧
        initSet.add("jxjyzc");//ۼƼ֧
        initSet.add("ljxljxjyzc");//ۼѧ֧
        initSet.add("ljfxljxjyzc");//ۼƷѧ֧
        initSet.add("zfzjzc");//ۼס֧
        initSet.add("zfdklxzc");//ۼƷݴ֧
        initSet.add("sylrzc");//ۼ֧
        initSet.add("ljzykcdjze");//ۼ׼۳ľ
        initSet.add("grylj"); //ۼƸϽ
        initSet.add("zykcjze");//׼۳ľ
        initSet.add("ykjse");//ۼƿ۳˰
        initSet.add("yxkcsf");//۳˰
        initSet.add("zycb");//չҵɱ
        initSet.add("qzd");//¼
        //ղϸ˰Ŀ
        Set configSet = new HashSet();
        configSet.add("sre");//
        configSet.add("mssd");// ˰
        configSet.add("jbylaobxf");//  ϱշ
        configSet.add("jbylbxf");//  ҽƱշ
        configSet.add("sybxf");//  ʧҵշ
        configSet.add("zfgjj");//  ס
        configSet.add("znjyzc");//  ۼŮ
        configSet.add("jxjyzc");//  ۼƼ
        configSet.add("zfdklxzc");//  ۼסϢ");
        configSet.add("zfzjzc");//  ۼס");
        configSet.add("nj");//  ҵְҵ");
        configSet.add("syjkbx");//  ҵ");
        configSet.add("syylbx");//  ˰ϱ");
        configSet.add("qt");//  ");
        configSet.add("zykcjze");//  ׼۳ľ");
        configSet.add("jmse");//  ˰");
        configSet.add("yxkcsf");//  ۳˰");
        configSet.add("ljsre");//  ۼ");
        configSet.add("bqljsre");//  ۼ");
        configSet.add("ljmssd");//  ۼ˰");
        configSet.add("bqljmssr");//  ۼ˰");
        configSet.add("qzd");//  ");
        configSet.add("jcfy");//  ۼƼ");
        configSet.add("fy");//  ڷ");
        configSet.add("zxkchj");//  ۼר۳");
        configSet.add("zxfjkchj");//  ۼרӿ۳ϼ");
        configSet.add("qtckhj");//  ۼ۳");
        configSet.add("ljzykcdjze");//  ۼ׼۳ľ
        configSet.add("ljynssde");//  ۼӦ˰ö
        configSet.add("sl");//  ˰
        configSet.add("sskcs");//  ۳
        configSet.add("ljynse");//  ۼӦ˰
        configSet.add("ljjmse");//  ۼƼ˰
        configSet.add("ljyingkjse");//  ۼӦ۽˰
        configSet.add("ykjse");//  ۼԤ˰
        configSet.add("ybtse");//  ۼӦˣ˰
        configSet.add("ycxbc");//  һԲ
        configSet.add("zycb");//  չҵɱ
        configSet.add("bz");//  ע
        configSet.add("ccyz");//  Ʋԭֵ
        configSet.add("jsbl");//  ˰
        configSet.add("ynssde");//  Ӧ˰ö
        configSet.add("bqybtse");//  Ӧˣ˰
        configSet.add("sylrzc");//  ۼ
        configSet.add("yyezhfzc");//  ۼӤ׶ջ
        configSet.add("grylj");//  ۼƸϽ
        configSet.add("ljfxljxjyzc");//  ۼƷѧ֧
        configSet.add("ljxljxjyzc");//  ۼѧ֧
        configSet.add("dyznjyzc");//  Ů֧
        configSet.add("dysylrzc");//  ֧
        configSet.add("dyfwdkzc");//  סϢ֧
        configSet.add("dyzfzjzc");//  ס֧
        configSet.add("dyjxjyzc");//  ֧
        configSet.add("dyfxljxjyzc");//ѧ֧
        configSet.add("dyyyrzhzc");//  Ӥ׶ջ֧
        try {
            TaxItemCollection itemColl = TaxItemFactory.getLocalInstance(ctx)
                    .getTaxItemCollection("where state = 1");
            for (int i = 0; i < itemColl.size(); ++i) {
                TaxItemInfo info = itemColl.get(i);
                String number = info.getNumber();
                if (initSet.contains(number)) {
                    taxItemInitMap.put(number, "T" + info.getFieldSn());
                }
                if (configSet.contains(number)) {
                    taxItemConfigMap.put(number, "T" + info.getFieldSn());
                }
            }
        } catch (BOSException var5) {
            var5.printStackTrace();
            throw new BOSException("ȡ˰Ŀ: " + var5.getMessage());
        }
    }
}
